/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('AppCtrl', MainController);

  function MainController($scope, $rootScope, warningForm
    , $httpFactory, $state, $ionicPopup, $cordovaAppVersion, localStorageService, $ionicLoading, $ionicViewSwitcher, LoginFactory, AppFactory, $timeout, RouteData, $ionicSideMenuDelegate, PaymentFactory) {

    {
      $rootScope.videoDownloadList = [];    //初始化缓存视频下载列表

      if (window.cordova && cordova.InAppBrowser) {
        window.open = cordova.InAppBrowser.open;
      }

      !$scope.login && LoginFactory.initLoginModal($rootScope);// 欢迎页中已初始化

      $scope.dialog_aat = dialog_aat;

      onLoaded();
      checkWebViewCache();// 检查Webview缓存是否需要更新
      loadVersion();// 获取软件版本号

      console.timeEnd("2.AppCtrl");
      // console.log((Date.now() - times) / 1000 + 's', 'AppCtrl ☆') , times = Date.now();
      console.time("3.AppCtrl onLoad");

      $scope.shareFlash = false;
      checkInstall();
    }

    function checkInstall() {
      $rootScope.hasQQ = $rootScope.hasWechat = $rootScope.hasTIM = 1;
      if (_app.isWeb) {
        return;
      }
      window.share.qq.installed().then(function (installed) {
        $rootScope.hasQQ = installed;
      }, function (res) {
        $rootScope.hasQQ = 0;
        window.share.tim.installed().then(function (installed) {
          $rootScope.hasTIM = installed;
        }, function (res) {
          $rootScope.hasTIM = 0;
        });
      });
      window.share.wechat.installed().then(function (installed) {
        $rootScope.hasWechat = installed;
      }, function (res) {
        $rootScope.hasWechat = 0;
      });
    }

    function toMall() {
      $state.go('app.mall');
      $ionicSideMenuDelegate.toggleLeft();
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.timeEnd("3.AppCtrl onLoad");
        console.timeEnd('[1+2+3]App page load');
        console.log((Date.now() - times) / 1000 + 's', 'App page load ★') , times = Date.now();
        console.timeEnd('App load');
      });
    }

    /**
     * 检查Webview缓存是否需要更新
     */
    function checkWebViewCache() {
      var webViewCacheVersionClient = localStorageService.get('webViewCacheVersionClient');
      !webViewCacheVersionClient && localStorageService.set('webViewCacheVersionClient', +new Date());// 初始化WebView缓存的数据时间

      $httpFactory.getSysConfig_1801('webViewCache-Version').then(function (res) {
        if (res.data && res.data.object && res.data.object.list.length > 0) {
          var webViewCacheVersionServer = res.data.object.list[0].value;
          if (webViewCacheVersionServer > webViewCacheVersionClient) {
            var iab = window.open();
            iab && iab.clearAllCache && iab.clearAllCache();
            localStorageService.set('webViewCacheVersionClient', +new Date());// 刷新本地WebView缓存的数据时间
          }
        }
      });
    }

    /**
     * 检查ios是否打开支付选择
     */
    function checkIos_isPayChoose() {
      // 同关于中版本号
      !_app.isWeb && $cordovaAppVersion.getVersionNumber().then(function (version) {
        $httpFactory.getSysConfig_1801('ios_isPayChoose[' + version + ']').then(function (res) {
          if (res.data && res.data.object) {
            $rootScope.ios_isPayChoose = res.data.object.list[0].value.match('true') ? true : false;// 是否启用支付选择
            localStorageService.set('ios_isPayChoose', res.data.object.list[0].value);
            //隐藏iOS 开关页面
            _app.isIos ? ($scope.specialOpen = $rootScope.ios_isPayChoose) : ($scope.specialOpen = true);
            if (!$scope.specialOpen) {
              $('button[ui-sref="app.table.special"]').css('display', 'none');
              $('button[ui-sref="app.table.live"]').css('display', 'none');
            }
          }
        });
      });
    }

    function loadVersion() {
      !_app.isWeb && $cordovaAppVersion.getVersionNumber().then(function (version) {
        _app.curVersion = version;
      });
    }

    function toUserInfo() {
      $state.go('app.userInfo');
    }

    function toShop() {
      warningForm(null, '暂未开放');
    }

    function gotoSetting() {
      $state.go('app.setting');
    }

    //选择教材
    function chooseBook() {
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'chooseBook',
        templateUrl: 'app/app/chooseBook.html',
        scope: $scope
      });
    }

    /** 软件推荐 */
    function checkRecommendOpen() {
      $scope.recommendOpen = true;
      if (!_app.isIos) {
        return;
      }
      $cordovaAppVersion && $cordovaAppVersion.getVersionNumber().then(function (version) {
        $httpFactory.sys.config('version' + version).then(function (res) {
          if (res.data.result == 0) {
            res.data.object[0].value == 'true' ? $scope.recommendOpen = true : $scope.recommendOpen = false;
          }
        });
      });
    }

    function recommend() {
      if ($scope.redInfo && $scope.redInfo.newRecommend) {
        var data = {
          content: JSON.stringify({
            newRecommend: false
          })
        };
        updateRedInfo(data);
      }
      ;
      $state.go('app.recommend_list');
    }

    /*帮助反馈*/
    function feedback() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      if ($scope.redInfo && $scope.redInfo.newFeedback) {
        var data = {
          content: JSON.stringify({
            newFeedback: false
          })
        };
        updateRedInfo(data);
        $state.go('app.feedback_list');
      } else {
        $state.go('app.feedback');
      }
      my.log("帮助反馈");
    }

    /*评价*/
    function evaluate() {
      $state.go('app.evaluate');
    }

    /*关于赛学霸物理*/
    function about() {
      my.log("关于赛学霸物理");
      $state.go('app.about');
    }

    function toBook(bookVersion) {
      // window.localStorage.setItem("bookVersion", bookVersion);
      localStorageService.set("bookVersion", bookVersion);
      $scope.myPopup.close();
      //$state.go('app.home');
    }

    /**
     * 分享软件
     */
    function shareApp() {
      // 未登陆
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }

      if ($scope.share) {
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/app/shareApp.html',
          scope: $scope
        });
        return;
      }

      $httpFactory.sys.config('shareApp').then(function (response) {
        shareApp_handle(response);
      })

      /* 闪烁三下分享软件 */
      function flashShareApp() {
        $scope.shareFlash = true;
        $timeout(function () {
          $scope.shareFlash = false;
        }, 2000);
      }
    }

    function invitingPopups() {
      // 未登陆
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      $scope.myPopupInvited = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/invitingPopups/invitingPopups.html',
        scope: $scope
      });
    }

    function closeAll() {
      if ($scope.myPopupInvitedSend) {
        $scope.myPopupInvitedSend.close();
      }
      if ($scope.myPopupInvited) {
        $scope.myPopupInvited.close();
      }
    }

    function invitingSend() {
      $scope.closeInvite = false;
      $scope.closeAll = closeAll;
      if ($scope.inviting_share) {
        $scope.myPopupInvitedSend = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/invitingPopups/invitingSend/invitingSend.html',
          scope: $scope
        });
        return;
      }
      $httpFactory.sys.config('shareApp').then(function (response) {
        inviting_handle(response);
      });
      function inviting_handle(response) {
        $scope.inviting_share = JSON.parse(response.data.object[0].value);
        $scope.inviting_share.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
        $scope.inviting_share.params.title = $scope.inviting_share.params.title.replace('{{inviteCode}}', $scope.inviting_share.inviteCode);
        $scope.inviting_share.params.description = $scope.inviting_share.params.description.replace('{{inviteCode}}', $scope.inviting_share.inviteCode);
        // $scope.share.remark = $scope.share.remark.replace('{{inviteCode}}',$scope.share.inviteCode);

        for (var i in $scope.inviting_share.items) {
          inviting_isInstall($scope.inviting_share.items[i]);
        }

        setTimeout(function () {
          $scope.$apply();
        }, 500);// 脏检查

        $scope.inviting_Share = inviting_Share;// 分享
        $scope.myPopupInvitedSend = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/invitingPopups/invitingSend/invitingSend.html',
          scope: $scope
        });
        function inviting_isInstall(item) {
          if (_app.isWeb) {
            item.isInstall = 1;
            return;
          }
          $scope.isInstall_qq().then(success, fail);
          function success(response) {
            item.isInstall = response;
            // $scope.$apply();
          }

          function fail(failResponse) {
            console.log(failResponse);
            // $scope.$apply();
          }
        }

        function inviting_Share(params) {
          $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        }

        function success(response) {
          $scope.closeInvite = true;
          console.log('分享成功', response);
        }

        function fail(failResponse) {
          $scope.closeInvite = false;
          console.log('分享失败', failResponse);
        }
      }
    }

    function dialog_aat() {
      $scope.aat = window.aat;
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/dialog_aat.html',
        scope: $scope
      });

      $scope.aat_action = function (item) {
        item.action();
      }
    }

    //填写邀请码
    function bindInviteCode() {
      // 一个精心制作的自定义弹窗
      if (!appv.currentUser && !appv.token) {
        $state.go('app.loginBefore');
        return;
      }
      if ($scope.userInfo.friendInviteCode) {
        $scope.invite.code = $scope.userInfo.friendInviteCode;
      }
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/invite.html',
        scope: $scope
      });
    }

    function save() {
      if ($scope.userInfo.friendInviteCode) {
        $scope.myPopup.close();
        return;
      } else if (!$scope.invite.code || $scope.invite.code.length <= 0) {
        $ionicLoading.show({template: '请输入正确的邀请码'})
      }

      else {
        $httpFactory.activity.bindInvite($scope.invite.code).then(function (res) {
          if (res.data.result == 0) {
            //appv.currentUser.friendInviteCode = $scope.invite.code;
            $scope.userInfo.friendInviteCode = $scope.invite.code;
            $ionicLoading.show({template: res.data.message, duration: 2000});
            $scope.myPopup.close();
          } else {
            $ionicLoading.show({template: res.data.message, duration: 2000});
          }
        });
      }
    }

    function updateRedInfo(data) {
      $httpFactory.user.redInfoRead(data).then(function (res) {
        if (res.data.result == 0) {
          $scope.redInfo = res.data.object;
        }
        else {
          console.log(res.data.message);
        }
      })
    }

    //活动中心
    function toActivity() {
      if ($scope.redInfo && $scope.redInfo.newActity) {
        var data = {
          content: JSON.stringify({
            newActity: false
          })
        };
        updateRedInfo(data);
      }
      ;
      $state.go('app.activity');
    }

    //一键加群
    function joinQQGroup() {
      var key = 'joinQQGroup';
      $httpFactory.getSysConfig_1801(key).then(function (res) {
        if (res.data.result == 0) {
          var joinQQGroupJson = JSON.parse(res.data.object.list[0].value)
          if (_app.isAndroid) {
            JoinQQGroup.open({key: joinQQGroupJson.android.key});
          } else if (_app.isIos) {
            JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
          }
        }
      });
    }

    function payUser() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      if (appv.currentUser.isPayUser != 1) {
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/app/payUser.html',
          scope: $scope
        });
        //$ionicLoading.show({template:'<div><button ng-click="loadingHide()"></button><img src="../../img/icon.png"></div>',duration:''});
        return;
      }
      joinQQGroup();
    }

    //我的消息
    function toMessage() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      if ($scope.redInfo && $scope.redInfo.newMessage) {
        var data = {
          content: JSON.stringify({
            newMessage: false
          })
        };
        updateRedInfo(data);
      }
      $state.go('app.message');
      $ionicViewSwitcher.nextDirection("forward")
    }

    //财富榜
    function toRichList() {
      RouteData.wsScope = {
        appScope: $scope
      };
      $httpFactory.user.information().then(function (response) {
        $rootScope.bookGold && ($rootScope.bookGold.blance = response.data.object.blance);// 更新全局金币($rootScope)
        appv.bookGold && (appv.bookGold.blance = response.data.object.blance);// 更新全局金币(appv)

        // 更新x中金币(bookGoldLocal)
        var bookGoldLocal = localStorageService.get('bookGold');
        if (bookGoldLocal) {
          bookGoldLocal.blance = response.data.object.blance;
          localStorageService.set('bookGold', bookGoldLocal)
        }
      });

      $state.go('app.rich');
    }

    //赚金币模块
    function earnGold() {
      RouteData.wsScope = {
        appScope: $scope
      };
      $state.go('app.earnGold');
    }


    function clearAllCache() {
      var iab = window.open();
      iab.clearAllCache && iab.clearAllCache();
    }

    /**
     * 进入充值页面
     * */
    function gotoRecharge() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      $scope.data = {};
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/recharge.html',
        scope: $scope
      });
      // $ionicSideMenuDelegate.toggleLeft();
    }

    //金币充值
    function loadDb() {
      var numArr = ['60', '160', '320', '700'];
      var priceArr = ['12', '30', '60', '118'];
      //var productIdArr = ['recharge_gold6', 'recharge_gold18', 'recharge_gold98', 'recharge_gold208'];
      var productIdArr = ['Com.saixueba.physics.60', 'Com.saixueba.physics.160jinbi', 'Com.saixueba.physics.320', 'Com.saixueba.physics.700'];
      var list = [];
      for (var i = 0; i < numArr.length; i++) {
        var product = {};
        product.num = numArr[i];
        product.price = priceArr[i];
        product.productId = productIdArr[i];
        list.push(product);
      }
      $scope.list = list;
    }

    function toRecharge() {
      var prod = $scope.data.prod;
      if (!prod) {
        $ionicLoading.show({template: '请选择充值金额...'});
        return;
      }
      console.log("product's id is " + prod.productId);
      window.iap.purchaseProduct(prod.productId, function (result) {
        console.log("支付成功");
        $httpFactory.section.order_gold_recharge({productCode: prod.productId}).then(success, function () {
          // 支付失败,提示联系管理员
          $scope.message = "金币充值失败,请通过用户反馈联系管理员";
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/main/masterVideo/pay_prompt2.html',
            scope: $scope
          });
        });

        function success(response) {
          if (response.data.result == 0) {
            $scope.message = "金币充值成功";
            $scope.myPopup.close();
          } else {
            $scope.message = response.data.message + "金币充值失败,请通过用户反馈联系管理员";
          }
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/main/masterVideo/pay_prompt2.html',
            scope: $scope
          });
        }
      }, function (result, p2, p3) {
        console.log("支付失败");
        //$scope.message = "支付失败:" + result;
        //$scope.myPopup = $ionicPopup.show({
        //  cssClass: 'myPopup',
        //  templateUrl: 'app/main/masterVideo/pay_prompt2.html',
        //  scope: $scope
        //});
      })
    }


  }
})();
