/**
 * Created by Administrator on 2017/2/13 0013.
 */
(function(){
  'use strict';

  angular
    .module('starter')
    .controller('ArticleCtrl',MainCtrl);

  function MainCtrl(RouteData,$httpFactory,$scope,$state,$ionicHistory,$ionicScrollDelegate,$timeout,$interval,$ionicLoading,$rootScope){
    {
      $scope.getComment = getComment;       //获取评论
      $scope.commentList = [];
      var type = RouteData.article.type;
      var code = RouteData.article.code;
      var pageSize = 5;
      var currentPage = 1;
      $scope.hasNextPage = true;
      _app.isIos && ($scope.pageStyle = {
        padding: '20px 0 0 0',
        height: '64px',
        'line-height': '44px',
      })
      $scope.navBack =  navBack;
      $scope.scrollToShare = scrollToShare;
      $scope.scrollToComment = scrollToComment;
      initArticle();                      //获取文章详情
      var shareHeight;
      var commentHeight;
      var screenHeight = window.screen.height;
      $scope.$on('$ionicView.afterEnter', function() {
        $timeout(function(){
          shareHeight = $('.share_div').offset().top;
          commentHeight = $('.comment_div').offset().top;
        },1000);
      }, false);
      $scope.changeStatus = changeStatus;       //赞-取消赞
      $scope.upCommentModal = upCommentModal;   //打开评论弹窗
      $scope.close = close;         //关闭评论弹窗
      $scope.upload = upload;       //上传评论
      $scope.share = share;         //分享
      getShareInfo();                                     //获取分享的信息
      $rootScope.reload_article = reload_article;         //刷新重载页面

      window.addEventListener('native.keyboardshow', keyboardShowHandler);        //软件盘显示监听
      window.addEventListener('native.keyboardhide', close);        //软键盘隐藏监听
    }

    function reload_article(){
      getComment();       //评论
      initArticle();      //文章
      getShareInfo();     //分享
    }

    function share(shareObj){
      var title = $scope.shareInfo.params.title;
      var description = $scope.shareInfo.params.description;
      var thumb = $scope.shareInfo.params.thumb;
      var url = $scope.shareInfo.params.url;

      if($scope.articleType == _app.article_video){
        title = $scope.video.title;
        description = $scope.video.description;
        thumb = $scope.video.mainPic;
        url = 'http://kexue.saixueba.com/share_article/article.html?type=video&code='+$scope.video.code;
      }else if($scope.articleType == _app.article){
        title = $scope.article.title;
        description = $scope.article.shareDiscription;
        thumb = $scope.article.picUrl;
        url = 'http://kexue.saixueba.com/share_article/article.html?type=article&code='+$scope.article.code;
      }

      switch (shareObj.name) {
        case 'Qzone':
          $rootScope.share_Qzone(title, description, thumb, url).then(success, fail);
          return true;
        case 'wechatTimeline':
          $rootScope.share_wechatTimeLine(title, description, thumb, url).then(success, fail);
          return true;
        case 'weibo':
          $rootScope.share_weibo(title, description, thumb, url).then(success, fail);
          return true;
        case 'qq':
          $rootScope.share_qq(title, description, thumb, url).then(success, fail);
          return true;
        case 'wechat':
          $rootScope.share_wechat(title, description, thumb, url).then(success, fail);
          return true;
      }
      function success(response) {
        console.log('分享成功', response);
      }
      function fail(failResponse) {
        console.log('分享失败', failResponse);
      }
    }

    function getShareInfo(){
      if(!$rootScope.ios_isPayChoose){
        /*审核状态不要分享*/
        return;
      }
      $httpFactory.sys.config('shareApp').then(function (res) {
        if(res.data.result == 0){
          $scope.shareInfo = JSON.parse(res.data.object[0].value);
        }
      });
    }

    //上传评论
    function upload(){
      if($scope.commentContent.length>255){
        $ionicLoading.show({template:'文本过长，最多255个字符！'});
        return;
      }
      var data = {
        content: JSON.stringify({
          type: type,
          resCode: code,
          comment: $scope.commentContent
        })
      };
      $httpFactory.main.uploadComment(data).then(function(res){
        if(res.data.result == 0){
          console.log('提交成功');
          //清空重置评论参数
          currentPage=1;
          $scope.commentContent = '';
          $scope.commentList = [];
          $scope.hasNextPage = true;
          // getComment();            //刷新评论并关闭弹窗
          $rootScope.reload_main();     //刷新首页视屏评论数
          close('close');
        }
      });
    }

    //弹出评论输入弹窗
    function upCommentModal(){
      $('.comment_input_modal').css('bottom','0');
      $('.page_cover').css('display','');
      $scope.inputClose=false;          //标记输入弹窗状态为打开
    }

    //软键盘显示时：输入弹窗上移
    function keyboardShowHandler(e){
      var height = e.keyboardHeight+'px';
      $('.comment_input_modal').css('bottom',height);
    }

    //关闭评论输入弹窗
    function close(active){
      if(active && active=='close'){
        $('.comment_input_modal').css('bottom','-61vw');
        $('.page_cover').css('display','none');
        $scope.inputClose = true;
      }else{
        if(!$scope.inputClose){                           //输入弹窗状态为打开时：弹窗下移；关闭时：无操作
          $('.comment_input_modal').css('bottom',0);
        }
      }
    }

    function scrollToShare(){
      if($scope.sharePlace && $scope.sharePlace==$('.share_div').offset().top){
        return;
      }
      $ionicScrollDelegate.scrollTo(0,shareHeight-200,true);
      $timeout(function(){
        $scope.sharePlace = $('.share_div').offset().top;
      },500);
    }

    function scrollToComment(){
      if($scope.commentPlace && $scope.commentPlace==$('.comment_div').offset().top){
        return;
      }
      $ionicScrollDelegate.scrollTo(0,commentHeight-200,true);
      $timeout(function(){
        $scope.commentPlace = $('.comment_div').offset().top;
      },500)
    }

    function navBack(){
      // $state.go('app.table.main');
      $ionicHistory.goBack();
    }

    function initArticle(){
      switch (type){
        case _app.article_video:
          $scope.articleType = _app.article_video;
          getVideo(code);
          break;
        case _app.article:
          $scope.articleType = _app.article;
          getArticle(code);
          break;
        default:
          break;
      }
    }
    function getVideo(videoCode){
      $httpFactory.main.getVideoInfo(videoCode).then(function(res){
        if(res.status==-1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          if(res.data.result == 0){
            $scope.video = res.data.object;
            initZan();
          }
        }
      });
    }
    function getArticle(articleCode){
      $httpFactory.main.getArticleInfo(articleCode).then(function(res){
        if(res.status==-1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          if(res.data.result == 0){
            $scope.article = res.data.object;
            initZan();
          }
        }
      });
    }
    function initZan(){
      switch (type){
        //视频
        case _app.article_video:
          if($scope.video.isClickLike == 0){
            $scope.zan_status=0;
            $scope.zan_text={color:''};
          }else{
            $scope.zan_status=1;
            $scope.zan_text={color:'#279cea'};
          }
          break;
        //图文文章
        case _app.article:
          if($scope.article.isClickLike == 0){
            $scope.zan_status=0;
            $scope.zan_text={color:''};
          }else{
            $scope.zan_status=1;
            $scope.zan_text={color:'#279cea'};
          }
          break;
        default:
          break;
      }
    }

    function changeStatus(){
      if($scope.zan_status == 1){     //每次点击，改变赞的状态
        return;
      }
      $scope.zan_status=1;
      $scope.zan_text={color:'#279cea'};
      // else{
      //   $scope.zan_status=0;
      //   $scope.zan_text={color:''};
      // }
      // $scope.endTime = 3;
      // $interval.cancel($scope.interval);      //3秒以内，再次点击，取消定时器，重置定时时间
      //
      // $scope.interval = $interval(function () {       //点击，无操作3秒后，提交点赞状态
      //   $scope.endTime--;
      //   if ($scope.endTime <= 0) {
      //     $interval.cancel($scope.interval);
      //     var data = {
      //       content:JSON.stringify({type:type,resCode:code,status:$scope.zan_status})
      //     };
      //     $httpFactory.main.updateZanStatus(data).then();
      //   }
      // }, 1000);
      var data = {
        content:JSON.stringify({type:type,resCode:code,status:$scope.zan_status})
      };
      $httpFactory.main.updateZanStatus(data).then(function(res){
        if(res.data.result == 0){
          $rootScope.reload_main();     //刷新首页视屏评论数
        }
      });
    }

    function getComment(){
      $httpFactory.main.getComment(type,code,pageSize,currentPage).then(function(res){
        currentPage++;
        if(res.data.result == 0){
          var list = res.data.object.comment;
          $scope.sumComment = res.data.object.sum;
          $scope.commentList = $scope.commentList.concat(list);
          if(list.length < pageSize){
            $scope.hasNextPage = false;
          }
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      });
    }
  }
})();
