/**
 * Created by Administrator on 2017/5/3 0003.
 */
(function(){
  'use strict';

  angular
    .module('starter')
    .factory('CacheVideoFactory',MainFactory);

  function MainFactory($rootScope,$cordovaFile,$cordovaFileTransfer,$timeout,$ionicLoading){
    {
      var rootPath;      //设置缓存目录
      _app.isAndroid && (rootPath = cordova.file.externalDataDirectory);      //安卓目录
      _app.isIos && (rootPath = cordova.file.documentsDirectory);          //ios目录
    }

    function cacheVideo(dirName,res,callBack) {
      var fileUrl = res.url;
      var urlList = res.url.split("/");
      var fileName = urlList[urlList.length - 1];
      $cordovaFile.checkDir(rootPath, dirName).then(
        //有目录时
        function (res) {
          var dirPath = res.nativeURL;
          //检测文件
          $cordovaFile.checkFile(rootPath, dirName + '/' + fileName).then(function () {
              $cordovaFile.checkFile(rootPath, dirName + '/lock_' + fileName).then(function () {      //锁文件还在，文件下载不完全，删除重新下载
                $cordovaFile.removeFile(rootPath, dirName + '/lock_' + fileName).then(function(){
                  $cordovaFile.removeFile(rootPath, dirName + '/' + fileName).then(function(){
                    downFile(fileUrl, dirPath, fileName);          //下载文件
                  });
                });
              })
          }, function () {
            //下载文件前-生成锁文件
            $cordovaFile.createFile(rootPath, dirName + '/lock_' + fileName, true).then(function () {
              downFile(fileUrl, dirPath, fileName);          //下载文件
            });
          });
        }
        ,
        //无目录时
        function (error) {
          //创建目录
          $cordovaFile.createDir(rootPath, dirName, true).then(function (res) {
            var dirPath = res.nativeURL;
            //下载文件前-生成锁文件
            $cordovaFile.createFile(rootPath, dirName + '/lock_' + fileName, true).then(function () {
              downFile(fileUrl, dirPath, fileName);      //下载文件
            });
          }, function (error) {
            alert('创建文件失败：' + JSON.stringify(error));
          })
        });

      function downFile(fileUrl, targetPath, fileName) {
        var url = fileUrl;
        var targetPath = targetPath + fileName;
        var options = {};
        var trustHosts = true;
        var num;
        if($rootScope.videoDownloadList){
          for(var i=0;i<$rootScope.videoDownloadList.length;i++){
            if($rootScope.videoDownloadList[i].finishDownload==1 && $rootScope.videoDownloadList[i].code==res.code){
              num = i;
            }
          }
          if(!num){
            $rootScope.videoDownloadList.push(res);
            num = $rootScope.videoDownloadList.length-1;
          }
        }else{
          $rootScope.videoDownloadList.push(res);
          num = $rootScope.videoDownloadList.length-1;
        }
        $rootScope.videoDownloadList[num].finishDownload=_app.finishDownload_no;                  //初始下载标记为未完成
        var qt = $cordovaFileTransfer.download(url, targetPath, options, trustHosts);
          qt.then(function (result) {
            // Success!
            $rootScope.videoDownloadList[num].finishDownload=_app.finishDownload_yes;               //下载完成标记
            $ionicLoading.show({template:"下载完成："+$rootScope.videoDownloadList[num].title});
            $cordovaFile.removeFile(rootPath, dirName + '/lock_' + fileName).then(function () {
              console.log('删除锁文件');
              callBack(result);
            });
          }, function (err) {
            $rootScope.videoDownloadList[num].finishDownload=_app.finishDownload_error;            //下载错误标记
            alert($rootScope.videoDownloadList[num].title+"——文件缓存失败:" + JSON.stringify(err));
          }, function (progress) {
            // $timeout(function () {
              $rootScope.videoDownloadList[num].progress_total = parseInt(progress.total/(1024*1024))+'M';
              $rootScope.videoDownloadList[num].progress_loaded = parseInt(progress.loaded/(1024*1024))+'M';
              $rootScope.videoDownloadList[num].downloadProgress = parseInt((progress.loaded / progress.total) * 100)+'%';
              $rootScope.videoDownloadList[num].downloadProgress % 10 == 0 && console.log(res.downloadProgress);
            // });
          });
        // qt.abort();
      }
    }

    var service = {
      cacheVideo:cacheVideo
    }
    return  service;
  }
})();
