/**
 * Created by Administrator on 2016/11/7 0007.
 */
(function () {
  'use strict';
  angular
    .module('starter')
    .factory('PaymentFactory', MainFactory);

  function MainFactory($rootScope, $ionicPopup, $ionicLoading, $httpFactory, localStorageService) {

    {
      var progress = false;
      var payHandle_success = false;// 支付完成
      var payHandle_cancel = false;// 支付中断(支付成功后进程切回也为中断)
    }

    /**
     * 打开支付选择
     * @param $scope
     * @param page_param
     * @param success_pay
     */
    function openPayChoose($scope, page_param, success_pay, fail_pay) {


      $scope.paySelectType = 1; //默认家长代付1，自己支付为2
      $scope.page_paySelect = {};
      $scope.page_paySelect.payment = {
        name: page_param.pro_name,
        price: page_param.pro_price,
        gold: page_param.pro_gold ? page_param.pro_gold : null,
      };

      $scope.page_paySelect.payChoose = 'wechat';// 默认支付方式:微信
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        // cssClass: 'popup_clean',
        templateUrl: 'app/home/section/paySelect.html',
        scope: $scope
      });

      qrcode();  //初始化微信支付二维码

      //家长扫码支付
      function qrcode() {
        // setTimeout(function () {
        var content = {productCode: page_param.productCode};
        $httpFactory.section.order_qrcode(content).then(function (res) {
          if (res.data.message.match("已经购买")) {
            $ionicLoading.show({template: res.data.message});
            return;
          }
          $scope.orderInfo = res.data.object;
          if (res.data.result == 0 && res.data.object.status != 1) {
            setTimeout(function () {
              // 安卓9.0初始化二维码，采用的画布样式
              // 安卓8初始化二维码，采用img样式
              // 所以这里初始化时候，带上width,height设置
              $scope.myQrCode = new QRCode(document.getElementById("qrcode"), {
                text: res.data.object.jsapiDto.code_url,
                width: 130,
                height: 130
              });
            }, 200);
          }
        });
        $scope.checkOrder = function () {
          orderCheck($scope.orderInfo.code);// 订单校验
        }
      }

      // 支付---自己支付
      $scope.pay_money = function (payChoose) {
        if (!progress) {
          progress = true;
          setTimeout(function () {
            progress = false;
          }, 3000);// 3s后再恢复
        } else {
          console.log('progress...');
          return;
        }

        $ionicLoading.show({template: '处理中...'});

        // 支付类型
        switch (payChoose) {
          case 'iap':
            iap();
            break;
          case 'alipay':
            alipay();
            break;
          case 'wechat':
            wechat();
            break;
          // case 'qrcode':
          //   qrcode();
          //   break;
          case 'qq':
            qqPay();
            break;
          case 'gold':
            goldPay();
            break;
          default:
            break;
        }

        function goldPay() {
          $httpFactory.section.order_gold({productCode: page_param.productCode}).then(success, function () {
            $scope.myPopup.close();// 支付失败,关闭弹窗
          });
          function success(response) {
            if (response.data.result == 0) {
              success_pay();
            }
          }
        }

        function wechat_web() {
          // 1.生成统一支付订单 https://pay.weixin.qq.com/wiki/doc/api/app/app.php?chapter=9_1
          var data = {
            "appid": "wx053be7b51c59b5a7",// 应用ID(★app需签名于此一至)
            "attach": "支付测试",// 附加数据
            "body": "APP支付测试",// 商品描述:商品名
            "mch_id": "1404784002",// 商户ID
            "nonce_str": generateRandomAlphaNum(32),// 随机字符串，不长于32位.(主要保证签名不可预测)
            "notify_url": "http://115.206.122.31:8080/K12Service/service/order/wechat/callback",// 接收微信支付异步通知回调地址
            "out_trade_no": wx_randomString(16),// 订单号,service提供
            "spbill_create_ip": "127.0.0.1",// 用户端实际ip
            "total_fee": 1,// 单位是分
            "trade_type": "APP"// 支付类型:APP
          }, key = "E2bKEbDGj7rMtX5Hdqzhd5U83AizX2Cw";// ★商户Key(因受保护)
          $httpFactory.wx.createUnityOrder(data, key, function (res) {
            var xotree = new XML.ObjTree();
            var json = xotree.parseXML(res);
            if (!json) {
              return;
            }
            var result = json.xml;
            if (result
              && result.result_code == "SUCCESS"
              && result.return_code == "SUCCESS"
              && result.return_msg == "OK") {

              var params = {
                appid: 'wx053be7b51c59b5a7',
                noncestr: result.nonce_str, // nonce:随机字符串，不长于32位。推荐随机数生成算法
                package: 'Sign=WXPay',
                partnerid: '1404784002', // merchant id : 商户号
                prepayid: result.prepay_id, // prepay id:微信生成的预支付回话标识，用于后续接口调用中使用，该值有效期为2小时
                timestamp: (Date.now() + '').slice(0, 10) // timestamp:时间戳 String(10)
              };
              var key = "E2bKEbDGj7rMtX5Hdqzhd5U83AizX2Cw";// ★商户Key(因受保护)
              params.sign = wx_sign(params, key);// 商户密钥(前端签名)

              // 2.调起支付接口 https://pay.weixin.qq.com/wiki/doc/api/app/app.php?chapter=9_12&index=2
              window.Wechat && window.Wechat.sendPaymentRequest(params, function () {
                console.log("Success");
                success_pay();
              }, function (reason) {
                // alert("Failed: " + reason);
                console.log("Failed:", reason);
              });
            }
          });
        }

        function wechat() {
          if ($rootScope.hasWechat != 1) {
            $ionicLoading.hide();
            $ionicLoading.show({template: '未找到微信程序'});
            return;
          }

          $httpFactory.section.order_wechat({productCode: page_param.productCode}).then(function (response) {
            if (!response.data.object) {
              $ionicLoading.show({template: response.data.message});
              return;
            }

            var dto = response.data.object.dto;
            // var params = {
            //   appid: resData.appid,
            //   noncestr: resData.nonce_str, // nonce:随机字符串，不长于32位。推荐随机数生成算法
            //   package: resData.package,
            //   partnerid: resData.partnerid, // merchant id : 商户号
            //   prepayid: resData.prepay_id, // prepay id:微信生成的预支付回话标识，用于后续接口调用中使用，该值有效期为2小时
            //   timestamp: resData.timestamp, // timestamp:时间戳 String(10)
            //   sign:resData.sign
            // };

            window.Wechat && window.Wechat.sendPaymentRequest(dto, function () {
              console.log("Success");
              payHandle_success = true;
              orderCheck(response.data.object.code);// 订单校验
            }, function (reason) {
              // alert("Failed: " + reason);
              console.log("Failed:", reason);
            });

            // 启动页面再激活监听
            document.addEventListener("resume", function resumeListener() {
              // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
              setTimeout(function () {
                if (!payHandle_success) {
                  orderCheck(response.data.object.code);// 订单校验
                }
              }, 1000);
              document.removeEventListener("resume", resumeListener);// 删除当前事件监听
            }, false);

          }, function (e) {
            fail_pay();
            $ionicLoading.show({template: e.data.message});
            // console.log(e);
          })
        }

        function alipay_web() {

          // 调用参数说明:https://github.com/charleyw/cordova-plugin-alipay
          window.alipay && window.alipay.pay({
            tradeNo: new Date().getTime(),
            subject: "[赛学霸]点播课-" + page_param.pro_name,
            body: "[赛学霸]点播课-" + page_param.pro_name,
            price: 0.02,
            notifyUrl: "http://your.server.notify.url"
          }, function (successResults) {
            console.log(successResults);
            success_pay();
            // play(knowPoint, el, true);
          }, function (errorResults) {
            console.log(errorResults);
            // play(knowPoint, el, true);
          });

          /**
           *App支付请求参数说明:
           * https://doc.open.alipay.com/doc2/detail.htm?spm=a219a.7629140.0.0.x7kkCI&treeId=204&articleId=105465&docType=1
           */
        }

        function alipay() {
          // 调用参数说明:https://github.com/charleyw/cordova-plugin-alipay
          $httpFactory.section.order_alipay({productCode: page_param.productCode}).then(function (response) {
            if (!response.data.object) {
              $ionicLoading.show({template: response.data.message});
              return;
            }

            var aliDto = response.data.object.v2str;

            window.cordova && cordova.plugins.alipay.payment(aliDto, function (successResults) {
              console.log(successResults);
              payHandle_success = true;
              orderCheck(response.data.object.code);// 订单校验
            }, function (errorResults) {
              console.log(errorResults);
            });

            // window.alipay && window.alipay.pay(aliDto, function (successResults) {
            //   console.log(successResults);
            //   payHandle_success = true;
            //   orderCheck(response.data.object.code);// 订单校验
            // }, function (errorResults) {
            //   console.log(errorResults);
            // });

            // 启动页面再激活监听
            document.addEventListener("resume", function resumeListener() {
              // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
              setTimeout(function () {
                if (!payHandle_success) {
                  orderCheck(response.data.object.code);// 订单校验
                }
              }, 1000);
              document.removeEventListener("resume", resumeListener);// 删除当前事件监听
            }, false);

            /**
             * App支付请求参数说明:
             * https://doc.open.alipay.com/doc2/detail.htm?spm=a219a.7629140.0.0.x7kkCI&treeId=204&articleId=105465&docType=1
             */
          });
        }

        function qqPay() {
          var content = {productCode: page_param.productCode};
          $httpFactory.section.order_qPay(content).then(function (res) {
            if (res.data.result == 0) {
              // alert('dto数据：'+JSON.stringify(res.data.object.qpayDto));
              var dto = res.data.object.qpayDto;
              var tokenId = dto.tokenId;
              var nonce = dto.nonce;
              var bargainorId = dto.bargainorId;
              var sig = dto.sig;


              var dtoInfo = {
                tokenId: tokenId,
                nonce: nonce,
                bargainorId: bargainorId,
                sig: sig
              };

              QPay.mqqPay(dto, function () {
                payHandle_success = true;
                orderCheck(res.data.object.orders.code);// 订单校验
              }, function (res) {
                alert("支付失败:" + JSON.stringify(res))
              });

              // 启动页面再激活监听
              document.addEventListener("resume", function resumeListener() {
                // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
                setTimeout(function () {
                  if (!payHandle_success) {
                    orderCheck(res.data.object.code);// 订单校验
                  }
                }, 1000);
                document.removeEventListener("resume", resumeListener);// 删除当前事件监听
              }, false);
            }
          });
        }

        function iap() {
          $rootScope.isInstall_qq().then(success, fail_pay);
        }
      }


      /**
       * 校验订单
       * @param orderCode
       */
      function orderCheck(orderCode) {
        // $ionicLoading.show({template: '支付确认中...'});
        $httpFactory.section.order_query({orderCode: orderCode}).then(function (request) {
          if (request.data.result == 0) {
            if (request.data.object.status == 1) {// 状态，0待支付，1已支付，2异常|失败，3作废
              appv.currentUser.isPayUser = 1;     //用户状态改为付费用户

              if(appv.currentUser.icon1){
                appv.currentUser.icon1 = http2https(appv.currentUser.icon1);
              }

              //退出，并去进程，在登录，读取isPayUser还是0，重新set
              localStorageService.set('currentUser', appv.currentUser);
              $rootScope.MallCtrl_refresh && $rootScope.MallCtrl_refresh();        //刷新用户商城钻石
              success_pay();
              /** 订单支付完成,回调业务 **/
            } else {
              $ionicLoading.hide();
              // $ionicLoading.show({template: '订单尚未支付完成...',duration:2000});// TODO 微信偶然会自动取消,所以暂不提示
            }
          } else {
            $ionicLoading.hide();
            $ionicLoading.show({template: request.message});
          }
        })
      }

      function http2https(url) {
        if (url && url.startsWith("http") && !url.startsWith("https")) {
          // http 转为 https
          url = url.replace("http", "https");
        }
        return url;
      }
    }

    var service = {
      openPayChoose: openPayChoose,
    };
    return service;
  }

})();
