/**
 * Created by Administrator on 2016/9/2 0002.
 */

(function (window) {
  'use strict';
  var wechat = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        Wechat.isInstalled(function (installed) {
          // alert("Wechat installed: " + (installed ? "Yes" : "No"));
          resolve(installed);
        });
      });
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        Wechat.auth("snsapi_userinfo", function (response) {
          // you may use response.code to get the access token.
          // alert(JSON.stringify(response));
          resolve(JSON.stringify(response));
        }, function (reason) {
          // alert("Failed: " + reason);
          reject(reason);
        });
      });
    },
    share: function (title, description, thumb, url) {
      return new Promise(function (resolve, reject) {

        // if (typeof Wechat === "undefined") {
        //   // alert("Wechat plugin is not installed.");
        //   reject("Wechat plugin is not installed.");
        //   return false;
        // }

        var params = {
          scene: Wechat.Scene.SESSION,
          message: {media: {}}
        };

        params.message.media.type = Wechat.Type.WEBPAGE;

        // params.message.title = "title";
        // params.message.description = "description";
        // params.message.thumb = "https://cordova.apache.org/images/cordova_256.png";
        // params.message.media.webpageUrl = "http://www.saixueba.com/";

        title && (params.message.title = title);
        description && (params.message.description = description);
        thumb && (params.message.thumb = thumb);
        url && (params.message.media.webpageUrl = url);

        Wechat.share(params, function () {
          //alert("Success：3333");
          resolve("Success");
        }, function (reason) {
          //alert("Failed: " + reason);
          reject(reason);
        });
      })
    },
    shareTimeLine: function (title, description, thumb, url) {
      return new Promise(function (resolve, reject) {

        // if (typeof Wechat === "undefined") {
        //   // alert("Wechat plugin is not installed.");
        //   reject("Wechat plugin is not installed.");
        //   return false;
        // }

        var params = {
          scene: Wechat.Scene.TIMELINE,
          message: {media: {}}
        };

        params.message.media.type = Wechat.Type.WEBPAGE;

        // params.message.title = "专访张小龙：产品之上的世界观";
        // params.message.description = "微信的平台化发展方向是否真的会让这个原本简洁的产品变得臃肿？在国际化发展方向上，微信面临的问题真的是文化差异壁垒吗？腾讯高级副总裁、微信产品负责人张小龙给出了自己的回复。";
        // params.message.thumb = "https://cordova.apache.org/images/cordova_256.png";
        // params.message.media.webpageUrl = "http://tech.qq.com/";

        title && (params.message.title = title);
        description && (params.message.description = description);
        thumb && (params.message.thumb = thumb);
        url && (params.message.media.webpageUrl = url);

        Wechat.share(params, function () {
          // alert("Success");
          resolve("Success");
        }, function (reason) {
          // alert("Failed: " + reason);
          reject(reason);
        });
      })
    },
    sendPaymentRequest: function (mchId, prepayId, nonce, timestamp, sign) {
      return new Promise(function (resolve, reject) {
        var params = {
          mch_id: '1404784002', // merchant id
          prepay_id: 'wx201411101639507cbf6ffd8b0779950874', // prepay id returned from server
          nonce: '1add1a30ac87aa2db72f57a2375d8fec', // nonce string returned from server
          timestamp: '1439531364', // timestamp
          sign: '0CB01533B8C1EF103065174F50BCA001', // signed string
        };
        mchId && (params.mch_id = mchId);
        prepayId && (params.prepay_id = prepayId);
        nonce && (params.nonce = nonce);
        timestamp && (params.timestamp = timestamp);
        sign && (params.sign = sign);

        Wechat.sendPaymentRequest(params, function () {
          // alert("Success");
          resolve("Success");
        }, function (reason) {
          // alert("Failed: " + reason);
          reject(reason);
        });
      });
    }
  }

  var qq = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.QQ;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        QQSDK.checkClientInstalled(function () {
          //alert('client is installed');
          resolve(1);
        }, function () {
          // if installed QQ Client version is not supported sso,also will get this error
          //alert('client is not installed');
          reject(0);
        }, args);
      })
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.QQ;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        QQSDK.ssoLogin(function (args) {
          //alert('args is ' + JSON.stringify(args));
          resolve(args);
        }, function (failReason) {
          //alert(failReason);
          reject(failReason);
        }, args);
      })
    },
    share: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.appName = "赛学霸物理";
        args.client = QQSDK.ClientType.QQ;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        args.scene = QQSDK.Scene.QQ;//QQSDK.Scene.QQZone,QQSDK.Scene.Favorite

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.image = imageUrl);
        url && (args.url = url);

        QQSDK.shareNews(function () {
          //alert('shareNews success');
          resolve(1);
        }, function (failReason) {
          //alert(failReason);
          reject(failReason);
        }, args);
      })
    },
    shareToQzone: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.QQ;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        args.scene = QQSDK.Scene.QQZone;//QQSDK.Scene.QQZone,QQSDK.Scene.Favorite

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.image = imageUrl);
        url && (args.url = url);

        QQSDK.shareNews(function () {
          resolve(1);
          //alert('qzone success');
        }, function (failReason) {
          //alert(failReason);
          reject(failReason);
        }, args);
      })
    }
  }

  var tim = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.TIM;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        QQSDK.checkClientInstalled(function () {
          resolve(1);
        }, function () {
          reject(0);
        }, args);
      })
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.TIM;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        QQSDK.ssoLogin(function (args) {
          resolve(args);
        }, function (failReason) {
          reject(failReason);
        }, args);
      })
    },
    share: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.appName = "赛学霸物理";
        args.client = QQSDK.ClientType.TIM;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        args.scene = QQSDK.Scene.QQ;//QQSDK.Scene.QQZone,QQSDK.Scene.Favorite

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.image = imageUrl);
        url && (args.url = url);

        QQSDK.shareNews(function () {
          resolve(1);
        }, function (failReason) {
          reject(failReason);
        }, args);
      })
    },
    shareToQzone: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.client = QQSDK.ClientType.TIM;//QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
        args.scene = QQSDK.Scene.QQZone;//QQSDK.Scene.QQZone,QQSDK.Scene.Favorite

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.image = imageUrl);
        url && (args.url = url);

        QQSDK.shareNews(function () {
          resolve(1);
        }, function (failReason) {
          reject(failReason);
        }, args);
      })
    }
  }

  var weibo = {
    installed: function () {
      return new Promise(function (resolve, reject) {
        YCWeibo.checkClientInstalled(function () {
          // console.log('client is installed');
          resolve(1);
        }, function () {
          // console.log('client is not installed');
          reject(0);
        });
      })
    },
    auth: function () {
      return new Promise(function (resolve, reject) {
        YCWeibo.ssoLogin(function (args) {
          // alert("access token is " + args.access_token);
          // alert("userid is " + args.userid);
          // alert("expires_time is " + new Date(parseInt(args.expires_time)) + " TimeStamp is " + args.expires_time);
          resolve(args);
        }, function (failReason) {
          // console.log(failReason);
          reject(failReason);
        });
      })
    },
    share: function (title, description, imageUrl, url) {
      return new Promise(function (resolve, reject) {
        var args = {};
        args.defaultText = "";
        // args.url = "http://www.baidu.com";
        // args.title = "Baidu";
        // args.description = "This is Baidu";
        // args.imageUrl = "https://www.baidu.com/img/bdlogo.png";//if you don't have imageUrl,for android http://www.sinaimg.cn/blog/developer/wiki/LOGO_64x64.png will be the defualt one

        title && (args.title = title);
        description && (args.description = description);
        imageUrl && (args.imageUrl = imageUrl);
        url && (args.url = url);

        YCWeibo.shareToWeibo(function () {
          // alert("share success");
          resolve(1);
        }, function (failReason) {
          // alert(failReason);
          reject(failReason);
        }, args);
      })
    }
  }

  /**
   * 分享实现
   */
  window.share = {
    wechat: wechat,
    qq: qq,
    tim: tim,
    weibo: weibo
  }

})(window);

/**
 谈谈 ES6 的 Promise 对象 - ac黄博客精选 - SegmentFault`
 https://segmentfault.com/a/1190000002928371
 */
