/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('CoursewareCtrl', MainController)

  /**
   * _data.knowPoints[0-5] 分册书列表
   * _data.knowPoints[0]  具体分册的书
   * _data.knowPoints[0] 子集[书]
   * _data.knowPoints[0].knowPoints[0-n] 子集[书-章]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0-n] 子集[书-章-节]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0].knowPoints[0] 子集[书-章-节-知识点]
   */
  function MainController($scope, $state, localStorageService, RouteData, $httpFactory, $ionicScrollDelegate, $cordovaAppVersion, $ionicPopup, $cordovaNativeAudio) {
    console.time('CoursewareCtrl');

    {
      $scope.isChoice = true;
      $scope.choiceToggle = choiceToggle;
      $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 同步本地存储后,初始化翻转角度
      $scope.choiceOpenBook = choiceOpenBook;
      $scope.openSection = openSection;
      $scope.toLive = toLive;

      $scope.musicPlay = function () {
        $cordovaNativeAudio.play('click');
      }

      initFormData();// 初始化formData数据
      onLoaded();// 加载完成后
      stateChangeSuccess();

      (appv.currentUser && !window.isEveryDaySign) ? $httpFactory.everyDaySign() : '';// 自动签到(场景:二次打开,自动登录)
      window.isCheckCVersion ? (window.isCheckCVersion = true) : checkVersion();// 版本更新

      console.timeEnd('HomeCtrl');
      console.timeEnd('Home state');

      if (_app.isAndroid) { // android umeng统计不正确,尝试在此重新统计
        umengService.init({"args": "init"})
      }
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.log('b', $(".paper").length);
        console.timeEnd('Home page load');

        // var player = new prismplayer({
        //   id: "J_prismPlayer", // 容器id
        //   source: "http://cloud.video.taobao.com/play/u/2554695624/p/1/e/6/t/1/fv/102/28552077.mp4",  // 视频url 支持互联网可直接访问的视频地址
        //
        //   // source: "http://sxb-live-source.oss-cn-shanghai.aliyuncs.com/m3u8SegementIn55/赛学霸直播课修改.mp4",
        //   // source: "http://sxb-live.oss-cn-shanghai.aliyuncs.com/Act-m3u8-segment/532a76e28cce487ea0f60fc848f4a3be/赛学霸直播课修改.m3u8",
        //
        //   // source: "http://sxb-live.oss-cn-hangzhou.aliyuncs.com/Act-ss-mp4-ld/5976aa21971c4105a2c4a6176897fbee/sxb_live.mp4",
        //   // source: "http://live.saixueba.com/Act-ss-mp4-ld/5976aa21971c4105a2c4a6176897fbee/sxb_live.mp4",
        //
        //   autoplay: false,      // 自动播放
        //   width: "100%",       // 播放器宽度
        //   height: "80vw"      // 播放器高度
        // });

        var screen_change_events = "webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange";
        $(document).on(screen_change_events, function () {
          console.log('change', document['webkitIsFullScreen'], screen_change_events);
          if (document['webkitIsFullScreen']) {
            !_app.isWeb && window.screen.orientation.lock("landscape");// 横屏
          } else {
            !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
          }
        });

        // 二维码初始化
        // new QRCode(document.getElementById("qrcode"), "http://baidu.com");
      });
    }

    /**
     * 初始化formdata数据,同步localStorage
     */
    function initFormData() {
      var formData = localStorageService.get('formData');
      if (formData) {
        initForm(formData);
      }

      $httpFactory.home.knowPoint().then(function (response) {
        localStorageService.set('formData', response.data);// 本地存储-节
        initForm(response.data);
      })
    }

    /**
     * 初始化form
     * @param formData
     */
    function initForm(formData) {
      $scope.books = formData.object[0].knowPoints;
      initLocalStorage(formData.object[0]);// 初始化本地存储

    }

    function stateChangeSuccess() {
      $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        // console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        if (toState.url == '/home') {
          $('.bar.bar-stable').css('background-color', '#279cea');
          $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 重置
        }
      })
    }

    /**
     * 初始化本地存储
     */
    function initLocalStorage(_data) {

      var path = window._config.domain_name_exp;//  "http://120.55.144.43/teach";
      var exePro = {'八年级上': 'teach_rjb_101', '八年级下': 'teach_rjb_102', '九年级': 'teach_rjb_103'};
      var chapterNum = 0;
      angular.forEach(_data.knowPoints, function (data1, index1, array) {// 书
        angular.forEach(data1.knowPoints, function (data2, index2, array) {// 章
          chapterNum += 1;
          angular.forEach(data2.knowPoints, function (data3, index3, array) {// 节
            data3.pic = "img/book/" + chapterNum + "/" + (index3 + 1) + ".jpg";
            angular.forEach(data3.knowPoints, function (data4, index4, array) {// 知识点
              data4.mobileUrl = path + "/" + exePro[data1.name] + "?chapterId=" + (chapterNum + '-' + (index3 + 1)) + "&menuId=" + (index4 + 1);// 知识点打开页面
            })
          })
        })
      });

      // 初始化本地存储
      _data.knowPoints[0].activity = 'activity';// 标记open
      localStorageService.set('openBook', _data.knowPoints[0]);
      $scope.openBook = _data.knowPoints[0];
      $scope.openBook.activity = 'activity';// 标记open
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
      localStorageService.bind($scope, 'openBook');

      $scope.isChoice = localStorageService.get('isChoice');
      localStorageService.bind($scope, 'isChoice');
    }

    /*检查是否有新版本*/
    function checkVersion() {
      // return ;// TODO debug
      if (!_app.isAndroid) {
        return;
      }

      $httpFactory.versionQuery_1802().then(function (res) {
        if (res.data.result == 0) {
          if (_app.isWeb) {
            return;
            /*web版本没有更新*/
          }
          $cordovaAppVersion.getVersionCode().then(function (version) {
            $scope.result = res.data.object.lastVersion;
            $scope.lastVersion = $scope.result.version;
            $scope.lastContent = $scope.result.content;
            if ($scope.result.versionNo <= version) {
              return;
              /*无需更新*/
            }

            // 是否忽略设备市场
            if (res.data.object &&
              res.data.object.lastVersion &&
              res.data.object.lastVersion.ignore &&
              res.data.object.lastVersion.ignore.indexOf(device.manufacturer) != -1) {
              return;
            }

            $scope.downNewVersion = downNewVersion;
            // $scope.popupColse = popupColse;
            // $scope.force_update = false;// 是否强制更新

            if (res.data.object.forceUpdate) {
              /* 强制更新 */
              $scope.force_update = true;
            }

            $scope.myPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              templateUrl: 'app/app/update.html',
              scope: $scope
            });
            $scope.myPopup.then(function (res) {
              if ($scope.force_update) {
                /*强制更新,返回退出*/
                ionic.Platform.exitApp();
              }
            });

            // function popupColse() {
            //   if ($scope.force_update) {
            //     return;
            //   }
            //   $scope.myPopup.close();
            // }
          });
        } else {
          my.log("错误：" + res.data.message);
        }
      });

      /* 跳转浏览器,下载新版本 */
      function downNewVersion() {
        window.open($scope.result.versionUrl, '_system');
      }
    }

    function choiceOpenBook(book) {
      if (book.name == $scope.openBook.name) {
        choiceToggle();
        return;
      }

      !!$scope.isChoice && ($scope.isChoice = true);

      $scope.openBook.activity = null;
      book.activity = 'activity';
      $scope.openBook = book;
      choiceToggle();
      $ionicScrollDelegate.scrollTop();// 回到顶部
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
    }

    function choiceToggle() {
      $scope.rotaeNum = $scope.rotaeNum + 1;
      $scope.isChoice = !$scope.isChoice;
    }

    function openSection(event, section, chapter) {
      RouteData.section = {openSection: section};

      var colorData = _getImgColor(event.currentTarget.querySelector("img"));
      section.color = colorData;
      localStorageService.set('openSection', section);// 本地存储-节

      RouteData.section.pageName_umeng = section.name;
      $state.go('app.section');
    }

    function toLive() {
      $state.go('app.live');
    }

    /**
     * 涟漪效果 ripple
     */
    function animate_ripple() {
      return true;// 影响性能,暂时关闭
      $(".paper")
        .click(function (e) {
          var ripple = $(this).find(".ripple");
          ripple.removeClass("animate-ripple");
          var x = parseInt(e.pageX - $(this).offset().left) - (ripple.width() / 2);
          var y = parseInt(e.pageY - $(this).offset().top) - (ripple.height() / 2);
          ripple.css({
            top: y,
            left: x
          }).addClass("animate-ripple");
        })
    }

  }

})();
