/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('HomeCtrl', MainController)

  /**
   * _data.knowPoints[0-5] 分册书列表
   * _data.knowPoints[0]  具体分册的书
   * _data.knowPoints[0] 子集[书]
   * _data.knowPoints[0].knowPoints[0-n] 子集[书-章]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0-n] 子集[书-章-节]
   * _data.knowPoints[0].knowPoints[0].knowPoints[0].knowPoints[0] 子集[书-章-节-知识点]
   */
  function MainController($scope, $state, localStorageService, RouteData, $httpFactory, $ionicScrollDelegate, $ionicLoading,
                          $cordovaAppVersion, $ionicPopup, $cordovaNativeAudio, $rootScope, SelfFactory, PaymentFactory) {
    console.time('HomeCtrl');

    {
      $scope.iosPayOpen = $rootScope.ios_isPayChoose;//是否打开支付
      $scope.isIos = $rootScope.isIos;//是否为ios设备
      $scope.currentUser = window.appv.currentUser;
      $scope.bookGold = appv.bookGold;
      $scope.isChoice = true;
      $scope.choiceToggle = choiceToggle;
      $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 同步本地存储后,初始化翻转角度
      $scope.choiceOpenBook = choiceOpenBook;
      $scope.openSection = openSection;
      $scope.chapterPractice = chapterPractice //章练习
      $scope.getProgress = getProgress;   //章练习进度
      // $scope.toWrong = toWrong;     //错题本

      if (window.cordova && cordova.InAppBrowser) {
        window.open = cordova.InAppBrowser.open;
      }

      checkThird();//检测第三方，奖学金弹窗分享需要分享信息
      $scope.toMyCenter = toMyCenter;     //头像，个人中心
      $scope.toMyLearning = toMyLearning;     //我的学习
      $scope.musicPlay = function () {
        // $rootScope.number = 100;                 //金币动画测试
        // $rootScope.message = '签到奖励';
        // AutoDivFactory.open('app/common/gold/gold.html', $rootScope);
        // $cordovaNativeAudio.play('click');     //音效测试
      }

      initFormData();// 初始化formData数据
      $rootScope.initFormData = initFormData;
      onLoaded();// 加载完成后
      stateChangeSuccess();

      (appv.currentUser && !window.isEveryDaySign) ? $httpFactory.everyDaySign() : '';// 自动签到(场景:二次打开,自动登录)
      window.isCheckCVersion ? (window.isCheckCVersion = true) : checkVersion();// 版本更新
      console.timeEnd('HomeCtrl');
      console.timeEnd('Home state');

      if (_app.isAndroid) { // android umeng统计不正确,尝试在此重新统计
        umengService.init({"args": "init"})
      }
      $scope.colorStyle = colorStyle;
      $scope.shareApp = shareApp;
      $scope.toMyScholar = toMyScholar;
      checkScholar();
    }

    function shareApp() {
      $scope.f_share = f_share;// 分享
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareApp.html',
        scope: $scope
      });
    }

    function f_share(item, params) {
      switch (item.name) {
        case 'Qzone':
          $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'wechatTimeline':
          $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'weibo':
          $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'qq':
          $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'wechat':
          $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
      }

      function success(response) {
        console.log('分享成功', response);
      }

      function fail(failResponse) {
        console.log('分享失败', failResponse);
      }
    }

    //第三方检测是否安装
    function checkThird() {
      if (RouteData.shareInfo) {
        $scope.share = RouteData.shareInfo;
        return;
      }
      $httpFactory.sys.config('shareApp').then(function (response) {
        shareApp_handle(response);
      })

      function shareApp_handle(response) {
        $scope.share = JSON.parse(response.data.object[0].value);
        $scope.share.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
        $scope.share.params.title = $scope.share.params.title.replace('{{inviteCode}}', $scope.share.inviteCode);
        $scope.share.params.description = $scope.share.params.description.replace('{{inviteCode}}', $scope.share.inviteCode);

        for (var i in $scope.share.items) {
          f_isInstall($scope.share.items[i]);
        }
        RouteData.shareInfo = $scope.share;

        setTimeout(function () {
          $scope.$apply();
        }, 500);// 脏检查

        function f_isInstall(item) {
          if (_app.isWeb) {
            item.isInstall = true;
            return;
          }

          switch (item.name) {
            case 'qq':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'Qzone':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'wechat':
              $scope.isInstall_wechat().then(success, fail);
              return true;
            case 'wechatTimeline':
              $scope.isInstall_wechat().then(success, fail);
              return true;
            case 'weibo':
              $scope.isInstall_weibo().then(success, fail);
              return true;
          }
          function success(response) {
            item.isInstall = response;
            item.itemShowImg = false;
          }

          function fail(failResponse) {
            console.log(failResponse);
          }
        }
      }
    }

    function checkScholar() {
      if (!appv.currentUser || !$scope.iosPayOpen) {
        return;
      }
      $httpFactory.user.myScholarship().then(function (res) {
        if (res.data.result == 0) {
          $scope.currentScholar = res.data.object;
          $scope.localScholar = localStorageService.get('myScholar') ? localStorageService.get('myScholar') : "";
          $scope.currentBalance = $scope.currentScholar.balance ? $scope.currentScholar.balance : 0;
          $scope.localBalance = $scope.localScholar.balance ? $scope.localScholar.balance : 0;
          if ($scope.currentBalance > $scope.localBalance) {
            localStorageService.set('myScholar', $scope.currentScholar);
            $scope.sholarPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              templateUrl: 'app/app/scholar.html',
              scope: $scope
            })
          }
        }
      });
    }

    function toMyScholar() {
      $scope.sholarPopup.close();
      $state.go('app.myMoney');
    }

    //头像，个人中心
    function toMyCenter() {
      $state.go('app.table.selfCenter');
      $rootScope.tableInit && $rootScope.tableInit('app.table.selfCenter');
    }

    //我的学习
    function toMyLearning() {
      $state.go('app.learning');
    }

    function getProgress(chapter) {
      var progress;
      if (chapter.trueNum / chapter.totalNum >= 1) {
        progress = 100;
      } else {
        progress = Math.floor(chapter.trueNum / chapter.totalNum * 100);
      }
      return progress;
    }

    function chapterPractice(chapter) {
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return;
      //}

      // [0书1章2节3点] 2节
      $httpFactory.section.order_product(2, chapter.code).then(function (response) {
        if (response.data.object.length == 0) {
          return;
        }
        $scope.pro_section = response.data.object[0];
      })


      localStorageService.set('openSection', chapter);// 本地存储-节
      $state.go('app.practice');
    }

    function colorStyle(progressSum, progressNum, index, length) {
      var wsStyle = {};
      var color;
      var side;
      //转换颜色
      if (progressSum >= progressNum) {
        switch (index) {
          case 0:
            color = '#70b907';
            break;
          case 1:
            color = '#e34218';
            break;
          case 2:
            color = '#1697eb';
            break;
          case 3:
            color = '#f1ae1f';
            break;
          case 4:
            color = '#1697eb';
            break;
          default:
            break;
        }
      }
      //转换位置
      {
        var row = parseInt(length / 2);
        var single = parseInt(length % 2);   //课件数-单双
        var changeRow = index + 1 > row * 2 - 1 ? true : false;    //左右边转换标记
        //双数列
        if (single == 0) {
          if (parseInt(index % 2) == 1) {
            changeSide(progressNum);       //从0开始，一列默认左边展示，二列转换右边展示
          }
        }
        //单数列
        else {
          if (parseInt(index % 2) == 1) {
            if (!changeRow) {
              changeSide(progressNum);       //从0开始，一列默认左边展示，二列转换右边展示
            }
          } else {
            if (changeRow) {
              changeSide(progressNum);
            }
          }
        }
      }
      //返回
      return {'border-color': color, clip: side};

      function changeSide(progressNum) {
        switch (progressNum) {
          case 1 :
            side = 'rect(10vw,38vw,15vw,19vw)';
            break;
          case 2 :
            side = 'rect(16vw,38vw,22vw,19vw)';
            break;
          case 3 :
            side = 'rect(23vw,38vw,28vw,19vw)';
            break;
          default :
            break;
        }
      }
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.log('b', $(".paper").length);
        console.timeEnd('Home page load');

        // var player = new prismplayer({
        //   id: "J_prismPlayer", // 容器id
        //   source: "http://cloud.video.taobao.com/play/u/2554695624/p/1/e/6/t/1/fv/102/28552077.mp4",  // 视频url 支持互联网可直接访问的视频地址
        //
        //   // source: "http://sxb-live-source.oss-cn-shanghai.aliyuncs.com/m3u8SegementIn55/赛学霸直播课修改.mp4",
        //   // source: "http://sxb-live.oss-cn-shanghai.aliyuncs.com/Act-m3u8-segment/532a76e28cce487ea0f60fc848f4a3be/赛学霸直播课修改.m3u8",
        //
        //   // source: "http://sxb-live.oss-cn-hangzhou.aliyuncs.com/Act-ss-mp4-ld/5976aa21971c4105a2c4a6176897fbee/sxb_live.mp4",
        //   // source: "http://live.saixueba.com/Act-ss-mp4-ld/5976aa21971c4105a2c4a6176897fbee/sxb_live.mp4",
        //
        //   autoplay: false,      // 自动播放
        //   width: "100%",       // 播放器宽度
        //   height: "80vw"      // 播放器高度
        // });

        var screen_change_events = "webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange";
        $(document).on(screen_change_events, function () {
          console.log('change', document['webkitIsFullScreen'], screen_change_events);
          if (document['webkitIsFullScreen']) {
            !_app.isWeb && window.screen.orientation.lock("landscape");// 横屏
          } else {
            !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
          }
        });

        // 二维码初始化
        // new QRCode(document.getElementById("qrcode"), "http://baidu.com");
      });
    }

    /**
     * 初始化formdata数据,同步localStorage
     */
    function initFormData() {
      var formData = localStorageService.get('formData');
      if (formData) {
        initForm(formData);
      }

      $httpFactory.home.knowPoint().then(function (response) {
        if (response.status == -1) {
          $scope.networkError = true;
        } else {
          $scope.networkError = false;
          localStorageService.set('formData', response.data);// 本地存储-节
          initForm(response.data);
          SelfFactory.redrawPage();     //重绘页面
        }
      })
    }

    /**
     * 初始化章节进度数据
     * @param formData
     */
    function initForm(formData) {
      var sectionList = [];
      for (var i = 0; i < formData.object[0].knowPoints.length; i++) {
        var chapter = formData.object[0].knowPoints[i].knowPoints;
        for (var j = 0; j < chapter.length; j++) {
          var section = chapter[j].knowPoints;
          sectionList = sectionList.concat(section);
        }
        var sum = 0;
        for (var k = 0; k < sectionList.length; k++) {
          sectionList[k].progressSum == 3 ? sum++ : 1;
        }
        var bookProgress = Math.floor(sum / sectionList.length * 100);
        formData.object[0].knowPoints[i].bookProgress = bookProgress;
        sectionList = [];
      }
      $rootScope.books = formData.object[0].knowPoints;
      initLocalStorage(formData.object[0]);// 初始化章节本地存储
    }

    function stateChangeSuccess() {
      $scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        // console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        if (toState.url == '/home') {
          $('.bar.bar-stable').css('background-color', '#279cea');
          $scope.rotaeNum = $scope.isChoice ? 0 : 1;// 重置
        }
      })
    }

    /**
     * 初始化本地存储
     */
    function initLocalStorage(_data) {

      var path = window._config.domain_name_exp;//  "http://120.55.144.43/teach";
      var exePro = {'八年级上': 'teach_rjb_101', '八年级下': 'teach_rjb_102', '九年级': 'teach_rjb_103'};
      var chapterNum = 0;
      angular.forEach(_data.knowPoints, function (data1, index1, array) {// 书
        angular.forEach(data1.knowPoints, function (data2, index2, array) {// 章
          chapterNum += 1;
          angular.forEach(data2.knowPoints, function (data3, index3, array) {// 节
            data3.pic = "img/book/" + chapterNum + "/" + (index3 + 1) + ".jpg";
            angular.forEach(data3.knowPoints, function (data4, index4, array) {// 知识点
              data4.mobileUrl = path + "/" + exePro[data1.name] + "?chapterId=" + (chapterNum + '-' + (index3 + 1)) + "&menuId=" + (index4 + 1);// 知识点打开页面
            })
          })
        })
      });

      // 初始化本地存储
      var localBook = localStorageService.get('openBook');
      var newBook;
      if (!localBook) {
        _data.knowPoints[0].activity = 'activity';// 标记open
        newBook = _data.knowPoints[0];
      } else {
        for (var i = 0; i < _data.knowPoints.length; i++) {
          if (localBook.code == _data.knowPoints[i].code) {
            _data.knowPoints[i].activity = 'activity';// 标记open
            newBook = _data.knowPoints[i];
          }
        }
      }
      localStorageService.bind($rootScope, 'openBook');//先绑定$rootScope
      localStorageService.set('openBook', newBook);

      /*newBook与$rootScope.books指向同一个引用,
       此时相当于把openBook与books绑定,改变books数据,也会改变openBook数据
       若先绑定openBook与books,再绑定localStorageService与$rootScope.openBook,前一个绑定失效
       */
      $rootScope.openBook = newBook;
      $rootScope.openBook.activity = 'activity';// 标记open
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
      localStorageService.set('isChoice', true);
      $scope.isChoice = localStorageService.get('isChoice');
      localStorageService.bind($scope, 'isChoice');
    }

    /*检查是否有新版本*/
    function checkVersion() {
      // return ;// TODO debug
      if (!_app.isAndroid) {
        return;
      }

      $httpFactory.versionQuery_1802().then(function (res) {
        if (res.data.result == 0) {
          if (_app.isWeb) {
            return;
            /*web版本没有更新*/
          }
          $cordovaAppVersion.getVersionCode().then(function (version) {
            $scope.result = res.data.object.lastVersion;
            $scope.lastVersion = $scope.result.version;
            $scope.lastContent = $scope.result.content;
            if ($scope.result.versionNo <= version) {
              return;
              /*无需更新*/
            }

            // 是否忽略设备市场
            if (res.data.object &&
              res.data.object.lastVersion &&
              res.data.object.lastVersion.ignore &&
              res.data.object.lastVersion.ignore.indexOf(device.manufacturer) != -1) {
              return;
            }

            $scope.downNewVersion = downNewVersion;
            // $scope.popupColse = popupColse;
            // $scope.force_update = false;// 是否强制更新

            if (res.data.object.forceUpdate) {
              /* 强制更新 */
              $scope.force_update = true;
            }

            $scope.myPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              templateUrl: 'app/app/update.html',
              scope: $scope
            });
            $scope.myPopup.then(function (res) {
              if ($scope.force_update) {
                /*强制更新,返回退出*/
                ionic.Platform.exitApp();
              }
            });

          });
        } else {
          my.log("错误：" + res.data.message);
        }
      });

      /* 跳转浏览器,下载新版本 */
      function downNewVersion() {
        window.open($scope.result.versionUrl, '_system');
      }
    }

    function choiceOpenBook(book) {
      if (book.name == $rootScope.openBook.name) {
        choiceToggle();
        return;
      }

      !!$scope.isChoice && ($scope.isChoice = true);

      $rootScope.openBook.activity = null;
      book.activity = 'activity';
      $rootScope.openBook = book;
      choiceToggle();
      $ionicScrollDelegate.scrollTop();// 回到顶部
      setTimeout(function () {
        animate_ripple()
      }, 200);// 初始化涟漪效果
    }

    function choiceToggle() {
      $scope.rotaeNum = $scope.rotaeNum + 1;
      $scope.isChoice = !$scope.isChoice;
    }

    //清理上次点击的节产品信息
    function clearOldData() {
      $scope.pro_book = {}
      $scope.pro_section = {}
    }

    function openSection(event, section, chapter, isNoFirst) {
      $scope.currentSection = section;
      clearOldData();
      //提取图片色值
      RouteData.section = {openSection: section};
      var colorData = _getImgColor(event.currentTarget.querySelector("img"));
      // var colorData = _getImgColor(event.toElement.querySelector("img"));
      section.color = colorData;
      localStorageService.set('openSection', section);// 本地存储-节
      RouteData.section.pageName_umeng = section.name;
      //未购买时，弹出购买窗口
      if (isNoFirst && (!$rootScope.openBook.status || $rootScope.openBook.status == 1)
        && (section.status == 1)) {
        getProduct();     //获取产品信息
        toPayMenu();      //打开购买选项菜单
        return;
      }
      //已订购后
      $state.go('app.section');

      //获取产品信息
      function getProduct() {
        // [0书1章2节3点] 0书
        $httpFactory.section.order_product(0, $rootScope.openBook.code).then(function (response) {
          if (response.status == -1) {
            $scope.networkError = true;
          } else {
            $scope.networkError = false;
            if (response.data.object.length == 0) {
              return;
            }
            $scope.pro_book = response.data.object[0];
          }
        });
        // [0书1章2节3点] 2节
        $httpFactory.section.order_product(2, section.code).then(function (response) {
          if (response.data.object.length == 0) {
            return;
          }
          $scope.pro_section = response.data.object[0];
        })
      }

      /**
       * 支付选择
       */
      function toPayMenu() {
        if (!appv.currentUser) {
          $state.go('app.loginBefore');
          return;
        }
        //打开购买选项菜单
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/home/section/payMenu.html',
          scope: $scope
        });

        $scope.pay_choose_gold = pay_choose_gold;// 金币支付单知识点
        $scope.pay_choose_money = pay_choose_money;// 金钱支付全册
      }

      /**
       * 金币支付单知识点
       */
      function pay_choose_gold() {
        if (!$scope.pro_section.resList || $scope.pro_section.resList.length == 0) {
          $ionicLoading.show({template: '未找到产品'});
          return;
        }

        $httpFactory.section.order_gold({productCode: $scope.pro_section.resList[0].proCode}).then(success, function () {
          $scope.myPopup.close();// 支付失败,关闭弹窗
        });
        //支付成功回调
        function success(response) {
          if (response.data.result == 0) {
            $scope.myPopup.close();
            if ($scope.pro_section.resList.length > 0) {
              // knowPoint.isBuy = true;// 已购买
              $scope.pro_section.resList[0].status = 2;// 已购买
              section.status = 2;
            }
            $scope.unlock = true;// 解锁提示
            $scope.myPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              // cssClass: 'popup_clean',
              templateUrl: 'app/home/section/pay_success.html',
              scope: $scope
            });
            //完成支付
            $scope.finishPay = function () {
              $state.go('app.section');
              // openSection($scope.getColorEvent, section, chapter);
            }
          } else {
            $scope.myPopup.close();
            $scope.unlock = false;// 不解锁,金币不足
            $scope.message = response.data.message;
            $scope.myPopup = $ionicPopup.show({
              cssClass: 'myPopup',
              // cssClass: 'popup_clean',
              templateUrl: 'app/home/section/pay_prompt.html',
              scope: $scope
            });
          }
        }
      }

      /**
       * 金钱支付全册
       */
      function pay_choose_money() {
        $scope.myPopup.close();

        var page_param = {
          pro_name: $scope.pro_book.name,
          pro_price: $scope.pro_book.price,
          productCode: $scope.pro_book.code,
          pro_gold: $scope.pro_book.gold
        };

        // 打开选择付费方式
        PaymentFactory.openPayChoose($scope, page_param, function () {
          $scope.pro_book.resList[0].status = 2;// 已购买(解锁)
          $rootScope.openBook.status = 2; //已购买，更新课件页购买状态
          // $scope.myPopup_qr && $scope.myPopup_qr.close();

          $scope.myPopup.close();

          $scope.unlock = true;// 解锁提示
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            // cssClass: 'popup_clean',
            templateUrl: 'app/home/section/pay_success.html',
            scope: $scope
          });
          //完成支付
          $scope.finishPay = function () {
            $state.go('app.section');
            // openSection($scope.getColorEvent, section, chapter);
          }
        }, function () {
          $scope.myPopup.close();// 支付失败,关闭弹窗
        });

      }
    }

    /**
     * 涟漪效果 ripple
     */
    function animate_ripple() {
      return true;// 影响性能,暂时关闭
      $(".paper")
        .click(function (e) {
          var ripple = $(this).find(".ripple");
          ripple.removeClass("animate-ripple");
          var x = parseInt(e.pageX - $(this).offset().left) - (ripple.width() / 2);
          var y = parseInt(e.pageY - $(this).offset().top) - (ripple.height() / 2);
          ripple.css({
            top: y,
            left: x
          }).addClass("animate-ripple");
        })
    }

  }

})();
