/**
 * Created by Administrator on 2016/12/12 0012.
 */
(function () {
  'use strict'
  angular
    .module('starter')
    .controller('LiveCtrl',MainCtrl);

  function MainCtrl($scope,$ionicPopup,PaymentFactory,$ionicLoading,$state, $ionicHistory,$httpFactory,$rootScope){
    {
      initData();
      $scope.initData = initData;
      initIosPayOpen();
      $scope.openShare = openShare;
      $scope.share = share;
      $scope.payLive = payLive;
    }

    function initData(){
      $httpFactory.live.getInfo().then(function(res){
        if(res.status==-1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          if(res.data.result == 0 && res.data.object){
            $scope.liveInfo = res.data.object;
          }
        }
      });
    }

    function initIosPayOpen(){
      $scope.isIos = _app.isIos;
      //数据库不配置开关则默认关
      !$rootScope.ios_isPayChoose && ($scope.iosPayOpen = false);
      //ios系统且有开关配置情况下
      $scope.isIos && $rootScope.ios_isPayChoose && ($scope.iosPayOpen = $rootScope.ios_isPayChoose);
    }

    function openShare(){

      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }

      $scope.sharePopup = $ionicPopup.show({
        cssClass:'myPopup',
        templateUrl:'app/home/live/sharePopup.html',
        scope:$scope,
        anamite:'side-down-up'
      });
    }

    function share(type){
      $httpFactory.sys.config('shareApp').then(function (res) {
        if(res.data.result == 0){
          $scope.shareInfo = JSON.parse(res.data.object[0].value);
          checkInstall(type);
        }else{
          $ionicLoading.show({template:'没有获取到分享信息，请稍后再试'});
        }
      })
    }

    function checkInstall(type){
      $scope.shareInfo.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
      var title = $scope.shareInfo.params.title.replace('{{inviteCode}}', $scope.shareInfo.inviteCode);
      var description = $scope.shareInfo.params.description.replace('{{inviteCode}}', $scope.shareInfo.inviteCode);
      var thumb = $scope.shareInfo.params.thumb;
      var url = $scope.shareInfo.params.url;
      if(type=='qq'){
        //检测安装记录
        window.share.qq.installed().then(function(){
          //分享
          window.share.qq.shareToQzone(title,description,thumb,url).then(success,fail);
        },function(){
          $ionicLoading.show({template:'没有检测到QQ的安装记录 或 QQ版本太低'});
        });


      }
      if(type=='wechat'){
        //检测安装记录
        window.share.wechat.installed().then(function(){
          //分享
          window.share.wechat.shareTimeLine(title,description,thumb,url).then(success,fail);
        },function(){
          $ionicLoading.show({template:'没有检测到微信的安装记录 或 微信版本太低'});
        });
      }
    }

    function success(){
      $httpFactory.live.getPasswordShare().then(function(res){
        if(res.data.result == 0){
          $ionicLoading.show({template:'分享成功'});
          $scope.sharePopup.close();
          $scope.liveInfo.status = 2;
          $scope.liveInfo.livePassword = res.data.object.livePassword;
        }
      })
    }

    function fail(){
      $ionicLoading.show({template:'分享失败'});
    }

    function payLive(){
      // $scope.sharePopup.close();

      var page_param = {
        pro_name: $scope.liveInfo.product.name,
        pro_price: $scope.liveInfo.product.price,
        productCode: $scope.liveInfo.product.code
      };

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, page_param, function () {
        var data = {
          content:JSON.stringify({
            productCode: $scope.liveInfo.product.code
          })
        };
        $httpFactory.live.getPasswordPay(data).then(function(res){
          if(res.data.result==0 && res.data.object.status==2 && res.data.object.password){
            $ionicLoading.show({template:'支付成功'});
            $scope.myPopup.close();
            $scope.liveInfo.status = 2;
            $scope.liveInfo.livePassword = res.data.object.password;
          }
        });
      }, function () {
        $ionicLoading.show({template:'支付失败'});
      });
    }
  }
})();
