/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('MyWrongQuestionCtrl', MainController)
    .controller('WQ_questionAnalysisCtrl', WQ_questionAnalysisCtrl)


  /** 我的错题集 */
  function MainController($scope, $ionicHistory, $rootScope, $ionicScrollDelegate, $state, $httpFactory, $ionicLoading, $stateParams, RouteData) {
    /***** Controller ******/
    {
      $scope.hasNextPage = true;
      $scope.gotoTop = false;
      $scope.cacheView = true;
      $scope.dataList = [];
      var pageNo = 0;
      var nomPagesize = 10;
      var questionList = [];

      $scope.loadOlder = loadOlder;// 底部上拉：加载更多
      $scope.loadNew = loadNew;// 头部下拉：重新加载
      $scope.goQuestion = goQuestion;// 查解析
      $scope.navBack = navBack;

      // $scope.returnPage = $stateParams.returnPage;
      // if ($scope.returnPage == window._app.pageFinish) {
      //     window._appv.lastPage = window._app.pageFinish;
      // }
      // if ($scope.returnPage == window._app.pageUserCenter) {
      //     window._appv.lastPage = window._app.pageUserCenter;
      // }

    }

    /***** function ******/

    // 初始化数据
    function initData(callback) {
      $httpFactory.practice.myQuestionList(nomPagesize, pageNo).then(function (res) {
        if (res.data.result === 0) {
          if (!!res.data.object) {
            questionList = res.data.object;
            callback(questionList);
            $scope.canLoadNew = true;
          } else {
            $scope.canLoadNew = false;
            $scope.hasNextPage = false;
          }
        } else {
          $ionicLoading.show({template: res.data.message});
          $scope.hasNextPage = false;
          $scope.canLoadNew = true;
        }
      })
    }

    function goQuestion(index, question) {
      RouteData.questionAnalyDeleteIndex = null;
      RouteData.questionAnalyIndex = index;
      $state.go('app.wq_questionAnalysis', {question: question});
    }

    // 导航-返回
    function navBack() {
      $ionicHistory.goBack();
    }

    function loadOlder() {
      pageNo++;
      initData(function (olderData) {
        if (olderData.length < nomPagesize) {
          $scope.hasNextPage = false;
        }
        $scope.dataList = $scope.dataList.concat(olderData);
        $scope.emptyList = true;
        //存
        $scope.$broadcast('scroll.infiniteScrollComplete');
      })
    }

    function loadNew() {
      pageNo = 1;
      initData(function (newData) {
        if (newData.length < nomPagesize) {
          $scope.hasNextPage = false;
        } else {
          $scope.hasNextPage = true;
        }
        $scope.dataList = newData;
        $scope.$broadcast('scroll.refreshComplete');
      }, true);
    }

  }

  /** 查看错题 */
  function WQ_questionAnalysisCtrl($scope, $stateParams, $ionicPopup, $httpFactory, $ionicLoading, $timeout, $ionicHistory, RouteData) {
    /***** Controller ******/
    {
      $scope.question_root = $stateParams.question;
      $scope.questionsShow = $stateParams.question.question;
      // $scope.questionsShow.result = 74;
      $scope.delQuestion = delQuestion;
      $scope.questionError = questionError; //题目纠错
      $scope.viewbulr_close = viewbulr_close; //关闭模糊页
      $scope.suggestDialog = suggestDialog;
      $scope.navBack = navBack;
    }

    /***** function ******/
    function delQuestion() {
      $ionicPopup.confirm({
        title: "提示",
        template: "确认删除!",
        cancelText: "取消",
        okText: "确定",
        okType: "button-positive"
      }).then(function (res) {
        if (res) {
          $httpFactory.practice.myQuestionDel($stateParams.question.id).then(function (response) {
            if (response.data.result == 0) {
              RouteData.questionAnalyDeleteIndex = RouteData.questionAnalyIndex;
              $ionicHistory.goBack();
            } else {
              $ionicLoading.show({template: response.data.message});
            }
          });
        }
      });
    }

    /** 用户反馈**/
    function viewbulr_close() {
      $("._modal").css("display", "none");
      $("ion-content").removeClass("ws_view_blur");
      $(".button-bar").removeClass("ws_view_blur");
    }

    function suggestDialog() {
      $("._modal").css("display", "none");
      if (window.screen.height < 800) {
        $(".analysis_error_otherError").css("height", "200px");
      } else {
        $(".analysis_error_otherError").css("height", "350px");
      }
      $(".analysis_error_otherError").css("top", "17%");
      $(".suggest_other_corver").css("display", "");
      $timeout(function () {
        $("#suggestOther").focus();
      }, 1);
    }

    function questionError(id, type) {
      var message = $('#suggestOther').val();
      if (type == 4 ? !message || RegExp("^[ ]+$").test(message) : false) {       //为空、全部为空格，false
        $ionicLoading.show({template: "请填写意见"});
        return false;
      }
      $(".suggest_other_corver").css("display", "none");
      $("._modal").css("display", "none");
      $ionicLoading.show({
        template: ' <div class="analysis_error_background">' +
        '<ion-spinner icon="spiral" class="spinner-light" style="float: left"></ion-spinner>' +
        '<span style="font-size: 20px;">反馈提交中......</span></div>',
        noBackdrop: true
      });

      var content = {};
      content.userId = window._appv.currentUser.userId;
      if (type == window._app.questionError_answer) {
        content.suggest = ("[3]题目" + id + " ：答案有误");
      }
      else if (type == window._app.questionError_question) {
        content.suggest = ("[3]题目" + id + " ：题干有误");

      } else if (type == window._app.questionError_analysis) {
        content.suggest = ("[3]题目" + id + " ：解析有误");
      }
      else if (type == window._app.questionError_other) {
        var suggest = $("#suggestOther").val();
        content.suggest = ("[3]题目" + id + " ：" + suggest);
      }
      $timeout(function () {
        $httpFactory.user.feedback(content.userId, JSON.stringify(content))
          .then(function (result) {
            $ionicLoading.show({
              template: '' +
              '<div class="analysis_error_background">' +
              '<i class="ion-ios-checkmark-outline" style="padding-right: 15px;font-size: 24px;"></i>' +
              '<span style="font-size: 20px;">提交成功!</span></div>',
              noBackdrop: true
            });
            $timeout(function () {
              $ionicLoading.hide();
              viewbulr_close();
            }, 1000);
          })
      }, 2000);
    }

    function navBack() {
      $ionicHistory.goBack();
    }

    $scope.viewblur = function () {
      $("._modal").css("display", "");
      $("ion-content").addClass("ws_view_blur");
      $(".button-bar").addClass("ws_view_blur");
    }

    $scope.closeOther = function () {
      $(".suggest_other_corver").css("display", "none");
      $("._modal").css("display", "");
    }

    $scope.dialogBack = function () {
      $(".analysis_error_otherError").css("top", "");
    }

    $scope.dialogUp = function () {
      $(".analysis_error_otherError").css("top", "17%");
    }
  }
})();
