/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SectionCtrl', MainController)

  function MainController($scope, $rootScope, $ionicPopup, localStorageService, $httpFactory, RouteData, $ionicNavBarDelegate, $state, AppFactory, $ionicLoading, PaymentFactory, $cordovaFile, $timeout, $cordovaFileTransfer) {

    {
      if (window.cordova && cordova.InAppBrowser) {
        window.open = cordova.InAppBrowser.open;
      }

      // var openSection = localStorageService.get('openSection');// 打开-节(本地存储)
      var openSection = RouteData.section.openSection;
      $scope.oldlocalSection = localStorageService.get("openSection");
      localStorageService.set("openSection", openSection);         //新的节信息存入本地
      openSection.knowPoints.sort(function (item, item2) {
        return (item.name == '本节总结') ? 1 : (item2.name == '本节总结') ? -1 : 0; // 本章总结最后
      });
      $scope.openSection = openSection;
      $scope.openBook = localStorageService.get('openBook');// 打开-分册

      $('.bar.bar-stable').css('background-color', $scope.openSection.color);// 设置主题色
      !_app.isWeb && StatusBar.backgroundColorByHexString($scope.openSection.color);

      var rootPath;      //设置缓存目录
      _app.isAndroid && (rootPath = cordova.file.externalDataDirectory);      //安卓目录
      _app.isIos && (rootPath = cordova.file.documentsDirectory);          //ios目录

      $scope.shareExp = shareExp;// 分享实验
      $scope.shareApp = shareApp;// 分享软件
      $scope.f_openPoint = f_openPoint;//  打开知识点
      $scope.f_points_read = f_points_read;// 已读知识点(关闭内嵌浏览器时触发)
      $scope.toPractice = toPractice;// 节练习
      $scope.toPayMenu = toPayMenu;// 购买选择
      $scope.clickPlay = clickPlay;// 点击播放按钮

      $scope.refresh = refresh;
      initPro();// 初始化节产品(视频播放)
      initPracticeOpen();
      initSectionShow();// 初始化节信息(含外部链接)
    }

    function uploadProgress(type) {
      var codeList = openSection.progressCode.split('#');
      if (codeList[type] == 1) {
        return;
      }
      codeList[type] = 1;
      var progressCode = codeList[0] + '#' + codeList[1] + '#' + codeList[2];

      openSection.progressCode = progressCode;        //重新给当前域的章节完成进度赋值
      localStorageService.set("openSection", openSection);         //新的节信息存入本地
      RouteData.section.openSection.progressCode = progressCode;        //重新给当前域的章节完成进度赋值
      var data = {
        content: JSON.stringify({
          knowCode: openSection.code,
          statusCode: progressCode
        })
      };
      $httpFactory.main.uploadProgress(data).then(function (res) {
        if (res.data.result == 0) {
          // $rootScope.initFormData();
          //刷新课件页进度
          for (var i = 0; i < $rootScope.books.length; i++) {
            var dataBook = $rootScope.books[i];               //获取课本
            var openBook = localStorageService.get('openBook');
            if (dataBook.code == openBook.code) {

              for (var j = 0; j < dataBook.knowPoints.length; j++) {
                var dataChapter = dataBook.knowPoints[j];           //获取章
                if (dataChapter.code == openSection.parentCode) {

                  for (var k = 0; k < dataChapter.knowPoints.length; k++) {
                    var dataSection = dataChapter.knowPoints[k];        //获取节
                    if (dataSection.code == openSection.code) {

                      $rootScope.books[i].knowPoints[j].knowPoints[k].progressCode = progressCode;
                      $rootScope.books[i].knowPoints[j].knowPoints[k].progressSum++;
                      updateBookProgress($rootScope.books[i]);
                    }
                  }
                }
              }
            }
          }
        }
      });
    }

    function updateBookProgress(book) {
      var sectionList = [];
      var chapter = book.knowPoints;

      for (var i = 0; i < chapter.length; i++) {
        var section = chapter[i].knowPoints;
        sectionList = sectionList.concat(section);
      }
      var sum = 0;
      for (var j = 0; j < sectionList.length; j++) {
        sectionList[j].progressSum == 3 ? sum++ : 1;
      }
      var bookProgress = Math.floor(sum / sectionList.length * 100);
      book.bookProgress = bookProgress;
    }

    function refresh() {
      initPro();// 初始化节产品(视频播放)
      initPracticeOpen();
      initSectionShow();// 初始化节信息(含外部链接)
    }

    function initPro() {

      // [0书1章2节3点] 0书
      $httpFactory.section.order_product(0, $scope.openBook.code).then(function (response) {
        if (response.status == -1) {
          $scope.networkError = true;
        } else {
          $scope.networkError = false;
          if (response.data.object.length == 0) {
            return;
          }
          $scope.pro_book = response.data.object[0];
        }
      });

      // [0书1章2节3点] 2节
      $httpFactory.section.order_product(2, $scope.openSection.code).then(function (response) {
        if (response.data.object.length == 0) {
          return;
        }
        $scope.pro_section = response.data.object[0];
        if ($scope.pro_section && $scope.pro_section.resList[0] && $scope.pro_section.resList[0].url) {
          $scope.pro_section.resList[0].url = http2https($scope.pro_section.resList[0].url);
        }

      })
    }


    /**
     * 初始化练兵开关
     */
    function initPracticeOpen() {
      var practiceOpen = localStorageService.get("practiceOpen", $scope.practiceOpen);
      practiceOpen && ($scope.practiceOpen = practiceOpen);
      $httpFactory.sys.config('practiceOpen').then(function (res) {
        if (res.data.result == 0) {
          if (res.data.object[0].value == 'true') {
            $scope.practiceOpen = true;
          } else {
            $scope.practiceOpen = false;
          }
          localStorageService.set("practiceOpen", $scope.practiceOpen);
        }
      });
    }

    /**
     * 点击播放按钮
     * */
    function clickPlay() {
      var el_video = document.querySelector('video');
        document.querySelector('.banner_pic').style.display = 'none';
        document.querySelector('.mask').style.display = 'none';
        document.querySelector('.playIcon').style.display = 'none';

      uploadProgress(_app.progress_video);    //更新视频完成进度
      el_video.style.display = 'block';
      el_video.play();
    }

    /**
     * 支付选择
     */
    function toPayMenu() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }

      $scope.isIOS = _app.isIos;
      $scope.ios_isPayChoose = $rootScope.ios_isPayChoose;

      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/home/section/payMenu.html',
        scope: $scope
      });

      $scope.pay_choose_gold = pay_choose_gold;// 金币支付单知识点
      $scope.pay_choose_money = pay_choose_money;// 金钱支付全册

    }

    /**
     * 金币支付单知识点
     */
    function pay_choose_gold() {

      if ($scope.pro_section.resList.length == 0) {
        $ionicLoading.show({template: '未找到产品'});
        return;
      }

      $httpFactory.section.order_gold({productCode: $scope.pro_section.resList[0].proCode}).then(success, failed);

      function success(response) {
        if (response.data.result == 0) {
          $scope.myPopup.close();
          if ($scope.pro_section.resList.length > 0) {
            $scope.pro_section.resList[0].status = 2;// 已购买
          }
          // $ionicLoading.show({template: '已解锁,请观看'});
          $scope.unlock = true;// 解锁提示
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            // cssClass: 'popup_clean',
            templateUrl: 'app/home/section/pay_prompt.html',
            scope: $scope
          });
        } else {
          $scope.myPopup.close();

          $scope.unlock = false;// 不解锁,金币不足
          $scope.message = response.data.message;
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            // cssClass: 'popup_clean',
            templateUrl: 'app/home/section/pay_prompt.html',
            scope: $scope
          });
        }
      }

      function failed(response) {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      }
    }

    /**
     * 金钱支付全册
     */
    function pay_choose_money() {
      $scope.myPopup.close();

      var page_param = {
        pro_name: $scope.pro_book.name,
        pro_price: $scope.pro_book.price,
        productCode: $scope.pro_book.code
      };

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, page_param, function () {
        $scope.pro_book.resList[0].status = 2;// 已购买(解锁)
        $scope.myPopup_qr && $scope.myPopup_qr.close();

        $scope.myPopup.close();

        $scope.unlock = true;// 解锁提示
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          // cssClass: 'popup_clean',
          templateUrl: 'app/home/section/pay_prompt.html',
          scope: $scope
        });
      }, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });

    }

    /**
     * 分享软件
     */
    function shareApp() {

      if ($scope.share) {
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/app/shareApp.html',
          scope: $scope
        });
        return;
      }

      $httpFactory.sys.config('shareApp').then(function (response) {
        shareApp_handle(response);
      });

      function shareApp_handle(response) {

        $scope.share = JSON.parse(response.data.object[0].value);
        $scope.share.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
        $scope.share.params.title = $scope.share.params.title.replace('{{inviteCode}}', $scope.share.inviteCode);
        $scope.share.params.description = $scope.share.params.description.replace('{{inviteCode}}', $scope.share.inviteCode);

        for (var i in $scope.share.items) {
          f_isInstall($scope.share.items[i]);
        }

        setTimeout(function () {
          $scope.$apply();
        }, 500);// 脏检查

        $scope.f_share = f_share;// 分享
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/app/shareApp.html',
          scope: $scope
        });

        function f_isInstall(item) {
          if (_app.isWeb) {
            item.isInstall = 1;
            return;
          }

          switch (item.name) {
            case 'Qzone':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'wechatTimeline':
              $scope.isInstall_wechat().then(success, fail);
              return true;
            case 'weibo':
              $scope.isInstall_weibo().then(success, fail);
              return true;
            case 'qq':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'wechat':
              $scope.isInstall_wechat().then(success, fail);
              return true;
          }

          function success(response) {
            item.isInstall = response;
          }

          function fail(failResponse) {
            console.log(failResponse);
          }
        }

        function f_share(item, params) {

          switch (item.name) {
            case 'Qzone':
              $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
              return true;
            case 'wechatTimeline':
              $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
              return true;
            case 'weibo':
              $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
              return true;
            case 'qq':
              $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
              return true;
            case 'wechat':
              $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
              return true;
          }

          function success(response) {
            console.log('分享成功', response);
          }

          function fail(failResponse) {
            console.log('分享失败', failResponse);
          }
        }
      }
    }

    /**
     * 分享实验
     * @param point
     */
    function shareExp() {
      if (_app.isWeb) {
        $rootScope.hasQQ = true;
        $rootScope.hasWechat = true;
      }

      $scope.share = {
        inviteCode: appv.currentUser && appv.currentUser.inviteCode,
        items: [
          {imgSrc: 'img/icon/qq.min.png', name: 'qq', goldNum: 5, isInstall: $rootScope.hasQQ},
          {imgSrc: 'img/icon/qzone.png', name: 'Qzone', goldNum: 10, isInstall: $rootScope.hasQQ},
          {imgSrc: 'img/icon/wechat.min.png', name: 'wechat', goldNum: 5, isInstall: $rootScope.hasWechat},
          {imgSrc: 'img/icon/wechatTimeline.png', name: 'wechatTimeline', goldNum: 10, isInstall: $rootScope.hasWechat},
        ],

        params: {
          title: $scope.openSection.name,
          description: $scope.openSection.name,
          thumb: 'https://kexue.saixueba.com/resources/' + $scope.openSection.pic,
          url: 'https://kexue.saixueba.com/share_experiment/share.html?code=' + $scope.openSection.code
        },
        remark: ""
      };

      //通过软件初始化时的`$rootScope.has`判断
      for (var i in $scope.share.items) {
        f_isInstall($scope.share.items[i]);
      }

      $scope.f_share = f_share;// 分享
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareExp.html',
        scope: $scope
      });

      function f_isInstall(item) {
        item.isInstall = 1;// 默认存在,失效时隐藏

        if (_app.isWeb) {
          return;
        }

        switch (item.name) {
          case 'Qzone':
            $rootScope.isInstall_qq().then(success, fail);
            break;
          case 'wechatTimeline':
            $rootScope.isInstall_wechat().then(success, fail);
            break;
          case 'weibo':
            $rootScope.isInstall_weibo().then(success, fail);
            break;
          case 'qq':
            $rootScope.isInstall_qq().then(success, fail);
            break;
          case 'wechat':
            $rootScope.isInstall_wechat().then(success, fail);
            break;
          default:
            break;
        }

        function success(response) {
          item.isInstall = 1;
          $scope.$apply();
        }

        function fail(failResponse) {
          item.isInstall = 0;
          console.log(failResponse);
          $scope.$apply();
        }
      }

      function f_share(item, params) {

        switch (item.name) {
          case 'Qzone':
            $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechatTimeline':
            $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'weibo':
            $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'qq':
            $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
          case 'wechat':
            $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
            return true;
        }

        function success(response) {
          console.log('分享成功', response);
        }

        function fail(failResponse) {
          console.log('分享失败', failResponse);
        }
      }
    }

    /**
     * 初始化已读(知识点)
     * @returns {Array}
     */
    function initRead() {
      var points_read = [];
      if (!!localStorageService.get('points_read')) {
        points_read = localStorageService.get('points_read');
        $scope.points_read = points_read;
      }
      localStorageService.bind($scope, 'points_read');// 本地存储绑定
      return points_read;
    }

    /**
     * 初始化节信息(含外部链接)
     * @param points_read
     */
    function initSectionShow() {

      // 借助上次缓存,快速显示
      // localStorageService.get('openSection[' + $scope.openSection.code + ']_points') && ($scope.points = localStorageService.get('openSection_points'));

      // appv.currentUser &&
      $httpFactory.section.getPoints($scope.openSection.code).then(function (response) {

        response.data && ($scope.points = response.data.object[0].knowPoints);

        if (true) {
          var knowPoints = response.data.object[0].knowPoints;// 替换为后端知识点

          knowPoints.sort(function (item, item2) {
            return (item.name == '本节总结') ? 1 : (item2.name == '本节总结') ? -1 : 0; // 本章总结最后
          });
          $scope.openSection.knowPoints = knowPoints;
        } else {
          // 同步已读信息与实验信息 (版本上线前,暂存)
          var rp_points = response.data.object[0].knowPoints;
          for (var i in $scope.openSection.knowPoints) {
            var point = $scope.openSection.knowPoints[i];
            point.knowExpList = rp_points[i].knowExpList;
          }
        }
      });
    }

    /**
     * 打开知识点
     * @param point
     */
    function f_openPoint(point, index) {
      f_openPoint_hanlder(point, index);
    }

    function f_openPoint_hanlder(point, index) {
      var webUrl = point.knowExpList[0].exp.webURL;     //后台提取的地址
      webUrl = http2https(webUrl);

      if (_app.isWeb) {
        window.open(webUrl, '_blank', 'location=no,immersion=yes,toolbar=no');
        return;
      }

      var immersion = '';
      if (_app.isAndroid && navigator.userAgent.indexOf('PAD') < 0) {
        immersion = ',immersion=yes';
      }
      //,hidden=yes
      var web = window.open(webUrl, '_blank', 'location=no,toolbar=no,hidden=yes' + immersion); // cordova-plugin-inappbrowser
      !_app.isWeb && window.screen.orientation.lock("landscape");// 横屏进入,避免自适应排版问题

      // 10s如还没有打开,则恢复横屏.
      setTimeout(function () {
        if (!web.isShow) {
          web.close();
          !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
          web.isClose = true;
        }
      }, 10 * 1000);

      if (web) {
        web.addEventListener('loadstart', iabLoadStart);             //html页面加载前进行iabLoadStart函数操作
        web.addEventListener('loadstop', isLoadstop);             //html页面加载后进行iabLoadStop 函数操作
        // web.addEventListener('loaderror', iabLoadError);           //html页面加载错误时进行iabLoadError 函数操作
        web.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作
        web.addEventListener('mycmd', mycmd);                      //html页面关闭后进行iabClose 函数操作

        $scope.web = web;// 绑定到页面提供页面关闭功能
      }

      var startTime;

      function iabLoadStart(event) {
        startTime = +new Date();
      }

      function isLoadstop() {
        isLoadstop_handle();
      }

      function isLoadstop_handle() {
        if (web.isClose) {
          return;
        }

        // $ionicNavBarDelegate.showBar(true);
        $scope.$apply();

        web.show();// 显示窗口
        web.isShow = true;
        document.querySelector('video').pause();// 暂停视频

      }

      function iabClose(event) {
        !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
        appv.currentUser && uploadProgress(_app.progress_exp);      //更新实验完成进度
      }

      function mycmd(cmd) {
        var cmd = cmd.args.split(':');

        switch (cmd[0]) {
          case 'close':
            web.close();
            web = null;
            return true;
          case 'loadstop':
            isLoadstop_handle();
            return true;
        }
      }


    }

    /**
     * 已读知识点(关闭内嵌浏览器时触发)
     * @param point
     */
    function f_points_read(point) {
      if (point.knowExpList == null || point.knowExpList.length == 0) {
        point.knowExpList = [{'isRead': 1}];
        $scope.$apply();
        return;
      }

      point.knowExpList[0].isRead = 1;
      $scope.$apply();
      point.knowExpList[0].expCode && appv.currentUser && $httpFactory.section.expRead(point.knowExpList[0].expCode);
    }

    /**
     * 节练习
     */
    function toPractice() {

      $state.go('app.practice');
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }

  }

})();
