/**
 * Created by white 2017-05-03.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('learningCtrl', MainController)


  function MainController($scope, $state, localStorageService, RouteData, $httpFactory,
     $ionicHistory, $rootScope, SelfFactory) {
    console.time('learningCtrl');

    {
      $scope.currentUser = window.appv.currentUser;
      $scope.showAllMyClass = true;
      $scope.showVideo = true;
      $scope.navBack = navBack;

      getUserInfo();
      //初始化从入门到精通
      getMyClass();
      $scope.goMyClass = goMyClass;
      // 查看视频
      init();
      $scope.spClick = spClick;
      $scope.videoClick = videoClick;

      $rootScope.reload_SpecialCtrl = function () {
        init();
      }
    }

    function getUserInfo() {
      $httpFactory.user.userLearningInfo().then(function (res) {
        if (res.data.result == 0) {
          $scope.allDays = res.data.object.allDays;
          $scope.continueDays = res.data.object.continueDays;
          $scope.rightQuestion = res.data.object.rightQuestion;
          $scope.allQuestion = res.data.object.allQuestion;
          // 正确率
          if ($scope.rightQuestion == 0 || $scope.allQuestion == 0) {
            $scope.rightPercent = 0;
          } else {
            $scope.rightPercent = parseInt($scope.rightQuestion / $scope.allQuestion * 100) + "%";
          }
        }
      });
    }

    function getMyClass() {
      $httpFactory.user.myClass().then(function (res) {
        if (res.data.result == 0) {
          // $scope.myClassList = res.data.object;
          $scope.myClassList = [];
          for (var i in res.data.object) {
            if (res.data.object[i].status == 2) {//status 购买状态
              res.data.object[i].homePic = http2https(res.data.object[i].homePic);
              $scope.myClassList.push(res.data.object[i]);
            }
          }
        }
      });
    }

    function navBack() {
      $ionicHistory.goBack();
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }

    function goMyClass(item) {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      //原接口
      RouteData.masterVideo = item;
      $state.go('app.masterVideo');
    }


    function spClick(index) {
      $scope._active = index;
      var target = $($('.ion-chevron-right').get(index - 1));
      if (!!$scope.before && $scope.beforeIndex != index) {
        $($scope.before).removeClass('arrow_rotate');
      }
      $scope.before = target;
      $scope.beforeIndex = index;

      if (!!target.hasClass('arrow_rotate')) {
        target.removeClass('arrow_rotate');
        $scope.showVideo = false;
      } else {
        target.addClass('arrow_rotate');
        $scope.showVideo = true;
      }

      SelfFactory.redrawPage();     //重绘页面
    }

    function init() {

      /*----------------获取分类-------------------*/
      var specialsLocal = localStorageService.get('specials');      // 本地存储直取
      specialsLocal && ($scope.specials = specialsLocal);
      $httpFactory.special.spec().then(function (response) {        // 服务端获取更新
        if (response.status == -1) {
          $scope.networkError = true;
        } else {
          $scope.networkError = false;
          $scope.specials = response.data.object;
          localStorageService.set('specials', response.data.object);
        }
      })

      /*----------------获取视频-------------------*/
      // 本地存储直取
      var videosLocal = localStorageService.get('videos');            // 本地获取
      videosLocal && ($scope.videos = videosLocal);
      var specialJson = {};
      $httpFactory.special.video().then(function (response) {         // 服务端获取更新
        $scope.videoArr1 = [];
        $scope.videoArr2 = [];
        $scope.videoArr3 = [];
        $scope.videoArr4 = [];
        $scope.videoArr5 = [];
        // 更新示例图片
        for (var index in response.data.object) {
          var item = response.data.object[index];
          specialJson[item.categoryType] = true;
          specialJson[item.specCode] = true;
          if (item.status == 2) {
            if (item.categoryType == 1) {
              $scope.videoArr1.push(item);
            } else if (item.categoryType == 2) {
              $scope.videoArr2.push(item);
            } else if (item.categoryType == 3) {
              $scope.videoArr3.push(item);
            } else if (item.categoryType == 4) {
              $scope.videoArr4.push(item);
            } else if (item.categoryType == 5) {
              $scope.videoArr5.push(item);
            }
          }
        }
        if ($scope.videoArr1.length > 0
          || $scope.videoArr2.length > 0
          || $scope.videoArr3.length > 0
          || $scope.videoArr4.length > 0
          || $scope.videoArr5.length > 0
          || $scope.myClassList.length > 0) {
          $scope.showAllMyClass = true;
        } else {
          $scope.showAllMyClass = false;
        }
        $scope.specialJson = specialJson;

        $scope.videos = response.data.object;
        localStorageService.set('videos', response.data.object);
        $scope.dataCloak = true;// 完成数据载入
        SelfFactory.redrawPage();     //重绘页面
      })
    }

    function videoClick(specRes) {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }

      RouteData.special_vedeo = {specResCode: specRes.code};
      localStorageService.set('specialVedeo_specResCode', specRes.code);// 本地存储-节
      $state.go('app.special_vedeo');// 直播视频
    }


  }
})();
