/**
 * Created by Administrator on 2016/8/17.
 */
(function() {
  'use strict';

  angular.module('starter').factory('LoginFactory', MainFactory);

  function MainFactory(
    $ionicModal,
    $httpFactory,
    $timeout,
    $ionicLoading,
    $ionicPlatform,
    $state,
    RegUtil,
    $interval,
    $rootScope,
    $http,
    localStorageService,
    $ionicHistory,
    AppFactory
  ) {
    function initLoginModal($scope) {
      var global = {};
      {
        initModal();
        initCanRegister();
        checkIosPage(); //ios独有样式
        initKeyboardListener();

        $scope.login = login;
        $scope.closeLogin = closeLogin;
        $scope.navBack = navBack;
        $scope.doLogin = doLogin;
        $scope.sendCode = sendCode;
        $scope.text = '发送';
        $scope.second = 60;
        $scope.changeLogin = changeLogin;
        $scope.reDraw = reDraw;

        refreshLoginInfo();
        $scope.refreshLoginInfo = refreshLoginInfo;

        $scope.directLogin = directLogin;
      }

      function initCanRegister() {
        if ($ionicPlatform.is('ios')) {
          $httpFactory.sys.config('msg_open').then(function(res) {
            if (res.data.result == 0) {
              res.data.object[0].value === 'true' ? true : false;
            } else {
              $scope.canRegister = false;
            }
          });
        }
      }

      function navBack() {
        $state.go('app.loginBefore');
        closeLogin();
      }

      function directLogin() {
        $state.go('app.table.home');
        closeLogin();
      }

      function initKeyboardListener() {
        if (_app.isIos) {
          window.addEventListener('native.keyboardshow', keyboardShowHandler);
          window.addEventListener('native.keyboardhide', keyboardHideHandler);
        }
      }

      function keyboardShowHandler(e) {
        console.log('keyboard is show');
        $scope.returnHeight = $scope.returnHeight
          ? $scope.returnHeight
          : $('#loginModal').height();
        $('.third_div_all').css('display', 'none');
        $('.noteData_ps_div').css('display', 'none');
        $('.cash_ps_div').css('display', 'none');
        $('.cash_button').css('display', 'none');
      }

      function keyboardHideHandler(e) {
        console.log('keyboard is hide:' + new Date());
        if (!$('input').is(':focus')) {
          $timeout(function() {
            $('.third_div_all').css('display', '');
            $('.noteData_ps_div').css('display', '');
            $('.cash_ps_div').css('display', '');
            $('.cash_button').css('display', '');
          }, 200);
        }

        //$timeout(function(){
        //  $("ion-content").css('display', 'none');
        //  document.body.offsetWidth;// 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
        //  $("ion-content").css('display', '');
        //},500);
      }

      //重绘页面
      function reDraw() {
        console.log('lost blur:' + new Date());
        //document.body.offsetWidth;
        // 对面板强行重绘
        //$timeout(function(){
        //  $("ion-content").css('display', 'none');
        //  document.body.offsetWidth;// 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
        //  $("ion-content").css('display', '');
        //},500);
      }

      function checkIosPage() {
        if (_app.isIos) {
          $scope.isIosPage = true;
        }
      }

      function refreshLoginInfo() {
        //苹果审核 账号登录优先,其他手机优先
        $scope.isOneLogin =
          $rootScope.isIos && !$rootScope.ios_isPayChoose ? false : true;
        $scope.userInfo = appv.currentUser;
        $scope.inviteCode = appv.currentUser
          ? appv.currentUser.inviteCode
          : null;
        $scope.bookGold = appv.bookGold;
        $scope.loginData = {};
        $scope.mobileLogin = {};
        $scope.isLogin = appv.currentUser ? true : false;
        checkRedInfo();
      }

      function initModal() {
        // 初始化弹窗模板
        $ionicModal
          .fromTemplateUrl('app/login/login.html', {
            scope: $scope,
            animation: 'slide-in-up'
          })
          .then(function(modal) {
            $scope.modal = modal;
          });

        // //当我们用完模型时，清除它！
        // $scope.$on('$destroy', function () {
        //   $scope.modal.remove();
        //   window.isLoginShow = false;
        // });
        // // 当隐藏模型时执行动作
        // $scope.$on('modal.hide', function () {
        //   // 执行动作
        //   window.isLoginShow = false;
        // });
        // // 当移动模型时执行动作
        // $scope.$on('modal.removed', function () {
        //   // 执行动作
        //   window.isLoginShow = false;
        // });
      }

      function changeLogin() {
        !_app.isWeb && cordova.plugins.Keyboard.close();
        $scope.returnHeight && $('#loginModal').height($scope.returnHeight);
        $scope.isOneLogin = !$scope.isOneLogin;
        if ($scope.isOneLogin) {
          $('h1.title').text('一键登录');
        } else {
          $('h1.title').text('用户名登录');
        }
      }

      // 隐藏登录弹窗
      function closeLogin() {
        $scope.modal.hide();
      }

      // Open the login modal
      function login() {
        $scope.modalHeight = {
          height: $('ion-modal-view').height() - 54 + 'px'
        };
        $scope.modal.show();
        // $ionicHistory.clearHistory();// 删除历史
      }

      //登录
      function doLogin() {
        //一键登录
        if ($scope.isOneLogin) {
          var mobile = $scope.mobileLogin.mobile;
          var code = $scope.mobileLogin.code;
          if (!checkOneLogin(mobile, code)) {
            return;
          }
          var data = {
            content: JSON.stringify({
              mobile: mobile,
              imei: getImei(),
              authCode: code
            })
          };
          $httpFactory.login.oneLogin(data).then(function(res) {
            afterLogin(res);
          });
        }
        //普通登录
        else {
          var loginName = $scope.loginData.loginName;
          var password = $scope.loginData.password;
          if (!checkNormalLogin(loginName, password)) {
            return;
          }
          var data = {
            content: JSON.stringify({
              loginName: loginName,
              imei: getImei(),
              password: password
            })
          };
          $httpFactory.login.normal(data).then(function(res) {
            afterLogin(res);
          });
        }
      }

      function checkOneLogin(mobile, code) {
        if (!mobile) {
          $ionicLoading.show({ template: '请输入手机号' });
          return false;
        }
        if (!RegUtil.mobile(mobile)) {
          return false;
        }
        if (!code) {
          $ionicLoading.show({ template: '请输入验证码' });
          return false;
        }
        return true;
      }

      function checkNormalLogin(loginName, password) {
        if (!loginName) {
          $ionicLoading.show({ template: '请输入用户名' });
          return false;
        }
        if (!password) {
          $ionicLoading.show({ template: '请输入密码' });
          return false;
        }
        return true;
      }

      function checkRedInfo() {
        //查询红点信息
        appv.currentUser &&
          $httpFactory.user.redInfo().then(function(res) {
            if (res.data.result == 0) {
              $rootScope.redInfo = res.data.object.object;
            }
          });
      }

      function afterLogin(res) {
        if (res.data.result == 0) {
          $ionicLoading.show({ template: '登录成功！' });
          appv.bookGold = res.data.object.bookGold;
          if(res.data.object.user.icon1){
            res.data.object.user.icon1 = http2https(res.data.object.user.icon1);
          }
          appv.currentUser = res.data.object.user;
          appv.token = res.data.object.token;

          $httpFactory.setToken(res.data.object.token);
          localStorageService.set('token', appv.token);
          localStorageService.set('currentUser', appv.currentUser);
          localStorageService.set('bookGold', appv.bookGold);
          $scope.userInfo = appv.currentUser;
          $scope.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
          $scope.bookGold = appv.bookGold;
          $scope.isLogin = true;

          $interval.cancel(global.timeStop);
          $scope.text = '发送';
          $scope.second = 60;
          $scope.color = {};

          //头像本地缓存
          var img = appv.currentUser.icon1;
          AppFactory.img2Base64('saixueba.userIcon', img);

          $timeout(function() {
            $scope.closeLogin();
          });
          //查询红点信息
          checkRedInfo();

          $httpFactory.everyDaySign().then(function(res) {
            if (res.data.object) {
              $scope.loginGold = res.data.object.addGold;
            }
          }); // 自动签到(场景:游客或用户A切换用户B登录)

          /** 刷新table数据 */
          $rootScope.reload_SpecialCtrl && $rootScope.reload_SpecialCtrl();
          $rootScope.initFormData && $rootScope.initFormData();

          //页面跳转
          $state.go('app.table.home');

          //手机验证码登录，弹窗提示修改密码
          if ($scope.isOneLogin) {
          }
        }
        //登录失败
        else {
          $ionicLoading.show({ template: res.data.message });
        }
      }

      function http2https(url) {
        if (url && url.startsWith("http") && !url.startsWith("https")) {
          // http 转为 https
          url = url.replace("http", "https");
        }
        return url;
      }

      //发送验证码
      function sendCode() {
        //检查
        var mobile = $scope.mobileLogin.mobile;
        if (!mobile) {
          $ionicLoading.show({ template: '请输入手机号码！' });
          return;
        }
        if (!RegUtil.mobile(mobile)) {
          return;
        }

        //发送验证码
        var data = {
          content: JSON.stringify({
            mobile: mobile,
            type: 3
          })
        };
        $httpFactory.login.getCode(data).then(function(res) {
          if (res.data.result == 0) {
            $ionicLoading.show({ template: res.data.message });
            //倒计时
            var timeStop = $interval(function() {
              if ($scope.second <= 0) {
                $interval.cancel(timeStop);
                $scope.text = '发送';
                $scope.second = 60;
                $scope.color = {};
              } else {
                $scope.text = '已发送(' + $scope.second + ')';
                $scope.color = { color: '#959595' };
                $scope.second--;
              }
            }, 1000);
            global.timeStop = timeStop;
          } else {
            $ionicLoading.show({ template: res.data.message });
          }
        });
      }

      function getImei() {
        var imei = '';
        if (_app.isAndroid || _app.isIos) {
          imei = device.uuid;
        }
        if (_app.isAndroid) {
          umengService.init({ args: 'init' });
        }
        return imei;
      }
    }

    var service = {
      initLoginModal: initLoginModal
    };
    return service;
  }
})();
