/**
 * Created by white 2017-05-03.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('LoginBeforeCtrl', LoginBeforeCtrl);

  function LoginBeforeCtrl($httpFactory, $scope, $timeout, $ionicLoading, $state, $rootScope, $http, localStorageService, AppFactory) {
    console.time('LoginBeforeCtrl');

    {
      $scope.iosPayOpen = $rootScope.ios_isPayChoose;//是否打开支付
      $scope.isIos = $rootScope.isIos;//是否为ios设备
      $scope.byYourself = byYourself;
      $scope.toLogin = toLogin;
      $scope.loginQQ = loginQQ;
      $scope.loginWechat = loginWechat;
    }

    function byYourself() {
      $state.go("app.table.home");
    }

    function toLogin() {
      $rootScope.login();
    }

    function loginQQ() {
      $ionicLoading.show({
        template: '<ion-spinner icon="ios-small"></ion-spinner><span>正在打开...</span>',
        duration: 2000
      });
      $rootScope.auth_qq().then(function (res) {
        var qqLink = 'https://graph.qq.com/';
        var token = res.access_token;
        var openid = res.userid;// TODO userid即openid,配合appid就能直接调用`user/get_user_info`,无需调用`oauth2.0/me?access_token`
        // var app_id = '1105715294';
        // alert(JSON.stringify(res));
        $http.get(qqLink + 'oauth2.0/me?access_token=' + token + '&unionid=1').then(function (res) {
          //截取openid段数据
          res = JSON.stringify(res);
          var firstworld = res.indexOf("(");
          var lastworld = res.lastIndexOf(')');
          var data = JSON.parse((res.substring(firstworld + 1, lastworld)).replace(/\\/g, ""));
          //赋值
          var access_token = token;
          var openid = data.openid;
          var app_id = data.client_id;
          var unionid = data.unionid;
          // alert(JSON.stringify(res));

          $http.get(qqLink + 'user/get_user_info?access_token=' + token + '&oauth_consumer_key=' + app_id + '&openid=' + openid).then(function (res) {
            // alert(JSON.stringify(res));
            var data = {
              content: JSON.stringify({
                nickName: res.data.nickname,
                icon1: res.data.figureurl_qq_1,
                sex: res.data.gender == '男' ? 'male' : 'female',
                openId: openid,
                unionid: unionid,
                imei: getImei(),
                logo: 2
              })
            };
            $httpFactory.login.thirdLogin(data).then(function (res) {
              afterLogin(res);
            });
          }, function (res) {
            // alert('error:' + JSON.stringify(res));
          });
        });
      }, function (error) {
        // alert("error", error);
      });
    }

    function loginWechat() {
      $ionicLoading.show({
        template: '<ion-spinner icon="ios-small"></ion-spinner><span>正在打开...</span>',
        duration: 2000
      });
      $rootScope.auth_wechat().then(function (response) {
        // alert('auth:' + response);
        response = JSON.parse(response);
        var wechatLink = 'https://api.weixin.qq.com/sns';// 必须使用https请求方式: https://mp.weixin.qq.com/wiki?t=resource/res_main&id=mp1421140840&token=&lang=zh_CN
        var APPID = "wx053be7b51c59b5a7";
        var CODE = response.code;
        var SECRET = "ca6fcdc7e8a48d1ed94e52aae02c0a0c";
        var authorization_code = "authorization_code";


        $http.get(wechatLink + '/oauth2/access_token' + "?appid=" + APPID + "&secret=" + SECRET + "&code=" + CODE + "&grant_type=" + authorization_code).then(function (res) {
          // alert("oauth2/access_token：" + JSON.stringify(res));
          var token = res.data.access_token;
          var openId = res.data.openid;
          var unionid = res.data.unionid;
          $http.get(wechatLink + '/userinfo?access_token=' + token + "&openid=" + openId).then(function (res) {
            // alert("userinfo?access_token：" + JSON.stringify(res));
            //alert(res);
            var data = {
              content: JSON.stringify({
                nickName: res.data.nickname,
                icon1: res.data.headimgurl,
                sex: res.data.sex == '0' ? 'male' : 'female',
                openId: res.data.openid,
                unionid: unionid,
                imei: getImei(),
                logo: 1
              })
            };
            $httpFactory.login.thirdLogin(data).then(function (res) {
              afterLogin(res);
            });
          });
        }, function (error) {
          // alert("oauth2/access_token error：" + JSON.stringify(error));
        })
      });
    }
    $scope.privacyShow = false;
    // 隐私政策
    $scope.privacyShowFunc = function () {
      $scope.privacyShow = true;
      $scope.localPravacy = localStorage.getItem("privacy");
    }
    $scope.privacyModel = function () {
      $scope.privacyShow = false;
      localStorage.setItem("privacy", 1)
    }
    $scope.closePrivacy = function () {
      $scope.privacyShow = false;
    }
    $scope.localPravacy = localStorage.getItem("privacy");

    $scope.closeApp = function () {
      var confirmPopup = $ionicPopup.confirm({
        title: '提示',
        template: '不同意该条款将无法使用该应用',
        buttons: [
          { text: '取消' },
          {
            text: '<b>确认退出</b>',
            type: 'button-positive',
            onTap: function () {
              console.log("aaaa")
              navigator.app.exitApp();
            }
          },
        ]
      });
    }
    if (!$scope.localPravacy) {
      $scope.privacyShow = true;
    }
    function afterLogin(res) {
      if (res.data.result == 0) {
        $ionicLoading.show({ template: '登录成功！' });
        appv.bookGold = res.data.object.bookGold;
        if(res.data.object.user.icon1){
          res.data.object.user.icon1 = http2https(res.data.object.user.icon1);
        }
        appv.currentUser = res.data.object.user;
        appv.token = res.data.object.token;

        $httpFactory.setToken(res.data.object.token);
        localStorageService.set('token', appv.token);
        localStorageService.set('currentUser', appv.currentUser);
        localStorageService.set('bookGold', appv.bookGold);

        //头像本地缓存
        var img = appv.currentUser.icon1;
        AppFactory.img2Base64('saixueba.userIcon', img);









        $timeout(function () {
          $scope.closeLogin();
        });
        //查询红点信息
        checkRedInfo();

        $httpFactory.everyDaySign().then(function (res) {
          if (res.data.object) {
            $scope.loginGold = res.data.object.addGold;
          }
        });// 自动签到(场景:游客或用户A切换用户B登录)

        /** 刷新table数据 */
        $rootScope.reload_SpecialCtrl && $rootScope.reload_SpecialCtrl();
        $rootScope.initFormData && $rootScope.initFormData();

        //页面跳转
        $state.go('app.table.home');
      }
      //登录失败
      else {
        $ionicLoading.show({ template: res.data.message });
      }
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }

    function getImei() {
      var imei = "";
      if (_app.isAndroid || _app.isIos) {
        imei = device.uuid;
      }
      if (_app.isAndroid) {
        umengService.init({ "args": "init" });
      }
      return imei;
    }

    function checkRedInfo() {
      //查询红点信息
      appv.currentUser && $httpFactory.user.redInfo().then(function (res) {
        if (res.data.result == 0) {
          $rootScope.redInfo = res.data.object.object;
        }
      });
    }
  }
})();
