/**
 * Created by Administrator on 2017/3/1 0001.
 */
(function () {
  'use strict';

  angular
    .module('starter')
    .controller('MasterVideoCtrl', MainCtrl);

  function MainCtrl($scope, $state, $httpFactory, RouteData, $ionicHistory, $ionicLoading, $rootScope, PaymentFactory, $ionicPopup) {
    {
      var productInfo = RouteData.masterVideo;
      productInfo.picUrl = http2https(productInfo.picUrl);
      $scope.productInfo = productInfo;
      getMasterVideoInfo();
      $scope.navBack = navBack;
      $scope.play = play;
      $scope.tip = tip;
      $scope.pay = pay;
      $scope.pay_choose_gold = pay_choose_gold;
    }

    function tip() {
      $ionicLoading.show({template: '请先购买该视频'});
    }

    function navBack() {
      $ionicHistory.goBack();
    }

    function play(item) {
      if (item.isFree == 1 || $scope.videoInfo.status != 1) {
        item.videoUrl = http2https(item.videoUrl);
        $scope.play_active = item;
        $('video')[0].play();
        // var video = document.querySelector('video');
      }else if(!appv.currentUser){
        $state.go('app.loginBefore');
      }else{
        pay();
      }
    }

    function getMasterVideoInfo() {
      $httpFactory.main.fromEntryToMaster.infoList(productInfo.code).then(function (res) {
        if (res.data.result == 0) {
          $scope.videoInfo = res.data.object;
          /* 设置图片信息 */
          var list = $scope.videoInfo.videoList;
          if (!list) {
            list = [];
          }
          for (var i = 0; i < list.length; i++) {
            var video = list[i];
            if (!$rootScope.ios_isPayChoose) {// 审核状态
              video.play_src = "img/main/play1.png";
              video.pause_src = "img/main/pause1.png";
            } else if ($scope.videoInfo.status != 1) {// 购买整个课程
              video.play_src = "img/main/play1.png";
              video.pause_src = "img/main/pause1.png";
            } else if (video.isFree) {// 单节免费
              video.play_src = "img/main/play1.png";
              video.pause_src = "img/main/pause1.png";
            } else { // 未购买状态
              video.play_src = "img/main/play2.png";
              video.pause_src = "img/main/pause2.png";
            }
          }
          play($scope.videoInfo.videoList[0]);
        }
      })
    }

    function pay() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      if (!$rootScope.ios_isPayChoose) {
        useGold();
        return;
      }

      //改版后（可选套餐视频）
      var page_param = {
        pro_name: productInfo.title,
        pro_price: $scope.videoInfo.price,
        productCode: productInfo.productCode
      }

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, page_param, function () {
        getMasterVideoInfo();
        $scope.myPopup.close();
      }, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });
    }

    function useGold() {
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/main/masterVideo/payMenu2.html',
        scope: $scope
      });
    }

    /**
     * 金币支付
     */
    function pay_choose_gold() {
      if (!productInfo) {
        $ionicLoading.show({template: '未找到产品'});
        return;
      }

      $httpFactory.section.order_gold({productCode: productInfo.productCode}).then(success, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });

      function success(response) {
        $scope.myPopup.close();
        if (response.data.result == 0) {
          getMasterVideoInfo();
        } else {
          $scope.message = response.data.message;
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/main/masterVideo/pay_prompt2.html',
            scope: $scope
          });
        }
      }
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }
  }
})();
