/**
 * Created by Administrator on 2017/2/10 0010.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('CommodCtrl', MainCtrl);

  function MainCtrl($scope, $state, $rootScope, RouteData, $httpFactory, $ionicPopup, $ionicLoading,$timeout) {
    {
      var submitting=false;
      init();
      $scope.exchangeClick = exchangeClick;
      $scope.close = close;
      window.addEventListener('native.keyboardshow', keyboardShowHandler);        //软件盘显示监听
      window.addEventListener('native.keyboardhide', keyboardHideHandler);        //软键盘隐藏监听
    }

    function close(){
      cordova.plugins.Keyboard.close();
      $scope.myPopup.close();

    }

    function keyboardShowHandler(e){
      var height = e.keyboardHeight+'px';
      // document.querySelector('.popup_bottom_div').style.top = '30vh';
      document.querySelector('.popup_bottom_div').style.bottom = height;
    }

    function keyboardHideHandler(){
      document.querySelector('.popup_bottom_div').style.bottom = '0';
    }

    function init() {
      $scope.commod = RouteData.commod;
    }

    function exchangeClick() {

      // expressInfo();// 快递信息
      $scope.data = {};
      $scope.data.placeholder = $scope.commod.type == 1 ? '手机号 + QQ号' : '收货信息 + 收货人 + 手机号';
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/mall/commod/exchangePage.html',
        scope: $scope
      });
      $timeout(function(){
        $('textarea').focus();
      },100);

      $scope.userExchange = function () {
        if (!$scope.data.info) {
          $ionicLoading.show({template: '请预留备注信息,便于兑换物品！'});
          return;
        }

        if(submitting){
          return;
        }
        submitting = true;// 开始提交(控制用户多次点击)

        $httpFactory.diamond.userExchange($scope.commod.code, $scope.data.info).then(function (response) {
          submitting = false;

          console.log('response:' + response);
          if (response.data.result == 0) {
            $ionicLoading.show({template: '兑换成功'});
            close();
            $rootScope.MallCtrl_refresh();
            $state.go('app.mall');
          } else {
            $ionicLoading.show({template: response.data.message});
            close();
          }

        }, function (error) {
          submitting = false;
          console.log('error:' + error);
        });
      }

      $scope._onfocus = function () {
        document.querySelector('.popup_bottom_div').style.top = '30vh';
        document.querySelector('.popup_bottom_div').style.bottom = 'inherit';

      }

      $scope._onblur = function () {
        document.querySelector('.popup_bottom_div').style.removeProperty('top');
        document.querySelector('.popup_bottom_div').style.bottom = '0';
      }

      function expressInfo() {
        $scope.data = {};
        var myPopup = $ionicPopup.show({
          template: '<textarea cols="60" rows="3" ng-model="data.info"></textarea>',
          title: '填写收货地址+联系人+电话',
          // subTitle: 'Please use normal things',
          scope: $scope,
          buttons: [
            {text: '取消'},
            {
              text: '<b>确认兑换</b>',
              type: 'button-positive',
              onTap: function (e) {
                if (!$scope.data.info) {
                  e.preventDefault();
                } else {
                  return $scope.data.info;
                }
              }
            },
          ]
        });
        myPopup.then(function (remark) {
          if (remark) {
            $httpFactory.diamond.userExchange($scope.commod.code, remark).then(function (success) {
              console.log('success:' + success);
              $ionicLoading.show({template: '兑换成功'});
              $rootScope.MallCtrl_refresh();
              $state.go('app.mall');
            }, function (error) {
              console.log('error:' + error);
            });
          }
        });
      }
    }

  }
})();
