/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('PracticeCtrl', MainController)

  /**
   * practice 练习
   * openSection 打开节-信息
   * questionRoot 打开节-题集
   * openQuestion 当前打开题
   */

  function MainController($scope, $state, $httpFactory, localStorageService,$timeout,RouteData, $ionicHistory, $ionicScrollDelegate,$rootScope) {

    {
      $scope.iosPayOpen = $rootScope.ios_isPayChoose;//是否打开支付
      $scope.isIos = $rootScope.isIos;//是否为ios设备
      onLoaded();    //刷新页面
      console.log('viewHistory', $ionicHistory.viewHistory());
      var questionRoot;// 打开节-题集 initData()中初始化
      $scope.index = 1;// 先定义位置
      initData();// 获取练习题(showOption显示题目中依赖位置定义)
      $scope.initData = initData;

      $scope.up = up;
      $scope.next = next;
      //$scope.nacBack = nacBack;
      //$timeout(function(){
      //  $('.sxb_title').css('background-color', RouteData.knowPointColor);// 设置主题色
      //},1)
    }

    //function nacBack(){
    //  $ionicHistory.goBack();
    //}

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        $timeout(function(){
          console.log("begin");
          $("ion-content").css('display', 'none');
          document.body.offsetWidth;// 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
          $("ion-content").css('display', '');
          console.log("end");
        },500)
      });
    }

    function initData() {
      $scope.openSection = localStorageService.get('openSection');// 打开-节(本地存储)

      // questionRoot = PracticeDataFactory;// 依据节,获取节练习题
      $httpFactory.practice.getPractices($scope.openSection.code).then(function (request) {
        if(request.status==-1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          questionRoot = request;
          showOption();// 显示题目
        }
      });
    }

    function up() {
      if ($scope.index == 1) {
        return;
      }

      $('.step li:nth-child(' + $scope.index + ')').removeClass('active');
      $('.step li:nth-child(' + $scope.index + ')').addClass('passive')
        .on("webkitAnimationEnd animationend", function () {
          $(this).removeClass('passive');
        });

      $scope.index = $scope.index - 1;
      showOption();
    }

    function next(option) {

      $scope.openQuestion.userResult = option.id;// 登记用户作答
      console.log($scope.index, $scope.openQuestion.result, $scope.openQuestion.userResult);
      $('.step li:nth-child(' + ($scope.index + 1) + ')').addClass('active');

      if ($scope.index == questionRoot.data.object.length) {
        submitTranscripts();// 提交成绩单
        return;
      }

      $scope.index = $scope.index + 1;
      showOption();// 显示题目

      // 解决无法滑动屏幕问题
      setTimeout(function(){
        // 对面板强行重绘（解决文字重叠问题）
        $("ion-content").css('display', 'none');
        document.body.offsetWidth;// 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
        $("ion-content").css('display', '');
      },100);
    }

    /**
     * 显示题目
     */
    function showOption() {
      $scope.openQuestion = questionRoot.data.object[$scope.index - 1].question;
      $ionicScrollDelegate.scrollTop();// 回到顶部
    }

    function submitTranscripts() {
      RouteData.transcripts = {questionRoot: questionRoot};
      localStorageService.set('transcripts', {questionRoot: questionRoot});

      var content = {knowCode: $scope.openSection.code, list: []};
      angular.forEach(questionRoot.data.object, function (data, index, array) {
        content.list.push({
          questionCode: data.code,
          result: data.question.userResult,
          isTrue: (data.question.result == data.question.userResult ? 1 : 0)
        });
      });
      //苹果审核，进去看看，未登录
      if(!window.appv.currentUser){
        $state.go('app.transcripts');
        return;
      }
      $httpFactory.practice.exercise(content).then(function(res){
        if(res.data.result == 0){
          //更新练习完成进度--章
          if($scope.openSection.lever==3){
            for(var i=0;i<$rootScope.openBook.knowPoints.length;i++){        //遍历打开的课本，找到章
              if($rootScope.openBook.knowPoints[i].code == $scope.openSection.code){
                $rootScope.openBook.knowPoints[i].trueNum = res.data.object.trueSum;           //更新章的正确题数，刷新章练习进度
                RouteData.openChapter = $rootScope.openBook.knowPoints[i];      //记录章信息（章练习进度用）
              }
            }
          }
          //更新练习完成进度--节
          else if($scope.openSection.lever==4){
            RouteData.openChapter = null;//清空章信息
            uploadProgress(_app.progress_practice);
          }
          $state.go('app.transcripts');
        }
      });// 提交成绩
    }

    function uploadProgress(type){
      var codeList = $scope.openSection.progressCode.split('#');
      if(codeList[type] == 1){
        return;
      }
      codeList[type] = 1;
      var progressCode = codeList[0]+'#'+codeList[1]+'#'+codeList[2];

      $scope.openSection.progressCode = progressCode;        //重新给当前域的章节完成进度赋值
      localStorageService.set("openSection", $scope.openSection);         //新的节信息存入本地
      RouteData.section.openSection.progressCode = progressCode;        //重新给当前域的章节完成进度赋值

      var data = {
        content:JSON.stringify({
          knowCode:$scope.openSection.code,
          statusCode:progressCode
        })
      };
      $httpFactory.main.uploadProgress(data).then(function(res){
        if(res.data.result == 0){
          // $rootScope.initFormData();
          //刷新课件页进度
          for(var i=0;i<$rootScope.books.length;i++){
            var dataBook = $rootScope.books[i];               //获取课本
            var openBook = localStorageService.get('openBook');
            var openSection = localStorageService.get("openSection");
            if(dataBook.code == openBook.code){

              for(var j=0;j<dataBook.knowPoints.length;j++){
                var dataChapter = dataBook.knowPoints[j];           //获取章
                if(dataChapter.code == openSection.parentCode){

                  for(var k=0;k<dataChapter.knowPoints.length;k++){
                    var dataSection = dataChapter.knowPoints[k];        //获取节
                    if(dataSection.code == openSection.code){
                      // dataSection.progressCode = progressCode;        //重新赋值进度
                      // dataSection.progressSum++;                        //完成度+1
                      $rootScope.books[i].knowPoints[j].knowPoints[k].progressCode = progressCode;
                      $rootScope.books[i].knowPoints[j].knowPoints[k].progressSum++;
                      updateBookProgress($rootScope.books[i]);
                      // $rootScope.openBook.knowPoints[j].knowPoints[k].progressCode = progressCode;
                      // $rootScope.openBook.knowPoints[j].knowPoints[k].progressSum++;
                    }
                  }
                }
              }
            }
          }
        }
      });
    }

    function updateBookProgress(book) {
      var sectionList = [];
      var chapter = book.knowPoints;

      for(var i=0;i<chapter.length;i++){
        var section = chapter[i].knowPoints;
        sectionList = sectionList.concat(section);
      }
      var sum = 0;
      for(var j=0;j<sectionList.length;j++){
        sectionList[j].progressSum==3?sum++:1;
      }
      var bookProgress = Math.floor(sum/sectionList.length*100);
      book.bookProgress = bookProgress;
    }

    function showUserResult() {
      for (var item in questionRoot.object) {
        var question = questionRoot.object[item].question;
        if (question.userResult == null) {
          break;
        }
        console.log(question.result, question.userResult);
      }
    }
  }

})();
