/**
 * Created by Administrator on 2016/9/3 0003.
 */
(function(){
  'use strict';

  angular
    .module('starter')
    .controller('RichCtrl',MainCtrl);

  function MainCtrl($scope,$state,$httpFactory,$ionicLoading,$ionicHistory,SelfFactory){
    {
      var pageSize = 10;
      var currentPage = 1;
      var diamondPage = 1;
      $scope.hasNextPage = true;
      $scope.diamondNextPage = true;
      $scope.richList = [];
      $scope.diamondList = [];

      initSwiper();
      initPageCss();
      $scope.user = appv.currentUser;
      $scope.bookGold = appv.bookGold;
      $scope.richLock = true;
      $scope.getRichList = getRichList;
      $scope.diamondLock = true;
      $scope.getDiamondList = getDiamondList;
      $scope.back = back;
      $scope.toHead = toHead;
      $scope.toShopping = toShopping;
      $scope.changeModal = changeModal;
      $scope.activeType = 0;  //默认展示钻石榜
      $scope.toEarnGold = toEarnGold;
    }

    function toEarnGold(){
      $state.go('app.earnGold')
    }

    function changeModal(type){
      if($scope.swiper.activeIndex != type){
        $scope.swiper.slideTo(type);
        changeModalStyle();
      }
    }

    function changeModalStyle(){
      $scope.activeType = $scope.swiper.activeIndex;
      SelfFactory.redrawPage(1);     //重绘页面
    }

    function toShopping(){
      $state.go('app.mall');
    }

    function initSwiper(){
      $scope.swiper = new Swiper('.swiper-container', {
        // spaceBetween: 50,
        // slidesPerView: 2,
        // centeredSlides: true,
        // slideToClickedSlide: true,
        // grabCursor: true,
        nextButton: '.swiper-button-next',
        prevButton: '.swiper-button-prev',
        // scrollbar: '.swiper-scrollbar',
        pagination: '.swiper-pagination',
        // paginationType : 'custom',
        // paginationClickable :true,
        onSlideChangeEnd: changeModalStyle
      });
    }

    function initPageCss(){
      if(_app.isIos){
        $scope.iosPageTitle = {
          height: '20px',
          'background-color':'#279ceb'
        };
        $scope.iosPageBj = {
          height:$('ion-view').height() - 20 +'px'
        }
      }
    }

    function toHead() {
      $state.go('app.head');
    }

    function back(){
      $ionicHistory.goBack();
    }

    function getDiamondList(){
      if(!$scope.diamondLock){
        return;
      }
      $scope.diamondLock = false;
      $httpFactory.gold.diamondList(pageSize,diamondPage).then(function(res){
        $scope.diamondLock = true;
        $scope.$broadcast('scroll.infiniteScrollComplete');
        if(res.status==-1){
          $scope.networkError = true;
        }else {
          $scope.networkError = false;
          diamondPage++;
          if(res.data.result == 0){
            $scope.diamondSum = res.data.object.diamondSum;
            $scope.diamondRank = res.data.object.myRanking;
            var list = res.data.object.rankList;
            $scope.diamondList = $scope.diamondList.concat(list);
            if(pageSize > list.length || diamondPage > 1){
              $scope.diamondNextPage = false;
            }
          }
        }
      })
    }

    function getRichList(){
      if(!$scope.richLock){
        return;
      }
      $scope.richLock = false;
      $httpFactory.gold.richList(pageSize,currentPage).then(function(res){
        $scope.richLock = true;
        if(res.status==-1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          currentPage++;
          if(res.data.result == 0){
            $scope.user.rank = res.data.object.myRanking;
            var richList = res.data.object.richList;
            $scope.richList = $scope.richList.concat(richList);   //数据拼接

            if(pageSize > richList.length || currentPage > 50){
              $scope.hasNextPage = false;
            }

            //设置排行榜滚动条区域高度
            // $scope.listHeight = {
            //   height:$('ion-view').height()*0.87-$('.rich_ws_self').height()-20-window.screen.width*0.042-$('#iosPageTitle').height()+'px'
            // }
          }else{
            $ionicLoading.show({template:res.data.message});
          }
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      });
    }
  }
})();
