/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('CashCtrl', CashCtrl)

  /** 我的消息 */
  function CashCtrl($scope, RouteData, $timeout, $state, localStorageService, $ionicLoading, $httpFactory, $ionicHistory) {
    console.log('into CashCtrl');

    /***** Controller ******/
    {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      $scope.currentUser = window.appv.currentUser;
      initData();
      $scope.applyData = {};
      $scope.haveClick = false;
      $scope.menuClick = menuClick;
      $scope.checkClick = checkClick;
      $scope.makeSureCash = makeSureCash;
      $scope.navBack = navBack;
    }

    /***** function ******/
    function initData() {
      $scope.localScholar = localStorageService.get('myScholar') ? localStorageService.get('myScholar') : "";
      $scope.localBalance = $scope.localScholar.balance ? $scope.localScholar.balance : 0;
      $scope._active = $scope.localScholar.linkType ? $scope.localScholar.linkType : 1;//1-QQ提现，2-微信提现
      $scope.moneyList = [2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000, 10000];
    }

    function menuClick(type) {
      $scope._active = type;
    }

    function checkClick(index) {
      $scope.cashType = index;
      if (!!$scope.beforeIndex && $scope.beforeIndex != index + 1) {
        var beforeTarget = $($('.cash_box').get($scope.beforeIndex - 1));
        beforeTarget.removeClass('active');
      }
      var target = $($('.cash_box').get(index));
      target.addClass('active');
      $scope.beforeIndex = index + 1;
    }

    function makeSureCash() {
      if (!checkData()) {
        return;
      }
      if($scope.haveClick){
        return;
      }
      $scope.haveClick = true;
      var data = {
        content: JSON.stringify({
          cashType: $scope.cashType,
          linkAccountType: $scope._active,
          linkAccount: $scope.localScholar.linkAccount,
          linkMobile: $scope.localScholar.linkMobile,
        })
      }
      $httpFactory.user.toCash(data).then(function (res) {
        if (res.data.result == 0) {
          $ionicLoading.show({template: res.data.message});
          $scope.currentScholar = res.data.object;
          localStorageService.set('myScholar', $scope.currentScholar);
          $timeout(function () {
            $scope.haveClick = false;
            $state.go('app.myMoney');
          }, 1000);
        } else {
          $ionicLoading.show({template: res.data.message});
          $scope.haveClick = false;
        }
      });
    }

    function checkData() {
      if (!$scope.localScholar.linkAccount) {
        if ($scope._active == 1) {
          $ionicLoading.show({template: "请输入QQ号"});
        } else if ($scope._active == 2) {
          $ionicLoading.show({template: "请输入微信号"});
        }
        return false;
      }
      if (!$scope.localScholar.linkMobile) {
        $ionicLoading.show({template: "请输入手机号码"});
        return false;
      }
      if ($scope.cashType == undefined) {
        $ionicLoading.show({template: "请选择提现金额"});
        return false;
      }
      return true;
    }

    // 导航-返回
    function navBack() {
      $ionicHistory.goBack();
    }


  }

})();
