(function () {
  'use strict';

  angular
    .module('starter')
    .controller('SelfCenterCtrl', SelfCenterCtrl);

  function SelfCenterCtrl($scope, $rootScope, RouteData, $timeout, $ionicViewSwitcher, $state, $ionicPopup, localStorageService, $ionicLoading, $httpFactory, $location) {

    //if (!appv.currentUser) {
    //  $state.go('app.loginBefore');
    //  return;
    //}
    $scope.currentUser = window.appv.currentUser;
    $scope.bookGold = appv.bookGold;
    $scope.iosPayOpen = $rootScope.ios_isPayChoose;//是否打开支付
    $scope.isIos = $rootScope.isIos;//是否为ios设备
    checkActive();

    $scope.toMessage = toMessage;//消息
    $scope.toSetting = toSetting;//设置
    $scope.toChangeHead = toChangeHead;//更换头像
    $scope.showInvite = showInvite;//我的邀请码

    $scope.inviteFriend = inviteFriend;//邀请好友，赚取奖学金
    $scope.toMyMoney = toMyMoney;//我的奖学金（可提现）
    $scope.shareApp = shareApp;//分享软件赚金币
    $scope.bindInviteCode = bindInviteCode;//填写好友邀请码
    $scope.toMyActive = toMyActive;//领取笔记本,或者活动
    $scope.feedback = feedback;//意见反馈
    $scope.joinQQGroup = joinQQGroup;//老师答疑QQ群

    $scope.save = save;
    getLearningInfo();
    checkThird();//检测第三方是否安装
    $scope.unInstallBack = unInstallBack;

    $scope.f_share = f_share;// 分享

    $scope.selfCenterTo = selfCenterTo;

    //我的消息
    function toMessage() {
      if ($scope.redInfo && $scope.redInfo.newMessage) {
        var data = {
          content: JSON.stringify({
            newMessage: false
          })
        };
        updateRedInfo(data);
      }
      $state.go('app.message');
      $ionicViewSwitcher.nextDirection("forward")
    }

    function updateRedInfo(data) {
      $httpFactory.user.redInfoRead(data).then(function (res) {
        if (res.data.result == 0) {
          $scope.redInfo = res.data.object;
        }
        else {
          console.log(res.data.message);
        }
      })
    }

    //设置
    function toSetting() {
      $state.go('app.setting');
    }

    function toChangeHead() {
      $state.go('app.userInfo');
    }

    //相关学习数据
    function getLearningInfo() {
      if (!$scope.currentUser) {
        return;
      }
      $httpFactory.user.userLearningInfo().then(function (res) {
        if (res.data.result == 0) {
          $scope.allDays = res.data.object.allDays;
          $scope.rightQuestion = res.data.object.rightQuestion;
          $scope.allQuestion = res.data.object.allQuestion;
          // 正确率
          if ($scope.rightQuestion == 0 || $scope.allQuestion == 0) {
            $scope.rightPercent = 0;
          } else {
            $scope.rightPercent = parseInt($scope.rightQuestion / $scope.allQuestion * 100) + "%";
          }
        }
      });
    }

    function selfCenterTo(type) {
      switch (type) {
        case 1:
          //邀请好友，赚取奖学金
          inviteFriend();
          break;
        case 2:
          toMyMoney();
          break;
        case 3:
          //分享软件赚金币
          shareApp();
          break;
        case 4:
          //填写好友的邀请码
          bindInviteCode();
          break;
        case 5:
          toMyActive();
          break;
        case 6:
          //意见反馈
          feedback();
          break;
        case 7:
          //老师答疑群
          joinQQGroup();
          break;
        case 8:
          //老师答疑群
          joinWeixin();
          break;
        default:
          break;
      }
    }

    function inviteFriend() {
      $scope.myInvitePopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/self_invite.html',
        scope: $scope
      });
    }

    function unInstallBack() {
      $scope.myInvitePopup.close();
      $scope.myInviteSharePopup.close();
    }

    function showInvite() {
      $scope.chooseShareType = 1;
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return;
      //}
      $scope.myInviteSharePopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/self_invite_choose.html',
        scope: $scope
      });
    }

    function toMyMoney() {
      $state.go('app.myMoney');
    }

    //分享软件赚金币
    function shareApp() {
      $scope.chooseShareType = 2;
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return;
      //}
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/shareApp.html',
        scope: $scope
      });
    }

    //填写好友的邀请码
    function bindInviteCode() {
      // 一个精心制作的自定义弹窗
      $scope.hasFriendCode = $scope.currentUser.inviteUserCode;//好友邀请码
      $scope.myPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/app/invite.html',
        scope: $scope
      });
    }

    function save() {
      if ($scope.hasFriendCode) {
        $scope.myPopup.close();
        return;
      } else if (!$scope.currentUser.friendCode || $scope.currentUser.friendCode.length <= 0) {
        $ionicLoading.show({template: '请输入正确的邀请码'})
      } else {
        $httpFactory.activity.bindInvite($scope.currentUser.friendCode).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message, duration: 2000});
            $scope.myPopup.close();
          } else {
            $ionicLoading.show({template: res.data.message, duration: 2000});
          }
        });
      }
    }

    //领取笔记本，或者活动
    function toMyActive() {
      if ($scope.isActive) {
        $state.go('app.myActive');
      } else {
        $state.go('app.myNote');
      }
    }

    //意见反馈
    function feedback() {
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return;
      //}
      if ($scope.redInfo && $scope.redInfo.newFeedback) {
        var data = {
          content: JSON.stringify({
            newFeedback: false
          })
        };
        updateRedInfo(data);
        $state.go('app.feedback_list');
      } else {
        $state.go('app.feedback');
      }
      my.log("意见反馈");
    }

    //老师答疑群
    function joinQQGroup() {
      //是否付费用户
      if (!payUser()) {
        return;
      }
      var key = 'joinQQGroup';
      $httpFactory.getSysConfig_1801(key).then(function (res) {
        if (res.data.result == 0) {
          var joinQQGroupJson = JSON.parse(res.data.object.list[0].value)
          if (_app.isAndroid) {
            JoinQQGroup.open({key: joinQQGroupJson.android.key});
          } else if (_app.isIos) {
            JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
          }
        }
      });
    }

    function joinWeixin() {

        $state.go('app.wechat');

    }

    function payUser() {
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return false;
      //}
      if (appv.currentUser.isPayUser != 1) {
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/app/payUser.html',
          scope: $scope
        });
        return false;
      }
      return true;
    }

    //第三方检测是否安装
    function checkThird() {
      //if (!appv.currentUser) {
      //  $state.go('app.loginBefore');
      //  return;
      //}
      if (RouteData.shareInfo) {
        $scope.share = RouteData.shareInfo;
        return;
      }
      $httpFactory.sys.config('shareApp').then(function (response) {
        shareApp_handle(response);
      })

      function shareApp_handle(response) {
        $scope.share = JSON.parse(response.data.object[0].value);
        $scope.share.inviteCode = appv.currentUser && appv.currentUser.inviteCode;
        $scope.share.params.title = $scope.share.params.title.replace('{{inviteCode}}', $scope.share.inviteCode);
        $scope.share.params.description = $scope.share.params.description.replace('{{inviteCode}}', $scope.share.inviteCode);

        for (var i in $scope.share.items) {
          f_isInstall($scope.share.items[i]);
        }
        RouteData.shareInfo = $scope.share;

        setTimeout(function () {
          $scope.$apply();
        }, 500);// 脏检查

        function f_isInstall(item) {
          if (_app.isWeb) {
            item.isInstall = true;
            return;
          }

          switch (item.name) {
            case 'qq':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'Qzone':
              $scope.isInstall_qq().then(success, fail);
              return true;
            case 'wechat':
              $scope.isInstall_wechat().then(success, fail);
              return true;
            case 'wechatTimeline':
              $scope.isInstall_wechat().then(success, fail);
              return true;
            case 'weibo':
              $scope.isInstall_weibo().then(success, fail);
              return true;
          }

          function success(response) {
            item.isInstall = response;
          }

          function fail(failResponse) {
            console.log(failResponse);
          }
        }
      }
    }

    //分享
    function f_share(item, params) {
      switch (item.name) {
        case 'qq':
          $scope.curItem = 0;
          $rootScope.share_qq(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'Qzone':
          $scope.curItem = 1;
          $rootScope.share_Qzone(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'wechat':
          $scope.curItem = 2;
          $rootScope.share_wechat(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'wechatTimeline':
          $scope.curItem = 3;
          $rootScope.share_wechatTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
        case 'weibo':
          $rootScope.share_weibo(params.title, params.description, params.thumb, params.url).then(success, fail);
          return true;
      }

      function success(response) {
        if ($scope.chooseShareType == 1) {//邀请好友入口，增加奖学金

        } else if ($scope.chooseShareType == 2) {//分享赚金币
          //$('.tick')[$scope.curItem].itemShowImg = true;
          ////更新shareInfo信息，关于itemShowImg
          //RouteData.shareInfo = $scope.share;
        }
        console.log('分享成功', response);
      }

      function fail(failResponse) {
        if ($scope.chooseShareType == 1) {//邀请好友入口，增加奖学金

        } else if ($scope.chooseShareType == 2) {//分享赚金币

        }
        console.log('分享失败', failResponse);
      }


    }

    function checkActive() {
      $httpFactory.sys.config("isActive").then(function (res) {
        if (res.data.result == 0) {
          $scope.isActive = JSON.parse(res.data.object[0].value);
        }
      })

    }
  }

})
();
