/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SpecialCtrl', MainController)

  function MainController($scope, $rootScope, $state, $httpFactory, RouteData, localStorageService,SelfFactory,$ionicPopup,PaymentFactory,$ionicLoading) {
    console.time('SpecialCtrl');

    {
      $scope.currentUser = window.appv.currentUser;
      $scope.choose = false;
      $scope.chooseF = chooseF;
      $scope._active = RouteData.special_active?RouteData.special_active:5;
      init();

      $scope.choiceSpecial = null;// 当前选择分类
      $scope.videoClick = videoClick;
      $scope.spClick = spClick;
      $scope.getPlanProduct =  getPlanProduct;
      $scope.toMyCenter =  toMyCenter;

      $rootScope.reload_SpecialCtrl = function () {
        init();
      }
    }

    //头像，个人中心
    function toMyCenter() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      $state.go('app.table.selfCenter');
      $rootScope.tableInit && $rootScope.tableInit('app.table.selfCenter');
    }

    function getPlanProduct(){
      var specialVideo = 4;
      var level = 3;
      $httpFactory.special.getPlanProduct(specialVideo,level).then(function(res){
        if(res.data.result == 0){
          $scope.videoProduct = [];
          for(var i=0;i<res.data.object.length;i++){
            var video = res.data.object[i];
            if(video.name.indexOf(_app.specialVideo_type[$scope._active-1])==0){
              $scope.videoProduct = $scope.videoProduct.concat(res.data.object[i])
            }
          }
          $scope.product = $scope.videoProduct[0];
        }
      });
      $scope.productPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/special_vedeo/product.html',
        scope: $scope
      });
      //关闭
      $scope.productClose = function () {
        $scope.productPopup.close();
      };
      //选择套餐
      $scope.chooseProduct = function (item) {
        $scope.product = item;
      };
      //确认购买
      $scope.pay_choose_money = function(){
        var page_param = {
          pro_name: $scope.product.name,
          pro_price: $scope.product.price,
          pro_gold:$scope.product.gold,
          productCode:$scope.product.code
        }
        PaymentFactory.openPayChoose($scope, page_param, success_pay, fail_pay);
      }
      function success_pay(){
        $scope.myPopup.close();
        $scope.productPopup.close();
        init();         //重载刷新页面
      }
      function fail_pay(){
        $ionicLoading.show({template:'支付失败....'});
        $scope.productPopup.close();// 支付失败,关闭弹窗
      }
    }

    function init() {

      /*----------------获取分类-------------------*/
      var specialsLocal = localStorageService.get('specials');      // 本地存储直取
      specialsLocal && ($scope.specials = specialsLocal);
      $httpFactory.special.spec().then(function (response) {        // 服务端获取更新
        if (response.status == -1) {
          $scope.networkError = true;
        } else {
          $scope.networkError = false;
          $scope.specials = response.data.object;
          localStorageService.set('specials', response.data.object);
        }
      })

      /*----------------获取视频-------------------*/
      // 本地存储直取
      var videosLocal = localStorageService.get('videos');            // 本地获取
      videosLocal && ($scope.videos = videosLocal);
      var specialJson = {};
      $httpFactory.special.video().then(function (response) {         // 服务端获取更新

        // 更新示例图片
        for (var index in response.data.object) {
          var item = response.data.object[index];
          specialJson[item.categoryType] = true;
          specialJson[item.specCode] = true;
        }
        $scope.specialJson = specialJson;

        for(var cur of response.data.object){
          cur.picUrl = http2https(cur.picUrl);
        }
        $scope.videos = response.data.object;
        localStorageService.set('videos', response.data.object);
        $scope.dataCloak = true;// 完成数据载入
        SelfFactory.redrawPage();     //重绘页面
      })
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }

    function chooseF() {

      $scope.choose = !$scope.choose;
    }

    function spClick(item) {
      RouteData.special_active = $scope._active;
      $scope.choose = false;
      $scope.choiceSpecial = item;
      SelfFactory.redrawPage();     //重绘页面
    }

    function videoClick(specRes) {
      if(!appv.currentUser){
        $state.go('app.loginBefore');
        return;
      }

      RouteData.special_vedeo = {specResCode: specRes.code};
      localStorageService.set('specialVedeo_specResCode', specRes.code);// 本地存储-节
      $state.go('app.special_vedeo');// 直播视频
    }

  }

})();
