/**
 * Created by Administrator on 2016/8/17.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('SpecialVedeoCtrl', MainController)

  function MainController($scope, $rootScope, $ionicHistory, $httpFactory, PaymentFactory, RouteData, localStorageService, $ionicLoading, $ionicPopup, SelfFactory,$cordovaFile,CacheVideoFactory,$state) {
    console.time('SpecialVedeoCtrl');

    {
      init();
      $scope.pay_choose_product = pay_choose_product;
      $scope.pay_choose_money = pay_choose_money;
      var vid = document.querySelector('video');
      vid.addEventListener('timeupdate', timeupdateListener);
      $scope.openVideoTip = openVideoTip;
      $scope.productClose = productClose;
      $scope.chooseProduct = chooseProduct;
      $scope.cacheVideo = cacheVideo;
      $scope.navBack = navBack;
    }
    function navBack() {
      document.querySelector('video').pause();
      $ionicHistory.goBack();
    }
    /*缓存视频*/
    function cacheVideo(){
      /*pc端*/
      if(_app.isWeb){
        $state.go('app.cacheVideo');
        return;
      }
      /*手机端*/
      //缓存此视频
      if($scope.specRes.cacheStatus==0){
        $scope.specRes.status=1;
        CacheVideoFactory.cacheVideo('expVideo',$scope.specRes,function(result){
          if(result){
            $scope.specRes.status=2;
            $scope.specRes.url=result.nativeURL;
          }
        });
        $state.go('app.cacheVideo');
      }
      //缓存中
      if($scope.specRes.cacheStatus==1){
        $state.go('app.cacheVideo');
      }
      //已缓存
      if($scope.specRes.cacheStatus==2){
        $("video")[0].play();
      }
    }

    function checkVideoCache(){
      //检测本地有无缓存
      var urlList = $scope.specRes.url.split("/");
      var fileName = urlList[urlList.length - 1];
      $cordovaFile.checkFile(cordova.file.externalDataDirectory, 'expVideo/lock_'+fileName).then(
        fail,       //有锁文件，即未缓存好
        function () {       //无锁文件-继续检测视频文件
          $cordovaFile.checkFile(cordova.file.externalDataDirectory, 'expVideo/'+fileName).then(function (fileSystem) {
            $scope.specRes.url = fileSystem.nativeURL;
            $scope.specRes.cacheStatus = 2
          },fail);
        });
      function fail(error){

      };
    }

    /*打开视频提示*/
    function openVideoTip() {
      $ionicLoading.show({template: '您还没购买哦亲', duration: 1000});
    }

    function init() {
      var specResCode = RouteData.special_vedeo ?
        RouteData.special_vedeo.specResCode : localStorageService.get('specialVedeo_specResCode');

      $httpFactory.special.specRes(specResCode).then(function (response) {
        // response.data.object.url = 'http://cloud.video.taobao.com/play/u/2554695624/p/1/e/6/t/1/fv/102/28552077.mp4';// 示例视频
        $scope.specRes = response.data.object;
        $scope.specRes.cacheStatus=0;   //默认未缓存
        for(var i=0;i<$rootScope.videoDownloadList.length;i++){
          if($rootScope.videoDownloadList[i].code == $scope.specRes.code){
            $scope.specRes.cacheStatus=1;   //若视频存在于下载列表中，状态变为1，缓存中
            if($rootScope.videoDownloadList[i].finishDownload==_app.finishDownload_yes){
              $scope.specRes.cacheStatus=2;   //若视频存在于下载列表中，下载标记成功，状态变为2，缓存中
            }
          }
        }
        !_app.isWeb && checkVideoCache();
        SelfFactory.redrawPage();     //重绘页面
      })
    }

    function timeupdateListener() {
      console.log('播放事件');
      if ($scope.specRes.status == 1) {
        vid.pause();
        $ionicLoading.show({template: '您还没购买哦亲', duration: 1000});
      } else {
        $httpFactory.special.playTotle($scope.specRes.code).then(function () {
          $scope.specRes.playSum++;
          $rootScope.reload_SpecialCtrl();
        });// 登记播放次数
        vid.removeEventListener("timeupdate", timeupdateListener);// 删除当前事件监听
      }
    }

    function pay_choose_product() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }

      $httpFactory.main.getVideoProduct($scope.specRes.code).then(function (res) {
        if (res.data.result == 0) {
          $scope.videoProduct = res.data.object;
          $scope.product = $scope.videoProduct[0]
        }
      });
      $scope.productPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/special_vedeo/product.html',
        scope: $scope
      })
    }

    function productClose() {
      $scope.productPopup.close();
    }

    function chooseProduct(item) {
      $scope.product = item;
    }

    /**
     * 金钱支付全册
     */
    function pay_choose_money() {
      if (!appv.currentUser) {
        $state.go('app.loginBefore');
        return;
      }
      if (!$rootScope.ios_isPayChoose) {
        payUseGold();
        return;
      }
      //改版前（指定详情页视频）
      // var page_param = {
      //   pro_name: $scope.specRes.product.name,
      //   pro_price: $scope.specRes.product.price,
      //   productCode: $scope.specRes.product.code
      // }

      //改版后（可选套餐视频）
      var page_param = {
        pro_name: $scope.product.name,
        pro_price: $scope.product.price,
        productCode: $scope.product.code,
        pro_gold: $scope.product.gold,
      }

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, page_param, paySuccess, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });
    }

    function paySuccess() {
      $scope.specRes.status = 2;// 已购买(解锁)
      $rootScope.reload_SpecialCtrl();
      // $scope.myPopup_qr && $scope.myPopup_qr.close();
      // alert('close11111');
      $scope.myPopup.close();
      $scope.productPopup.close();

      $scope.unlock = true;// 解锁提示
      // $scope.myPopup = $ionicPopup.show({
      //   cssClass: 'myPopup',
      //   // cssClass: 'popup_clean',
      //   templateUrl: 'app/home/section/pay_prompt.html',
      //   scope: $scope
      // });
    }

    function payUseGold() {
      $httpFactory.section.order_gold({productCode: $scope.product.code}).then(success, function (param1,param2) {
        $scope.productPopup.close();// 支付失败,关闭弹窗
      });

      function success(response) {
        $scope.productPopup.close();
        if (response.data.result == 0) {
          paySuccess();
        } else {
          $scope.message = response.data.message;
          $scope.productPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/main/masterVideo/pay_prompt2.html',
            scope: $scope
          });
        }
      }
    }
  }

})();
