/**
 * Created by Administrator on 2016/8/24 0024.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('UserInfoCtrl', MainController);

  function MainController($scope, $state, $ionicModal, $timeout, $httpFactory, $ionicLoading, localStorageService, $rootScope, $ionicHistory, $ionicPopup, $ionicActionSheet) {
    {
      $scope.user = appv.currentUser;
      $scope.change = change;
      $scope.toHead = toHead;
      $scope.close = close;
      $scope.save = save;
      $scope.logout = logout;
      $scope.checkText = checkText;
      $scope.sureLogout = sureLogout;
      $scope.closeLogin = closeLogin;
      $scope.modalData = {
        title: null,
        maxLength: null,
        text: '',
        tip: ''
      };
      $scope.allowText = {
        color: $scope.modalData.text.length <= $scope.modalData.maxLength ? '#0093d8' : 'red'
      }
    }

    function checkText() {
      if ($scope.modalData.title == '昵称') {
        $scope.modalData.text = $scope.modalData.text.replace(/[\r\n]+/g, "");// \s 匹配任何空白字符，包括空格、制表符、换页符等等。等价于 [ \f\n\r\t\v]。
      }
      $scope.modalDatavalue = $scope.modalData.text;

      // if ($scope.modalData.text.length <= $scope.modalData.maxLength) {
      //   // $scope.modalData.text = $scope.modalData.text.substr(0,$scope.modalData.maxLength);
      //   $scope.modalDatavalue = $scope.modalData.text;
      // } else {
      //   $scope.modalData.text = $scope.modalDatavalue;
      // }
    }

    function logout() {
      //  confirm 确认对话框
      //$scope.logoutPopup = $ionicActionSheet.show({
      //  buttons: [{text:'退出登录',className:'destructive'},{text: '取消' }],
      //  titleText: '友情提示：退出后将清除所有缓存内容和账号信息，下次登录需要重新提供账号信息。',
      //  buttonClicked:function(index){
      //    index==0 && sureLogout();
      //    index==1 && $scope.logoutPopup();
      //  }
      //});

      $scope.logoutPopup = $ionicPopup.show({
        cssClass: 'myPopup',
        templateUrl: 'app/userInfo/logoutPopup.html',
        scope: $scope,
      });
    }

    function sureLogout() {
      var formData = localStorageService.get('formData');// 本地存储
      var openBook = localStorageService.get('openBook');
      localStorageService.clearAll();
      localStorageService.set('formData', formData);
      localStorageService.set('openBook', openBook);
      $ionicHistory.clearCache();

      appv.currentUser = null;
      appv.token = null;
      appv.bookGold = null;
      $rootScope.userInfo=null;
      $rootScope.refreshLoginInfo();
      $httpFactory.setToken(null);    //清空http请求头token
      //$scope.logoutPopup()
      closeLogin();
      $state.go('app.table.home');
      $timeout(function () {
        var dom = document.querySelector('button[ui-sref="app.table.home"]');
        if (dom) {
          dom.click();
        }
      }, 1000);      //防html未加载,异步等待一秒,再次点击跳转home
      $ionicLoading.show({template: '退出成功'});
      //$rootScope.login();
      $state.go('app.loginBefore');
    }

    function closeLogin() {
      $scope.logoutPopup.close();
      return;
    }

    function toHead() {
      if(!$rootScope.isIos || $rootScope.ios_isPayChoose){
        $state.go('app.head');
      }
    }

    function save() {
      if (!$scope.modalData.text || $scope.modalData.text.length <= 0) {
        $ionicLoading.show({template: '请输入有效字符'})
        return;
      }

      if ($scope.modalData.title == '昵称') {
        if ($scope.modalData.text.length > 32) {
          $ionicLoading.show({template: "昵称过长，不能超出32个字符！"});
          return;
        }

        var data = {
          content: JSON.stringify({
            nickName: $scope.modalData.text
          })
        };
        $httpFactory.user.infoChange(data).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message});
            appv.currentUser.nickName = $scope.modalData.text;
            $scope.user.nickName = $scope.modalData.text;
            if(appv.currentUser.icon1){
              appv.currentUser.icon1 = http2https(appv.currentUser.icon1);
            }
            localStorageService.set('currentUser', appv.currentUser);// 更新local
            close();
          }
        });
      } else if ($scope.modalData.title == '鸡汤') {
        var data = {
          content: JSON.stringify({
            motto: $scope.modalData.text
          })
        };
        $httpFactory.user.infoChange(data).then(function (res) {
          if (res.data.result == 0) {
            $ionicLoading.show({template: res.data.message});
            appv.currentUser.motto = $scope.modalData.text;
            $scope.user.motto = $scope.modalData.text;
            if(appv.currentUser.icon1){
              appv.currentUser.icon1 = http2https(appv.currentUser.icon1);
            }
            localStorageService.set('currentUser', appv.currentUser);// 更新local
            close();
          }
        });
      }
    }

    function http2https(url) {
      if (url && url.startsWith("http") && !url.startsWith("https")) {
        // http 转为 https
        url = url.replace("http", "https");
      }
      return url;
    }

    $ionicModal.fromTemplateUrl('app/userInfo/infoChangeModal/nickNameChange.html', {
      scope: $scope
    }).then(function (modal) {
      $scope.modal = modal;
    });

    function change(type) {
      if (type == _app.infoType_nickName) {
        $scope.modalData.title = '昵称';
        $scope.modalData.maxLength = 10;
        $scope.modalData.text = $scope.user.nickName;
        $scope.modalDatavalue = $scope.user.nickName;
        $scope.modalData.tip = '设置你的昵称'
      } else if (type == _app.infoType_motto) {
        $scope.modalData.title = '鸡汤';
        $scope.modalData.maxLength = 32;
        $scope.modalData.text = $scope.user.motto;
        $scope.modalDatavalue = $scope.user.motto;
        $scope.modalData.tip = '设置你的心灵鸡汤'
      }
      $scope.modal.show();
    }

    function close() {
      $scope.modalData.text = null;
      $scope.modal.hide();
    }
  }

})();
