/**
 * Created by Administrator on 2016/9/8 0008.
 */
(function () {
  'use strict'

  angular
    .module('starter')
    .controller('WelcomeAgainCtrl', MainCtrl)

  function MainCtrl($scope, $rootScope, $state, $interval, $ionicHistory, RouteData, $httpFactory, localStorageService, LoginFactory,$timeout,$cordovaFile,$cordovaFileTransfer) {
    {
      initImg();
      !$scope.welcomeImg && ($scope.welcomeImg = {img:'img/welcome/welcomeAgain.jpg'});
      $timeout(function(){
        getWelcomeImg();
      },10000);
      $scope.toEnd = toEnd;
      $scope.toWebUrl = toWebUrl;

      setTimeout(function () {
        LoginFactory.initLoginModal($rootScope);
      }, 1500);// 适当延时,首屏加速

      console.log('splash.wa',navigator.splashscreen);
      onLoaded();

      $ionicHistory.nextViewOptions({historyRoot: true});    //设定下一个页面为主路由
      RouteData.welcome = {after: true};// 已经过
    }

    function toWebUrl(data){
      if(data){
        if(data.type == _app.wclcomeImgType_activity){
          $state.go('app.activity');
        }
        else if(data.type == _app.wclcomeImgType_webUrl){
          if(data.webUrl){
            var web = window.open(data.webUrl, '_blank','location=no');
            web.addEventListener('exit',iabClose);
          }
        }
        else if(data.type == _app.wclcomeImgType_joinQQ){
          var key = 'joinQQGroup';
          $httpFactory.getSysConfig_1801(key).then(function (res) {
            if (res.data.result == 0) {
              var joinQQGroupJson = JSON.parse(res.data.object.list[0].value)
              if (_app.isAndroid) {
                JoinQQGroup.open({key: joinQQGroupJson.android.key});
              } else if (_app.isIos) {
                JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
              }
            }
          });
        }
      }
    }
    function exit(){
      $state.go("app.table.home");
    }

    function onLoaded() {
      $scope.$watch('$viewContentLoaded', function () {
        console.log('splash.wa.viewLoad',navigator.splashscreen);
        navigator.splashscreen && navigator.splashscreen.hide();// 加载完毕后关闭启动屏幕
        endTime();
        console.timeEnd('App load');
      });
    }

    function initImg() {
      for (var i = 0; i < localStorageService.length(); i++) {
        var imgObject = localStorageService.get('welcomeImg' + i);
        if (imgObject) {
          if (imgObject.start_time && imgObject.end_time) {
            var start_time = new Date(imgObject.start_time);
            var end_time = new Date(imgObject.end_time);
            var now = new Date();
            start_time <= now && end_time >= now && ($scope.welcomeImg = imgObject);
          } else {
            $scope.welcomeImg = imgObject;
          }
        } else {
          //break;
        }
      }
    }

    function toEnd() {
      /** 在跳过时,如果疯狂点击就会出现app闪退(甚至按钮没有click事件下,点击也会闪退).此可小范围规避 */
      document.querySelector('.welcomeAgain_entTime').style.display='none';

      $interval.cancel($scope.interval);
      if(appv.currentUser){
        $state.go("app.table.home");
      }else{
        $state.go('app.loginBefore');
      }

    }

    function endTime() {
      $scope.endTime = 4; // 1s为启动页淡出时间(策略改变)
      $scope.interval = $interval(function () {
        $scope.endTime--;
        if ($scope.endTime <= 0) {
          $interval.cancel($scope.interval);
          if(appv.currentUser){
            $state.go("app.table.home");
          }else{
            $state.go('app.loginBefore');
          }
        }
      }, 1000);
    }

    function getWelcomeImg() {
      $httpFactory.sys.config('welcome-img').then(function (res) {
        if (res.data.result == 0) {
          var imgList = JSON.parse(res.data.object[0].value);
          for (var i = 0; i < imgList.length; i++) {
            var lastName = imgList[i].img.split('.');          //获取文件名后缀
            var localUrl = "welcomeImg"+i+'.'+lastName[lastName.length-1];      //赋予新的文件名
            var img = imgList[i];
            // img2Base64("welcomeAgainImg" + i, imgList[i]);
            imgFileDownLoad(localUrl,img);
          }
          //img = img2Base64(img);
        }
      });
    }

    function imgFileDownLoad(fileName,welcomeImg){
      welcomeImg.img = adaptation(welcomeImg.img);// 设备屏幕适配
      var rootPath;      //设置缓存目录
      _app.isAndroid && (rootPath = cordova.file.externalDataDirectory);      //安卓目录
      _app.isIos && (rootPath = cordova.file.documentsDirectory);          //ios目录
      $cordovaFile.checkDir(rootPath,'welcomeImg').then(dirSuccess,dirFault);
      //检测到目录
      function dirSuccess(){
        $cordovaFile.checkFile(rootPath,'welcomeImg/lock_'+fileName).then(lockFileSuccess,lockFileFault);
      }
      //检测不到目录
      function dirFault(){
        $cordovaFile.createDir(rootPath,'welcomeImg',true).then(dirSuccess);
      }
      //检测到锁文件
      function lockFileSuccess(){
        $cordovaFile.removeFile(rootPath,'welcomeImg/lock_'+fileName).then(function(){
          console.log('下载失败，删除锁文件');
          $cordovaFile.removeFile(rootPath,'welcomeImg/'+fileName).then(function(){
            console.log('下载失败，删除源文件');
            fileFault();
          });
        });
      }
      //检测不到锁文件
      function lockFileFault(){
        $cordovaFile.checkFile(rootPath,'welcomeImg/'+fileName).then(fileSuccess,fileFault);
      }
      //检测到图片文件
      function fileSuccess(){
        var localStorageName = fileName.split('.')[0];
        if(welcomeImg.updateDate &&         //数据库更新时间
          //localStorageService.get(localStorageName).updateDate &&       //本地更新时间
          welcomeImg.updateDate != localStorageService.get(localStorageName).updateDate){         //两者不一致则覆盖下载
          fileFault();    //若更新时间不一致，则覆盖下载
        }
      }
      //检测不到图片文件
      function fileFault(){
        //添加锁文件
        $cordovaFile.createFile(rootPath,'welcomeImg/lock_'+fileName,true).then(function(){
          //开始下载文件
          $cordovaFileTransfer.download(welcomeImg.img,rootPath+'welcomeImg/'+fileName,{},true).then(
            //下载成功
            function(res){
              $cordovaFile.removeFile(rootPath,'welcomeImg/lock_'+fileName).then(); //下载成功后，删除锁文件
              welcomeImg.img = res.nativeURL;
              localStorageService.set(fileName.split('.')[0],welcomeImg);                        //本地图片地址存入localStroge
            },
            //下载失败
            function(err){
              $cordovaFile.removeFile(rootPath,'welcomeImg/lock_'+fileName).then(function(){console.log('下载失败，删除锁文件');});
              $cordovaFile.removeFile(rootPath,'welcomeImg/'+fileName).then(function(){console.log('下载失败，删除错误文件');});
            },
            //下载进程
            function(progress){
              $timeout(function () {
                var downloadProgress = parseInt((progress.loaded / progress.total) * 100);
                downloadProgress % 10 == 0 && console.log(downloadProgress);
              });
            });
        },function(){});
      }
    }

    function img2Base64(localUrl, imgObject) {
      var welome2Img = adaptation(imgObject.img);// 设备屏幕适配
      var img = document.createElement('img');
      img.crossOrigin = "Anonymous";// 开启客户端允许跨域
      img.src = welome2Img;
      img.onload = function () {
        var data = getBase64Image(img);
        imgObject.img = data;
        localStorageService.set(localUrl, imgObject);
        //$scope.welome2Img = data;
      }
    }

    /* 设备屏幕适配 */
    function adaptation(welome2Img) {

      var prefix = welome2Img.substr(0, welome2Img.lastIndexOf('/'));

      var width = window.screen.width;
      var height = window.screen.height;
      var result_56 = Math.abs(0.56 - (width / height));//  ? 720/1280=0.56
      var result_60 = Math.abs(0.60 - (width / height));//  华为pad 601/962=0.62[高度裁剪] 优先使用这个,适当裁剪不至于留白
      var result_66 = Math.abs(0.66 - (width / height));//  华为pad 601/962=0.62[高度留白],如:0.65会适配到0.66有留白风险,暂不考虑
      var result_75 = Math.abs(0.75 - (width / height));//  ipad 1536/2048=0.75
      var result = Math.min.apply(null, [result_56, result_60, result_66, result_75]);

      console.log('window.screen', width, height, width / height);

      if (result_56 == result) {
        console.log('0.56');
        welome2Img = prefix + '/720x1280.jpg';
      } else if (result_60 == result) {
        console.log('0.60');
        welome2Img = prefix + '/720x1184.jpg';
      } else if (result_66 == result) {
        console.log('0.66');
        welome2Img = prefix + '/960x1440.jpg';
      } else if (result_75 == result) {
        console.log('0.75');
        welome2Img = prefix + '/1536x2048.jpg';
      }
      return welome2Img;
    }

    function getBase64Image(img) {
      var canvas = document.createElement("canvas");
      canvas.width = img.width;
      canvas.height = img.height;
      var ctx = canvas.getContext("2d");
      ctx.drawImage(img, 0, 0, img.width, img.height);
      var dataURL = canvas.toDataURL("image/png");
      return dataURL;
      // return dataURL.replace("data:image/png;base64,", "");
    }
  }
})();
