/**
 * Created by Administrator on 2016/1/14.
 */
(function () {
  'use strict';

  angular.module('starter')
    .filter('filter_choose', ShooseFilter)
    .filter('filter_rank_img',RankImg)
    .filter("filter_trustUrl", trustUrl)
    .filter("filter_login_day", loginDay)
    .filter("filter_login_gold", loginGold)
    .filter('filter_big_num',bigNum)
    .filter('filter_exp_color',expColor)
    .filter('filter_share_name',shareName)
    .filter('filter_progress_name',progressName)
    .filter('filter_progress_src',progressSrc)
    .filter('filter_select', SelectFilter)
    .filter('filter_special_video_type', specialVideoType)

  function ShooseFilter() {
    return function (number) {
      return _app.choose[number];
    }
  }

  function SelectFilter() {
    return function (item) {
      return _app.select[item];
    }
  }

  function RankImg(){
    return function(number){
      return _app.rank_img[number];
    }
  }

  function trustUrl($sce) {
    return function (recordingUrl) {
      return $sce.trustAsResourceUrl(recordingUrl);
    };
  }

  function loginDay(){
    return function(number){
      return _app.loginDay[number];
    }
  }

  function loginGold(){
    return function(number){
      return _app.loginGold[number];
    }
  }

  function bigNum(){
    return function(number){
      if(number || number==0){
        var result = number;
        if(number>10000){
          result = (number/10000).toFixed(1) + '万';
        }
        return result;
      }
    };
  }

  function expColor(){
    return function(number){
      return _app.expColor[number];
    }
  }

  function shareName(){
    return function(name){
      switch(name){
        case 'Qzone':name='QQ空间';break;
        case 'wechatTimeline':name='朋友圈';break;
        case 'qq':name='QQ好友';break;
        case 'wechat':name='微信好友';break;
        default:break;
      }
      return name;
    }
  }
  function progressName(){
    return function(progress){
      var result;
        if(progress>0 && progress<20){
          result = _app.chapter_progress_name[0];
        }
        else if(progress>=20 && progress<40){
          result = _app.chapter_progress_name[1];
        }
        else if(progress>=40 && progress<60){
          result = _app.chapter_progress_name[2];
        }
        else if(progress>=60 && progress<80){
          result = _app.chapter_progress_name[3];
        }
        else if(progress>=80 && progress<99){
          result = _app.chapter_progress_name[4];
        }
        else if(progress == 100){
          result = _app.chapter_progress_name[5];
        }
      return result
    }
  }
  function progressSrc(){
    return function(progress){
      var result;
        if(progress>0 && progress<20){
          result = _app.chapter_progress_src[0];
        }
        else if(progress>=20 && progress<40){
          result = _app.chapter_progress_src[1];
        }
        else if(progress>=40 && progress<60){
          result = _app.chapter_progress_src[2];
        }
        else if(progress>=60 && progress<80){
          result = _app.chapter_progress_src[3];
        }
        else if(progress>=80 && progress<99){
          result = _app.chapter_progress_src[4];
        }
        else if(progress == 100){
          result = _app.chapter_progress_src[5];
        }
      return result;
    }
  }

  function specialVideoType(){
    return function(index){
      return _app.specialVideo_type[index-1];
    }
  }
})();
