/**
 * Created by Administrator on 2016/8/17 0017.
 */
;(function() {
  'use strict'

  angular.module('starter').factory('$httpFactory', mainFactory)

  /**
   *
   * @param $http
   * @param HttpUrl
   * @returns {{kingRank: *, friendsHelp: *}}
   */
  function mainFactory(
    $rootScope,
    $http,
    $ionicLoading,
    AutoDivFactory,
    localStorageService,
    $state,
    $cordovaDevice,
    $cordovaAppVersion,
    $cordovaNativeAudio,
    $timeout,
    $cordovaNetwork
  ) {
    /**
     * 服务器地址前缀
     * @type {string}
     */
    // var device = !_app.isWeb && $cordovaDevice.getDevice();
    var domain_name = _config.domain_name

    // 设置默认headers
    $http.defaults.headers.post = {
      'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
      //'Content-Type':'application/json'
    }
    var clientVersion = localStorageService.get('clientVersion') //本地保存当前版本号
    var serverVersion = localStorageService.get('serverVersion') //本地保存服务器版本号
    // if (_app.isWeb) {
    //   $http.defaults.headers.common.client_version = '1.0.0'
    //   $http.defaults.headers.common.server_version = '1.0.0'
    // }
    if (clientVersion && serverVersion) {
      $http.defaults.headers.common.client_version = clientVersion
      $http.defaults.headers.common.server_version = serverVersion
    }

    /**
     * 设置切面
     */
    $http.defaults.transformRequest = appendTransform(
      $http.defaults.transformRequest,
      function(value) {
        return value
      }
    )
    // $http.defaults.transformResponse = appendTransform($http.defaults.transformResponse, function (value) {return value;});

    /**
     * 示例
     * $http.get('/someUrl', config).then(successCallback, errorCallback);
     * $http.post('/someUrl', data, config).then(successCallback, errorCallback);
     */

    var service = {
      setToken: function(token) {
        $http.defaults.headers.common.token = token
      },
      setAppVersion: function(clientVersion, serverVersion) {
        $http.defaults.headers.common.client_version = clientVersion
        $http.defaults.headers.common.server_version = serverVersion
      },
      everyDaySign: function() {
        var url = domain_name + 'event/everyDaySign'
        return send(url, 'POST')
      },
      home: {
        book: function(userId) {
          var url = domain_name + ('user/bag/' + userId + '/13/1/1')
          // return _response($http.get(url));
          return send(url)
        },
        knowPoint: function(userId) {
          var url = domain_name + 'knowPoint'
          return send(url)
        }
      },
      live: {
        getInfo: function(os) {
          var url = domain_name + 'order/product/live?os=' + os
          return send(url)
        },
        getPasswordPay: function(data) {
          var url = domain_name + 'order/product/live/password'
          return send(url, 'POST', $.param(data))
        },
        getPasswordShare: function() {
          var url = domain_name + 'order/product/live/share'
          return send(url)
        }
      },
      user: {
        infoChange: function userInfoChange(data) {
          var url = domain_name + 'user/infoModify'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        redInfo: function() {
          var url = domain_name + 'user/redInfo'
          // //return _response($http.get(url));
          return send(url)
        },
        redInfoRead: function(data) {
          var url = domain_name + 'user/redInfoRead'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        information: function() {
          var url = domain_name + 'user/information'
          return send(url)
        },
        userLearningInfo: function() {
          var url = domain_name + 'user/useInfo'
          return send(url)
        },
        myClass: function() {
          var url = domain_name + 'video/user/fromEntryToMaster'
          return send(url)
        },
        myScholarship: function() {
          var url = domain_name + 'scholarship/info'
          return send(url)
        },
        toCash: function(data) {
          var url = domain_name + 'scholarship/toCash'
          return send(url, 'POST', $.param(data))
        },
        giftInfo: function() {
          var url = domain_name + 'user/giftInfo'
          return send(url)
        },
        giftInfoModify: function(data) {
          var url = domain_name + 'user/giftInfoModify'
          return send(url, 'POST', $.param(data))
        }
      },
      sys: {
        config: function(key) {
          var url = domain_name + 'sys/config/?key=' + key
          // return _response($http.get(url));
          return send(url)
        }
      },
      activity: {
        bindInvite: function(code) {
          var url = domain_name + 'invite/' + code
          // return _response($http.post(url));
          return send(url, 'POST')
        },
        myInviteInfo: function() {
          var url = domain_name + 'invite/info'
          return send(url)
        },
        list: function(pageSize, currentPage, type) {
          var url =
            domain_name +
            'activity/?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage +
            '&activityType=' +
            type
          // return _response($http.get(url));
          return send(url)
        },
        shareGold: function(type) {
          //1qq空间，2微信朋友圈，3微博，4qq，5微信
          var url = domain_name + 'invite/share/' + type
          return send(url, 'POST')
        },
        evaluateGold: function() {
          var url = domain_name + 'gold/marketComment'
          return send(url)
        }
      },
      message: {
        list: function(pageSize, currentPage) {
          var url =
            domain_name +
            'message/list/?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          // return _response($http.get(url));
          return send(url)
        },
        read: function(data) {
          var url = domain_name + 'message/read'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        }
      },
      gold: {
        richList: function(pageSize, currentPage) {
          var url =
            domain_name +
            'gold/richList?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          // return _response($http.get(url));
          return send(url)
        },
        diamondList: function(pageSize, currentPage) {
          var url =
            domain_name +
            'diamond/rank?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        }
      },
      section: {
        getPoints: function(sectionCode) {
          var url = domain_name + 'knowPoint/' + sectionCode
          // return _response($http.get(url));
          return send(url)
        },
        expRead: function(expCode) {
          var url = domain_name + 'knowPoint/expRead/' + expCode
          // return _response($http.post(url));
          return send(url, 'POST')
        },
        order_gold: function(content) {
          var url = domain_name + 'order/gold'
          var data = { content: JSON.stringify(content) } //content =  {"productCode":1}
          return send(url, 'POST', $.param(data))
        },
        order_gold_recharge: function(content) {
          var url = domain_name + 'order/gold/buy'
          var data = { content: JSON.stringify(content) }
          return send(url, 'POST', $.param(data))
        },
        order_wechat: function(content) {
          var url = domain_name + 'order/wechat/create'
          var data = { content: JSON.stringify(content) }
          //content =  {"productCode":1}
          return send(url, 'POST', $.param(data))
        },
        order_alipay: function(content) {
          var url = domain_name + 'order/alipay/create'
          var data = { content: JSON.stringify(content) }
          //content =  {"productCode":1}
          return send(url, 'POST', $.param(data))
        },
        order_qPay: function(content) {
          var url = domain_name + 'order/qpay/create'
          return send(
            url,
            'POST',
            $.param({ content: JSON.stringify(content) })
          )
        },
        order_product: function(level, knowCode) {
          // level [0书1章2节3点]
          var url =
            domain_name + 'order/product/' + level + '?knowCode=' + knowCode
          return send(url)
        },
        order_query: function(content) {
          var url = domain_name + 'order/query'
          var data = { content: JSON.stringify(content) }
          // content = {"orderCode":"1"}
          return send(url, 'POST', $.param(data))
        },
        order_qrcode: function(content) {
          var url = domain_name + 'order/wechatJSAPI'
          var data = { content: JSON.stringify(content) }
          return send(url, 'POST', $.param(data))
        }
      },
      practice: {
        getPractices: function(sectionId) {
          var sum = 5
          var url = domain_name + 'knowPoint/exercise/' + sectionId + '/' + sum
          // return _response($http.get(url));
          return send(url)
        },
        getPracticesAll: function(pageSize, currentPage) {
          var url =
            domain_name +
            'test/question' +
            '?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        },
        exercise: function(content) {
          var url = domain_name + 'knowPoint/exercise'
          var data = { content: JSON.stringify(content) }
          //content =  {"knowCode":1,"list":[{"questionCode":10,"result":"33","isTrue":0},{"questionCode":12,"result":"41","isTrue":1}]}
          return send(url, 'POST', $.param(data))
        },
        myQuestionList: function(pageSize, currentPage) {
          var url =
            domain_name +
            'question/errorRec/?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        },
        myQuestionDel: function(questionId) {
          var url = domain_name + 'question/errorRec/' + questionId
          return send(url, 'POST')
        }
      },
      login: {
        normal: function normal(data) {
          var url = domain_name + 'user/login'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        oneLogin: function oneLogin(data) {
          $http.defaults.headers.common.token = ''
          var url = domain_name + 'user/mobile/oauth'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        getCode: function(data) {
          var url = domain_name + 'user/mobile/codeSend'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        thirdLogin: function(data) {
          var url = domain_name + 'user/thirdLogin'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        oauthLogin: function(data) {
          var url = domain_name + 'user/mobile/oauth'
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        }
      },
      kingRank: function kingRank(userId, pageSize, currentPage) {
        var url =
          domain_name +
          ('acticity/question/kingRank/' +
            userId +
            '/?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage)
        // return _response($http.get(url));
        return send(url)
      },
      friendsHelp: function friendsHelp(userId, pageSize, currentPage) {
        var url =
          domain_name +
          ('acticity/question/friendsHelp/' +
            userId +
            '/?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage)
        // return _response($http.get(url));
        return send(url)
      },
      setting: {
        receiptQuery_1014: function() {
          var url = domain_name + 'user/receiptQuery'
          // return _response($http.get(url));
          return send(url)
        },
        receiptModify_1015: function(name, mobile, address) {
          var url = domain_name + 'user/receiptModify'
          var data = {
            content: JSON.stringify({
              name: name,
              mobile: mobile,
              address: address
            })
          }
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        userSuggest_1803: function(suggest, tags, phone) {
          var url = domain_name + 'sys/userSuggest'
          var data = {
            content: JSON.stringify({
              suggest: suggest,
              tags: tags,
              phone: phone
            })
          }
          // return _response($http.post(url, $.param(data)));
          return send(url, 'POST', $.param(data))
        },
        suggestQuery_1805: function(pageSize, currentPage) {
          var url =
            domain_name +
            'sys/suggestQuery?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          // return _response($http.get(url));
          return send(url)
        }
      },
      wx: {
        createUnityOrder: function createUnityOrder(data, key, cb) {
          var url = 'https://api.mch.weixin.qq.com/pay/unifiedorder'
          data.sign = wx_sign(data, key)
          var xotree = new XML.ObjTree()
          var xml = xotree.writeXML(data)
          // return send(url, "POST", $.param(data));
          $.ajax({
            url: url,
            type: 'POST',
            processData: false,
            data: xml,
            success: cb
          })
        },
        wechatJoin: function wechatJoin(wechatNo, opSys, cb){
          var url = domain_name + 'wechat/join'
            + '?wechatNo=' + wechatNo + '&opSys=' + opSys;
          return send(url, 'POST')
        },
      },
      softwaveRecommend_1804: function() {
        var url = domain_name + 'sys/softwaveRecommend'
        // return _response($http.get(url));
        return send(url)
      },
      versionQuery_1802: function() {
        var url = domain_name + 'sys/versionQuery'
        // //return _response($http.get(url));
        return send(url)
      },
      /* goodsType 物品类型 0 实物 1虚拟头像 2其他虚拟物品 多个逗号隔开*/
      exchangeQuery_1902: function(goodsType) {
        var url =
          domain_name + 'goods/exchangeQuery' + '?goodsType=' + goodsType
        // return _response($http.get(url));
        return send(url)
      },
      headUnlock_1906: function(goodsCode) {
        var url = domain_name + 'goods/headUnlock'
        var data = {
          content: JSON.stringify({
            goodsCode: goodsCode
          })
        }
        return send(url, 'POST', $.param(data))
      },
      /* goodsType 物品类型 0 实物 1虚拟头像 2其他虚拟物品 多个逗号隔开*/
      myGoodsQuery_1907: function(goodsType) {
        var url = domain_name + 'gold/myGoodsQuery' + '?goodsType=' + goodsType
        // return _response($http.get(url));
        return send(url)
      },
      getSysConfig_1801: function(key) {
        var url = domain_name + 'sysConfig' + '?key=' + key
        // //return _response($http.get(url));
        return send(url)
      },
      relogin: function(key) {
        var url = domain_name + 'sysConfig' + '?key=' + key
        // return _response($http.get(url));
        return send(url)
      },
      special: {
        spec: function() {
          var url = domain_name + 'spec'
          return send(url)
        },
        video: function() {
          var url = domain_name + 'spec/0'
          return send(url)
        },
        specRes: function(specResCode) {
          var url = domain_name + 'spec/res/' + specResCode
          return send(url)
        },
        playTotle: function(specCode) {
          var url = domain_name + 'sepc/log/play/' + specCode
          return send(url)
        },
        getPlanProduct: function(type, level) {
          var url = domain_name + 'order/product/' + type + '/' + level
          return send(url)
        }
      },
      main: {
        getMarquee: function() {
          var url = domain_name + 'home/marquee'
          return send(url)
        },
        getWeekVideo: function(pageSize, currentPage) {
          var url =
            domain_name +
            'home/videoEveryWeek?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        },
        getArticleInfo: function(articleCode) {
          var url = domain_name + 'home/article/' + articleCode
          return send(url)
        },
        getVideoInfo: function(videoCode) {
          var url = domain_name + 'home/videoEveryWeek/' + videoCode
          return send(url)
        },
        getComment: function(type, code, pageSize, currentPage) {
          var url =
            domain_name +
            'comment/' +
            type +
            '/' +
            code +
            '?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        },
        uploadComment: function(data) {
          var url = domain_name + 'comment/upload'
          return send(url, 'POST', $.param(data))
        },
        updateZanStatus: function(data) {
          var url = domain_name + 'user/clickLike'
          return send(url, 'POST', $.param(data))
        },
        getVideoProduct: function(specResCode) {
          var url = domain_name + 'product/spec/' + specResCode
          return send(url)
        },
        uploadProgress: function(data) {
          var url = domain_name + 'user/learningProgress'
          return send(url, 'POST', $.param(data))
        },
        checkDate: function() {
          var url = domain_name + 'user/invitedSum'
          return send(url)
        },
        fromEntryToMaster: {
          list: function() {
            var url = domain_name + 'video/fromEntryToMaster'
            return send(url)
          },
          infoList: function(homeCode) {
            var url = domain_name + 'video/fromEntryToMaster/' + homeCode
            return send(url)
          }
        }
      },
      diamond: {
        banner: function() {
          var url = domain_name + 'diamond/banner'
          return send(url)
        },
        mall: function(pageSize, currentPage) {
          var url =
            domain_name +
            'diamond/mall?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        },
        userExchange: function(diamondCode, remark) {
          var url = domain_name + 'diamond/userExchange'
          var data = {
            content: JSON.stringify({
              diamondCode: diamondCode,
              remark: remark
            })
          }
          return send(url, 'POST', $.param(data))
        },
        log: function() {
          var url = domain_name + 'diamond/log'
          return send(url)
        },
        task: function(pageSize, currentPage) {
          var url =
            domain_name +
            'diamond/task?pageSize=' +
            pageSize +
            '&currentPage=' +
            currentPage
          return send(url)
        }
      }
    }
    return service

    /**************************************************************************************************************/

    function send(url, method, data) {
      !method && (method = 'GET')
      var req = {
        method: method,
        url: url,
        data: data,
        timeout: 150000
      }

      method == 'GET' && (req.params = data)

      var _http = $http(req)
      _http.catch(httpCatch)
      _http.finally(httpFinally)

      var sign = ~~(Math.random() * 100) // 标记（随机0~99）
      var start = +new Date()
      console.log('begin:' + start)
      console.log('request:', sign, method, url, data)
      // $ionicLoading.show({
      //   template: '<ion-spinner icon="spiral"></ion-spinner><div>Loading...</div>',
      //   duration: 100000
      // });
      return _http.then(httpBaseThen, httpCatch)

      function httpBaseThen(response) {
        // $ionicLoading.hide();
        response.data &&
          console.log(
            'response:',
            sign,
            (new Date() - start) / 1000 + 's',
            response.data.message,
            response.data.object
          )
        if (response.data == null || response.data == '') {
          console.log(
            'response:',
            sign,
            (new Date() - start) / 1000 + 's',
            response.data + '(无结果响应)'
          )
          return Promise.reject(response) // 阻断返回
          // throw new Error('无结果响应');
        }

        // 控制token失效
        if (
          !!response &&
          (response.data.message == '请先登录' ||
            !!response.data.message.match('重新登录'))
        ) {
          // message:"请先登录"
          //return oauthLogin(response);
          $state.go('app.loginBefore')
          return Promise.reject(response)
        } else {
          // 金币奖励
          // var everyDaySignData = {"curRec": 1, "message": "签到成功", "object": {"addGold": 1,"blance":11}, "result": 0, "totalRec": 1};
          // $rootScope.bookGold && ($rootScope.bookGold.blance = $rootScope.bookGold.blance + 1);
          if (response.data.object && response.data.object.addGold) {
            if (response.data.object.haveSign == 1) {
              return response
            }

            $rootScope.bookGold &&
              ($rootScope.bookGold.blance = response.data.object.blance) // 更新全局金币($rootScope)
            appv.bookGold &&
              (appv.bookGold.blance = response.data.object.blance) // 更新全局金币(appv)

            // 更新x中金币(bookGoldLocal)
            var bookGoldLocal = localStorageService.get('bookGold')
            bookGoldLocal &&
              (bookGoldLocal.blance = response.data.object.blance)
            bookGoldLocal && localStorageService.set('bookGold', bookGoldLocal)

            if (response.data.object.addGold > 0) {
              $rootScope.number = response.data.object.addGold //获得金币数（全局）
              if (response.data.message == '签到成功') {
                window.isEveryDaySign = true
                $rootScope.message = '签到奖励'
              } else {
                $rootScope.message = ''
              }
              AutoDivFactory.open('app/common/gold/gold.html', $rootScope)
              $cordovaNativeAudio.play('click')
            }
          }

          return response
        }
      }

      function oauthLogin(response) {
        // 失效清理
        appv.currentUser = null
        window.isEveryDaySign = false

        var token = appv.token
        var user = localStorageService.get('currentUser')
        if (token && user) {
          return service.login
            .oauthLogin({ loginName: user.loginName, imei: getImei() })
            .then(function(response) {
              if (response.data.result == 0) {
                response.data && service.setToken(response.data.object.token) // 刷新Token
                appv.bookGold = response.data.object.bookGold
                if(res.data.object.user.icon1){
                  res.data.object.user.icon1 = http2https(res.data.object.user.icon1);
                }
                appv.currentUser = response.data.object.user
                appv.token = response.data.object.token
                // $rootScope.refreshLoginInfo();
                localStorageService.set('token', appv.token)
                localStorageService.set('currentUser', appv.currentUser)
                localStorageService.set('bookGold', appv.bookGold)
                $rootScope.userInfo = appv.currentUser
                $rootScope.inviteCode =
                  appv.currentUser && appv.currentUser.inviteCode
                $rootScope.bookGold = appv.bookGold
                $rootScope.isLogin = true
                return $http(req)
              } else {
                if (!window.location.hash.match('welcome')) {
                  $ionicLoading.show({ template: response.data.message })
                }

                window.location.hash.indexOf('welcome') < 0 &&
                  $rootScope.login &&
                  $state.go('app.table.home') // 去登录
                return Promise.reject(response) // 阻断返回
              }
            })
        } else {
          if (!window.location.hash.match('welcome')) {
            $ionicLoading.show({ template: response.data.message })
          }
          window.location.hash.indexOf('welcome') < 0 &&
            $rootScope.login &&
            $state.go('app.loginBefore') // 去登录
          return Promise.reject(response) // 阻断返回
        }
      }

      function http2https(url) {
        if (url && url.startsWith("http") && !url.startsWith("https")) {
          // http 转为 https
          url = url.replace("http", "https");
        }
        return url;
      }

      function httpCatch(error) {
        console.log('response error:', error)

        var message = '网络连接错误,请稍后再试!'

        if (
          !_app.isWeb &&
          typeof $cordovaNetwork != 'undefined' &&
          $cordovaNetwork.isOffline()
        ) {
          message = '请连接网络!'
        }

        $ionicLoading.show({
          template: message,
          noBackdrop: true,
          duration: 2000
        })

        return error
      }

      function httpFinally() {
        // $rootScope.isLoding = false;// 关闭加载圈
        // $rootScope.noLogind = false;
        // $rootScope.$broadcast('scroll.refreshComplete');
      }
    }

    /**
     * 追加切面函数处理
     * @param defaults
     * @param transform
     * @returns {Array.<T>}
     */
    function appendTransform(defaults, transform) {
      // We can't guarantee that the default transformation is an array
      defaults = angular.isArray(defaults) ? defaults : [defaults]

      // Append the new transformation to the defaults
      return defaults.concat(transform)
    }

    function getImei() {
      var imei = ''
      if (_app.isAndroid || _app.isIos) {
        imei = !_app.isWeb && $cordovaDevice.getDevice().uuid
      }
      return imei
    }
  }
})()
/**
 * $http 使用详解请见
 * http://devdocs.io/angularjs~1.5/api/ng/service/$http
 *
 * $q(promise) angular承诺的使用
 * http://devdocs.io/angularjs~1.5/api/ng/service/%24q
 **/
