/**
 * Created by Administrator on 2016/8/22 0022.
 */
(function () {
  'use strict';


  angular.module('starter')
    .factory('AppFactory', MainFactory);

  function MainFactory($rootScope, $state, $ionicLoading, $ionicPlatform, $location, $timeout, RouteData, localStorageService, $ionicHistory) {

    function stateChange() {
      $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
        //路由锁（防止多次点击）
        // if (!_app.routeOpen) {
        //   event && event.preventDefault();// 阻止模板解析
        //   return;
        // }

        //锁住路由
        _app.routeOpen = false;
        //1秒后解开路由锁
        $timeout(function () {
          _app.routeOpen = true;
        }, 500);

        //路由处理
        if (fromState.name == "") {
          console.timeEnd('App first state');
          console.log((Date.now() - times) / 1000 + 's', '@first state ★') , times = Date.now();
        }

        if (toState.name == 'app.table.home') {
          console.time('1.@AppCtrl');
          console.time('[1+2+3]App page load');
        }

        if (toState.url == '/home') {
          console.time('Home state');
          console.time('Home page load');
        }

        //当路由进到有视频播放器的页面时，激活后台运行监听器，当播放视频时切换到后台，视频暂停
        if (('/special_vedeo,/section').match(toState.url)) {
          document.addEventListener('pause', function pauseVideo() {
            $('video').length > 0 && $('video')[0].pause();
            // document.removeEventListener('pause',pauseVideo);     //取消监听器
          }, false)
        }
        if (('/special_vedeo,/section').match(fromState.url)) {
          $('video').length > 0 && $('video')[0].pause() && document.removeEventListener('pause', pauseVideo);     //取消监听器
        }


        /** 需要登录的路由页面 **/
        var routes = ['/learning', '/rich', '/userInfo', '/feedback', '/article', '/earnGold'];
        if (!appv.currentUser && routes.indexOf(toState.url) > -1) {
          //$rootScope.login && $rootScope.login();// 去登录
          $ionicLoading.show({template:"请先登录"});
          $state.go('app.loginBefore');
          event && event.preventDefault();// 阻止模板解析
        }
      });

      $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);

        if (toState.name.match('app.table')) {    //每次进入table级页面，设为主路由，次操作使table页面可以滑动打开侧边栏
          $ionicHistory.nextViewOptions({historyRoot: true});
        }

        //_app.routeOpen = true;    //打开路由锁

        // IOS暂不启用umeng的页面统计,怀疑有造成闪退的风险
        if (!_app.isIos && typeof umengService === 'object') {
          if (toState.url == '/home') {
            if (!RouteData[toState.url.slice(1)]) {
              RouteData[toState.url.slice(1)] = {};
            }

            if (!RouteData[toState.url.slice(1)].pageName_umeng) {
              // 打开后,切换年级情况忽略统计.(性能考虑)
              var openBook_local = localStorageService.get('openBook');
              openBook_local && (RouteData[toState.url.slice(1)].pageName_umeng = openBook_local.name);
            }
          }

          // 异步执行友盟统计,有效减少闪退现象
          setTimeout(function () {
            umengService.end({pageName: fromState.url + routePagename(fromState.url)});
            umengService.start({pageName: toState.url + routePagename(toState.url)});
          }, 200)
        }

        if (('/home,/special,/main,/selfCenter').match(toState.url)) {
          $('.bar.bar-stable').css('background-color', '#279cea');
          !_app.isWeb && StatusBar.backgroundColorByHexString("#279cea");

          !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏

          //var routes = ['/learning', '/message', '/rich', '/activity', '/recommend_list', '/feedback', '/about', '/userInfo', '/earnGold', '/evaluate', '/mall', '/recharge'];
          //for (var i = 0; i < routes.length; i++) {
          //  if (fromState && fromState.url && fromState.url.match(routes[i])) {
          //    document.querySelector('.ion-navicon').click();
          //    break;
          //  }
          //}
        }

      })

      function routePagename(route) {
        if (RouteData[route.slice(1)] && RouteData[route.slice(1)].pageName_umeng) {
          return '_' + RouteData[route.slice(1)].pageName_umeng;
        } else {
          return "";
        }
      }
    }

    function app_backButtonAction() {
      //主页面显示退出提示框
      $ionicPlatform.registerBackButtonAction(function (e) {

        e.preventDefault();

        function showConfirm() {
          var confirmPopup = $ionicPopup.confirm({
            title: '<strong>退出应用?</strong>',
            template: '你确定要退出应用吗?',
            okText: '退出',
            cancelText: '取消'
          });

          confirmPopup.then(function (res) {
            if (res) {
              ionic.Platform.exitApp();
            } else {
              // Don't close
            }
          });
        }

        // Is there a page to go back to?
        if ($location.path() == '/home') {
          showConfirm();
        }
        else if (document.querySelector('.popup_div')) {// popup弹窗,禁止返回(手动关闭,避免强制更新被跳过)
          // 风险:隐藏的class(.popup_div)可能会造成全局返回键失效
          alert('app.factory.js 文件代码导致返回键失效');
          return false;
        }
        else if ($rootScope.$viewHistory.backView) {
          console.log('currentView:', $rootScope.$viewHistory.currentView);
          // Go back in history
          $rootScope.$viewHistory.backView.go();
        } else {
          // This is the last page: Show confirmation popup
          showConfirm();
        }

        return false;
      }, 101);
    }

    function img2Base64(localUrl, welome2Img) {
      var img = document.createElement('img');
      img.crossOrigin = "Anonymous";// 开启客户端允许跨域
      img.src = welome2Img;
      img.onload = function () {
        var data = getBase64Image(img);
        window.localStorage.setItem(localUrl, data);
      }
    }

    function getBase64Image(img) {
      var canvas = document.createElement("canvas");
      canvas.width = img.width;
      canvas.height = img.height;
      var ctx = canvas.getContext("2d");
      ctx.drawImage(img, 0, 0, img.width, img.height);
      var dataURL = canvas.toDataURL("image/png");
      return dataURL;
      // return dataURL.replace("data:image/png;base64,", "");
    }

    var service = {
      stateChange: stateChange,
      // app_backButtonAction: app_backButtonAction,
      img2Base64: img2Base64,
    }
    return service;
  }
})();
