// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter')
  .run(RunFactory);

function RunFactory($ionicPlatform, AppFactory, ShareFactory, AutoDivFactory, $location, $rootScope, $cordovaToast,
                    $ionicHistory, $httpFactory, localStorageService, $cordovaAppVersion, $cordovaNativeAudio) {
  console.timeEnd('@App.run');
  console.time('App.run');

  AppFactory.stateChange();// 路由变化控制
  initApp();                //初始化本地设置

  console.time('$ionicPlatform.ready');
  $ionicPlatform.ready(function () {
    console.timeEnd('$ionicPlatform.ready');
    console.log('splash.$ionicPlatform.ready', navigator.splashscreen);
    navigator.splashscreen && navigator.splashscreen.hide();// 加载完毕后关闭启动屏幕

    initVersionInfo();      //初始化http请求头版本号
    listenBackButton();     // app系统返回键控制
    // AppFactory.app_backButtonAction();// app系统返回键控制
    checkIos_isPayChoose();// 初始化ios审核开关
    ShareFactory.initShare();// 初始化第三方分享(需插件初始化完成后)
    AutoDivFactory.init();// 初始化AutoDiv
    !_app.isWeb && $cordovaNativeAudio.preloadSimple('click', 'music/gold.mp3', 1, 1);     //初始化金币音效


    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {

      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    !_app.isWeb && window.screen.orientation.lock("portrait");
    !_app.isWeb && umengService.init({"args": "init"});// 初始化友盟
  });
  console.timeEnd('App.run');
  console.time('App first state');

  //物理返回按钮控制&双击退出应用
  function listenBackButton() {
    $ionicPlatform.registerBackButtonAction(function (e) {
      //判断处于哪个页面时双击退出
      if ($location.path() == '/welcome' || $location.path() == '/welcomeAgain' ||  $location.path().match('/app/table') || $location.path() == '/app/loginBefore') {
        if ($rootScope.backButtonPressedOnceToExit) {
          ionic.Platform.exitApp();
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $cordovaToast.showShortBottom('再按一次退出系统');
          setTimeout(function () {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
      } else if ($ionicHistory.viewHistory().backView) {
        $ionicHistory.goBack();
      }
      else {
        $rootScope.backButtonPressedOnceToExit = true;
        $cordovaToast.showShortBottom('再按一次退出系统');
        setTimeout(function () {
          $rootScope.backButtonPressedOnceToExit = false;
        }, 2000);
      }
      e.preventDefault();
      return false;
    }, 101);
  }

  //初始化localStorage数据
  function initApp() {
    if (localStorageService.get('token')) {
      appv.token = localStorageService.get('token');
      $httpFactory.setToken(localStorageService.get('token'));

      if (localStorageService.get('currentUser')) {
        appv.currentUser = localStorageService.get('currentUser');
      }
      if (localStorageService.get('userIcon')) {
        var icon = localStorageService.get('userIcon');
        appv.currentUser.icon1 = icon;
      }
      if (localStorageService.get('bookGold')) {
        appv.bookGold = localStorageService.get('bookGold');
      }
      appv.initFinish = true;


    }

    $rootScope.isWeb = _app.isWeb;
    $rootScope.isAndroid = _app.isAndroid;
    $rootScope.isIos = _app.isIos;
  }
  //初始化版本号
  function initVersionInfo() {
    !_app.isWeb && $httpFactory.versionQuery_1802().then(function (res) {
      var serverVersion = res.data.object.lastVersion.version;
      $cordovaAppVersion.getVersionNumber().then(function (version) {
        var clientVersion = version;
        $httpFactory.setAppVersion(clientVersion, serverVersion);
        localStorageService.set('clientVersion', clientVersion); //本地保存当前版本号
        localStorageService.set('serverVersion', serverVersion); //本地保存服务器版本号
      });
    });
  }

  /**
   * 初始化ios审核开关
   */
  function checkIos_isPayChoose() {
    //web端测试专用
    //$rootScope.ios_isPayChoose = false;
    //$rootScope.isIos = false;
    //return;

    // 同关于中版本号
    if (_app.isIos) {
      $rootScope.ios_isPayChoose = false;
    } else {
      $rootScope.ios_isPayChoose = true;
    }
    // _app.isWeb && ($rootScope.ios_open=true);
    $rootScope.inOpen = true;           //直接进入开关,默认显示
    _app.isAndroid && ($rootScope.inOpen = false);// 直接进入开关

    !_app.isWeb && $cordovaAppVersion.getVersionNumber().then(function (version) {
      $httpFactory.getSysConfig_1801('ios_isPayChoose[' + version + ']').then(function (res) {
        if (res.data && res.data.object) {
          $rootScope.ios_isPayChoose = res.data.object.list[0].value.match('true')?true:false;// 是否启用支付选择
          // $rootScope.ios_open = _app.isAndroid || $rootScope.ios_isPayChoose;      //统一审核开关

          $rootScope.gold_recharge_open = _app.isIos && !$rootScope.ios_isPayChoose;

          _app.isIos && $rootScope.ios_isPayChoose && ($rootScope.inOpen = false);
          if (!_app.isIos) {
            $rootScope.ios_isPayChoose = true;
          }
          localStorageService.set('ios_isPayChoose', res.data.object.list[0].value);
        }
      });
    });
  }
}

